/************************************************/
/*    simple.c: contour a function              */
/*              and refine the mesh             */
/************************************************/
#include "dime.h"

struct user_node {
	double f;				/* function value */
};

struct user_bdy {
    double unused;
};

struct user_elmt {
	double refine_crit;		/* refinement criterion */
};

#ifdef IBM
main(argc, argv)int argc; char **argv; {sillysilly(argc, argv);}
dime_user_main(user_menu, argc, argv)
#else
user_main(user_menu, argc, argv)
#endif

MNUPTR user_menu;
int argc;
char **argv;
{
    int contour(), adaptrefine();

	DIME_PREAMBLE;

    menu_add_function(user_menu, "Contour", contour);
    menu_add_function(user_menu, "Adaptrefine", adaptrefine);
}

contour()
{
	NODEPTR node;
	double func(), contour_func();

	FORALLNODES(node)
		node->user->f = func(node->x, node->y);
	NEXTNODE(node)
	color(2);
	contor(contour_func, 16, 1, 0.0, 1.0);
}

double contour_func(node)
NODEPTR node;
{
	return(node->user->f);
}

double func(x, y)
double x, y;
{
/* 
The function to be contoured is fine-scale near the origin
and coarser elsewhere
*/
	double rr = sqrt(x*x + y*y);
	return(sin(10.0/(rr + 0.2)));
}

adaptrefine()
{
	ELMTPTR elmt;
	NODEPTR node;
	double r, ecmx, ecmy, crit_func(), area();
	int i;

	FORALLELMTS(elmt)
		ecmx = ecmy = 0;
		for(i=0; i<3; i++){
			node = elmt->neigh[i];
			ecmx += node->x;
			ecmy += node->y;
		}
		ecmx /= 3;
		ecmy /= 3;
/* 
(ecmx, ecmy) is position od center of the element
*/
		r = sqrt(ecmx*ecmx + ecmy*ecmy);
/*
refinement criterion is ratio of element size to its distance from
the origin
*/
		elmt->user->refine_crit = sqrt(area(elmt))/r;
	NEXTELMT(elmt)

	refine_fraction(crit_func, 0.25);
}

double crit_func(elmt)
ELMTPTR elmt;
/* for the refiner */
{
	return(elmt->user->refine_crit);
}
