#include <stdio.h>
#include <math.h>

#define POINT		1
#define CURVE		2
#define ALIAS		3
#define END			4

#define LINE		1
#define ARC			2
#define ARCN		3
#define CURVETO		4

char curvename[20], firstname[20], lastname[20];
char token[20], token1[20], token2[20], token3[20];
FILE *fp;

readbdy(passfp)
FILE *passfp;
{
	double s[10];
	int keyword, op, nstack = 0;
	fp = passfp;

	while(get_token()){

	if(!(keyword = iskeyword())) {crash(); return 0;}
	switch(keyword){
		case END:
			return 1;
		case POINT:
			if(!get_token() || !isname()) {crash(); return 0;}
			strcpy(firstname, token);

			if(!get_token() || !isnumber()) {crash(); return 0;}
			sscanf(token, "%lf", s);

			if(!get_token() || !isnumber()) {crash(); return 0;}
			sscanf(token, "%lf", s+1);

			make_point(firstname, s[0], s[1]);
			break;

		case ALIAS:
			if(!get_token() || !isname()) {crash(); return 0;}
			strcpy(firstname, token);

			if(!get_token() || !isname()) {crash(); return 0;}
			strcpy(lastname, token);

			make_alias(firstname, lastname);
			break;

		case CURVE:
			if(!get_token() || !isname()) {crash(); return 0;}
			strcpy(curvename, token);

			if(!get_token() || !isname()) {crash(); return 0;}
			strcpy(firstname, token);

			make_moveto(firstname);

			while(1){
				if(!get_token()) {crash(); return 0;}
				if(op = isop()){
					switch(op){
					case LINE:
						if(nstack == 2){
							make_line(s[0], s[1]); 
							nstack = 0;
							break;
						} else {crash(); return 0;}
					case ARC:
						if(nstack == 5){
							make_arc(s[0], s[1], s[2], s[3], s[4]);
							nstack = 0;
							break;
						} else {crash(); return 0;}
					case ARCN:
						if(nstack == 5){
							make_arcn(s[0], s[1], s[2], s[3], s[4]);
							nstack = 0;
							break;
						} else {crash(); return 0;}
					case CURVETO:
						if(nstack == 6){
							make_curveto(
								s[0], s[1], s[2], s[3], s[4], s[5]);
							nstack = 0;
							break;
						} else {crash(); return 0;}
					default:
						crash(); return 0;
					}
			} else if(isnumber()){
				sscanf(token, "%lf", s + nstack++);
				continue;
			} else break;
		}
		if(!isname()){crash(); return 0;}
		strcpy(lastname, token);
		make_curve(curvename, firstname, lastname);
	}
	}
}

get_token()
{
	char *ptr = token;
	int c, started = 0;

	strcpy(token3, token2);
	strcpy(token2, token1);
	strcpy(token1, token);

	while((c = getc(fp)) != EOF){
		if(c == ' ' || c == '\t' || c == '\n'){
			if(started){
				*ptr++ = '\0';
				return 1;
			}
		} else {
			*ptr++ = c;
			started = 1;
		}
	}
	if(started){
		*ptr++ = '\0';
		return 1;
	}
	return 0;
}


iskeyword()
{
	if(!strcmp(token, "Point")) return POINT;
	else
	if(!strcmp(token, "Curve")) return CURVE;
	else
	if(!strcmp(token, "Alias")) return ALIAS;
	else
	if(!strcmp(token, "End")) return END;
	else
	return 0;
}

isop()
{
	if(!strcmp(token, "Lineto")) return LINE;
	else
	if(!strcmp(token, "Arc")) return ARC;
	else
	if(!strcmp(token, "Arcn")) return ARCN;
	else
	if(!strcmp(token, "Curveto")) return CURVETO;
	else
	return 0;
}

isnumber()
{
	double dummy;
	return(sscanf(token, "%lf", &dummy));
}

isname()
{
	char *ptr = token;
	while(*ptr >= '0' && *ptr <= 'z')
		ptr++;
	return (*ptr == '\0');
}

crash()
{
	printf("Syntax error in reading boundary near...\n");
	printf("#%s#%s#%s#%s#\n", token3, token2, token1, token);
}

#ifdef TEST
main(){readbdy(stdin);}
make_point(s, x, y) char *s; double x, y;
{printf("make_point %s %f %f\n", s, x, y);}
make_alias(s, t) char *s, *t;
{printf("make_alias %s %s\n", s, t);}
make_line(x, y) double x, y;
{printf("make_line %f %f\n", x, y);}
make_arc(x, y, r, t0, t1) double x, y, r, t0, t1;
{printf("make_arc %f %f %f %f %f\n", x, y, r, t0, t1);}
make_arcn(x, y, r, t0, t1) double x, y, r, t0, t1;
{printf("make_arcn %f %f %f %f %f\n", x, y, r, t0, t1);}
make_curve(s, t, u) char *s, *t, *u;
{printf("make_curve %s %s %s\n", s, t, u);}
make_curveto(a, b, c, d, e, f) double a, b, c, d, e, f;
{printf("make_curveto %f %f %f %f %f %f\n", a, b, c, d, e, f);}
#endif
