#include "curvetool.h"

adjust_point(point, x, y)
struct point *point;
double x, y;
{
	struct endseg *endseg;

	color(BACKGD);
	draw_point(point);

	point->x = x;
	point->y = y;
	if(endseg = point->loop){
		do {
			adjust_endseg(endseg, x, y);
		} while((endseg = endseg->loop) != point->loop);
	}
	color(FOREGD);
	draw_point(point);
}

adjust_endseg(endseg, x, y)
struct endseg *endseg;
double x, y;
{
	double dx, dy;
	color(BACKGD);
	draw_endseg(endseg);
	draw_segment(endseg->segment);

	dx = endseg->kx - endseg->x;
	dy = endseg->ky - endseg->y;
	endseg->x = x;
	endseg->y = y;
	endseg->kx = x + dx;
	endseg->ky = y + dy;
	setup_segment(endseg->segment);

	color(FOREGD);
	draw_endseg(endseg);
	draw_segment(endseg->segment);
}

adjust_knot(endseg, x, y)
struct endseg *endseg;
double x, y;
{
	struct endseg *otherendseg;
	double dx, dy, d, dother, sqdist();

	color(BACKGD);
	draw_knot(endseg);
	draw_segment(endseg->segment);

	endseg->kx = x;
	endseg->ky = y;
	setup_segment(endseg->segment);

	color(FOREGD);
	draw_knot(endseg);
	draw_segment(endseg->segment);

	if(!endseg->interior)
		return 1;

	otherendseg = endseg->loop;

	color(BACKGD);
	draw_knot(otherendseg);
	draw_segment(otherendseg->segment);

	dx = endseg->x - endseg->kx;
	dy = endseg->y - endseg->ky;
	d = sqrt(sqdist(
		endseg->x, endseg->y,
		endseg->kx, endseg->ky
	));
	dother = sqrt(sqdist(
		otherendseg->x, otherendseg->y,
		otherendseg->kx, otherendseg->ky
	));
	otherendseg->kx = otherendseg->x + dx*dother/d;
	otherendseg->ky = otherendseg->y + dy*dother/d;
	setup_segment(otherendseg->segment);

	color(FOREGD);
	draw_knot(otherendseg);
	draw_segment(otherendseg->segment);
}
