#include "curvetool.h"

void
setup_segment(seg)
struct segment *seg;
{
	int i;
	double t, xc, yc;
	double ax, bx, cx, dx, ay, by, cy, dy;
	double x0 = seg->e1->x, y0 = seg->e1->y;
	double x1 = seg->e1->kx, y1 = seg->e1->ky;
	double x2 = seg->e2->kx, y2 = seg->e2->ky;
	double x3 = seg->e2->x, y3 = seg->e2->y;

    dx = x0;				dy = y0;
    cx = 3*(x1-dx);			cy = 3*(y1-dy);
    bx = 3*(x2-x1)-cx;		by = 3*(y2-y1)-cy;
    ax = x3-dx-cx-bx;		ay = y3-dy-cy-by;

	seg->ax = ax;			seg->ay = ay;
	seg->bx = bx;			seg->by = by;
	seg->cx = cx;			seg->cy = cy;
	seg->dx = dx;			seg->dy = dy;

	seg->e1->kx = x1;		seg->e1->ky = y1;
	seg->e2->kx = x2;		seg->e2->ky = y2;

	seg->xmin = seg->ymin = LARGE;
	seg->xmax = seg->ymax = -LARGE;

    for(i=0; i<=nres; i++){
        t = (double)i/nres;
        xc = seg->dx + t*(seg->cx + t*(seg->bx + t*seg->ax));
        yc = seg->dy + t*(seg->cy + t*(seg->by + t*seg->ay));
		if(xc < seg->xmin) seg->xmin = xc;
		if(xc > seg->xmax) seg->xmax = xc;
		if(yc < seg->ymin) seg->ymin = yc;
		if(yc > seg->ymax) seg->ymax = yc;
    }
}

double 
d_to_segment(seg, x, y)
struct segment *seg;
double x, y;
{
    int i;
    double sqdist(), dmin = LARGE, t, d, xc, yc, tmin;
 
    for(i=0; i<=nres; i++){
        t = (double)i/nres;
        xc = seg->dx + t*(seg->cx + t*(seg->bx + t*seg->ax));
        yc = seg->dy + t*(seg->cy + t*(seg->by + t*seg->ay));
        d = sqdist(xc, yc, x, y);
        if(d < dmin)
			dmin = d;
    }
    return(dmin);
}

straighten_segment(seg)
struct segment *seg;
{
	seg->e1->kx = (2*seg->e1->x + seg->e2->x)/3;
	seg->e1->ky = (2*seg->e1->y + seg->e2->y)/3;
	seg->e2->kx = (2*seg->e2->x + seg->e1->x)/3;
	seg->e2->ky = (2*seg->e2->y + seg->e1->y)/3;
	setup_segment(seg);
}

double
sqdist(x1, y1, x2, y2)
double x1, y1, x2, y2;
{
	double dx = x1 - x2;
	double dy = y1 - y2;
	return(dx*dx + dy*dy);
}

get_middle(seg, x, y)
struct segment *seg;
double *x, *y;
{
	double t = 0.5;
	*x = seg->dx + t*(seg->cx + t*(seg->bx + t*seg->ax));
	*y = seg->dy + t*(seg->cy + t*(seg->by + t*seg->ay));
}
