#include "curvetool.h"

struct segment *
pick_segment(x, y)
double x, y;
{
	struct segment *segment, *segmin = NULL;
	double d_to_segment();
	double d, dmin = LARGE;

	FORALLSEGMENTS(segment)
		d = d_to_segment(segment, x, y);
		if(d < dmin){
			dmin = d;
			segmin = segment;
		}
	NEXTSEGMENT(segment)
	return(segmin);
}

struct point *
pick_point(x, y)
double x, y;
{
	struct point *point, *pointmin = NULL;
	double d, dmin = LARGE;
	double sqdist();

	FORALLPOINTS(point)
		d = sqdist(x, y, point->x, point->y);
		if(d < dmin){
			dmin = d;
			pointmin = point;
		}
	NEXTPOINT(point)
	return(pointmin);
}

char *
pick_pointish(type, x, y)
int *type;
double x, y;
{
	struct point *pointmin, *pick_point();
	struct endseg *endseg, *endsegmin = NULL;
	double d, dmin, sqdist();

	if(pointmin = pick_point(x, y)){
		dmin = sqdist(x, y, pointmin->x, pointmin->y) - SMALL;
		*type = POINT;
	} else
		*type = NOTHING;

	FORALLENDSEGS(endseg)
		d = sqdist(x, y, endseg->x, endseg->y);
		if(d < dmin){
			*type = ENDSEG;
			dmin = d;
			endsegmin = endseg;
		}
		d = sqdist(x, y, endseg->kx, endseg->ky);
		if(d < dmin){
			*type = KNOT;
			dmin = d;
			endsegmin = endseg;
		}
	NEXTENDSEG(endseg)

	color(RED);
	switch(*type){
		case POINT:
			draw_point(pointmin);
			return((char *)pointmin);
		case ENDSEG:
			draw_endseg(endsegmin);
			return((char *)endsegmin);
		case KNOT:
			draw_knot(endsegmin);
			return((char *)endsegmin);
		default:
			printf("Nothing Found\n");
			return(NULL);
	}
}
