#include <stdio.h>
#define WHITE		8
#define BLACK		59
#define RAINSTART	60
#define RAINEND		127
extern FILE *ps_file;
extern int plotting;
extern int graphics;

int edgesave;
int linecolor = 1;
	static float r[8] = {1.,0.,1.,0.,0.,0.,1.,1.};
	static float g[8] = {1.,0.,0.,1.,0.,1.,0.,1.};
	static float b[8] = {1.,0.,0.,0.,1.,1.,1.,0.};

Erase()
{
	if(graphics)
		erase();
}

Dotext(s, x, y, angle, hj, vj)
char *s;
double x, y, angle;
int hj, vj;
{
	if(graphics)
		dotext(s, x, y, 0.0, hj, vj);
	if(plotting)
		fprintf(ps_file, "(%s) %3.3f %3.3f %d %d text\n",
			s, x, y, hj, vj);
}

Move(x, y)
double x, y;
{
	if(graphics)
		move(x, y);
	if(plotting){
		fprintf(ps_file, "%3.3f %3.3f m\n", x, y);
	}
}

Cont(x, y)
double x, y;
{
	if(graphics)
		cont(x, y);
	if(plotting){
		fprintf(ps_file, "%3.3f %3.3f c\n", x, y);
	}
}

Color(shade)
int shade;
{
	if(graphics)
		color(shade);
	if(plotting){
		shade %= 8;
		linecolor = shade;
		fprintf(ps_file, "%4.0f %4.0f %4.0f lrgb\n",
			r[shade], g[shade], b[shade]);
	}
}

Marker(i, x, y, s)
int i;
double x, y, s;
{
	if(graphics)
		marker(i, x, y, s);
}

Initpanel(shade, edge)
int shade, edge;
{
	double grey, hue;
	if(graphics)
		initpanel(shade, edge);
	if(plotting){
		edgesave = edge;
		if(shade <= RAINEND && shade >= RAINSTART){
			hue = (double)(shade - RAINSTART)/(RAINEND - RAINSTART);
			fprintf(ps_file, "%4.3f ihsb\n", hue);
		}
		else if(shade <= BLACK && shade >= WHITE){
			grey = (double)(shade - WHITE)/(BLACK - WHITE);
			fprintf(ps_file, "%4.3f igry\n", grey);
		}
		else {
			shade %= 8;
			fprintf(ps_file, "%4.1f %4.1f %4.1f i\n",
				r[shade], g[shade], b[shade]);
		}
	}
}

Panelpoint(x, y)
double x, y;
{
	if(graphics)
		panelpoint(x, y);
	if(plotting)
		fprintf(ps_file, "%3.3f %3.3f p\n", x, y);
}

Endpanel()
{
	if(graphics)
		endpanel();
	if(plotting){
		if(edgesave)
			fprintf(ps_file, "E\n");
		else
			fprintf(ps_file, "e\n");
		Color(linecolor);
	}
}

Box(x0, y0, x1, y1, shade, edge)
double x0, y0, x1, y1;
int shade, edge;
{
	Initpanel(shade, edge);
	Panelpoint(x0, y0);
	Panelpoint(x1, y0);
	Panelpoint(x1, y1);
	Panelpoint(x0, y1);
	Endpanel();
}

Linemod(s)
int s;
{
	if(graphics)
		linemod(s);
	if(plotting)
		fprintf(ps_file, "%2d l\n", s);
}

Usendplot()
{
	if(graphics)
		usendplot();
	if(plotting){
		fflush(ps_file);
	}
}

Sendplot()
{
	if(graphics)
		sendplot();
	if(plotting){
		fflush(ps_file);
	}
}

Openpl(buf, fp)
int buf;
FILE *fp;
{
	if(graphics)
		openpl(buf, fp);
}

Setclip(x0, y0, x1, y1)
double x0, y0, x1, y1;
{
	if(graphics)
		setclip(x0, y0, x1, y1);
}

Space(x0, y0, x1, y1)
double x0, y0, x1, y1;
{
	if(graphics)
		space(x0, y0, x1, y1);
}

Ortho_space(x0, y0, x1, y1, i)
double x0, y0, x1, y1;
int i;
{
	double xp0, yp0, xp1, yp1;
	double portasp, size, surfasp, xtemp, ytemp;
	if(!graphics)
		return 1;
	ortho_space(x0, y0, x1, y1, i);
	return 1;
/*
	portasp = surfasp = 1.35;

	if(portasp*(y1-y0) > (x1-x0)){
		size = (y1-y0)*portasp;
		xp0 = 0.5*(x0+x1) - 0.5*size;
		xp1 = 0.5*(x0+x1) + 0.5*size;
		yp0 = y0;
		yp1 = y1;
	} else {
		size = (x1-x0)/portasp;
		xp0 = x0;
		xp1 = x1;
		yp0 = 0.5*(y0+y1) - 0.5*size;
		yp1 = 0.5*(y0+y1) + 0.5*size;
	}
	space(xp0, yp0, xp1, yp1);
*/
}

Vport(x0, y0, x1, y1)
double x0, y0, x1, y1;
{
	return(graphics ? vport(x0, y0, x1, y1) : 0);
}

Setvport(port)
int port;
{
	if(graphics)
		setvport(port);
}

appl_redraw() {};
 
#ifdef SEQ
 _ex_info(t) char *t; {return 0;}
 _ex_error(t) char *t; {return 0;}
 _ex_fatal(t) char *t; {return 0;}
#endif
