#include "meshtool.h"

ELMTPTR the_elmts;
NODEPTR the_nodes;
int nnodes = 0;
int nelmts = 0;

NODEPTR 
node_alloc()
{
    NODEPTR this;

    this = (NODEPTR)malloc(sizeof(_NODE));
    if(this == (NODEPTR)NULL)
        abort(100);                    /* malloc failed for node */

	this->clock = this->antik = NULL;

    if(the_nodes == (NODEPTR)NULL)
        the_nodes = this->last = this->next = this;
    else {
        this->next = the_nodes;
        this->last = the_nodes->last;
        the_nodes->last->next = this;
        the_nodes->last = this;
    }
	++nnodes;
    return(this);
}

ELMTPTR 
elmt_alloc()
{
    ELMTPTR this;
    int ineigh;

    this = (ELMTPTR)malloc(sizeof(_ELMT));
    if(this == (ELMTPTR)NULL)
        abort(101);                    /* malloc failed for elmt */

    for(ineigh=0; ineigh<DIM1; ineigh++){
        this->eneigh[ineigh] = (ELMTPTR)NULL;
        this->nneigh[ineigh] = (NODEPTR)NULL;
    }

    if(the_elmts == (ELMTPTR)NULL)
        the_elmts = this->last = this->next = this;
    else {
        this->next = the_elmts;
        this->last = the_elmts->last;
        the_elmts->last->next = this;
        the_elmts->last = this;
    }
    this->influence = 0;
    this->instat = INTERIOR;
	this->show = 0;
	++nelmts;
    return(this);
}

freemesh()
{
    NODEPTR node;
    ELMTPTR elmt;
    if((node = the_nodes) != (NODEPTR)NULL){
        node = node->next;
        do {
            freenode(node);
        } while((node = node->next) != the_nodes);
        freenode(node);
    }
    if((elmt = the_elmts) != (ELMTPTR)NULL){
        elmt = elmt->next;
        do {
            freeelmt(elmt);
        } while((elmt = elmt->next) != the_elmts);
        freeelmt(elmt);
    }
    the_nodes = (NODEPTR)NULL;
    the_elmts = (ELMTPTR)NULL;
}

freeelmt(elmt)
ELMTPTR elmt;
{
    if(elmt == the_elmts){
        the_elmts = elmt->next;
        if(the_elmts->next == the_elmts)
            the_elmts = (ELMTPTR)NULL;
    }
    elmt->next->last = elmt->last;
    elmt->last->next = elmt->next;
	--nelmts;
    free(elmt);
}

freenode(node)
NODEPTR node;
{
    if(node == the_nodes){
        the_nodes = node->next;
        if(the_nodes->next == the_nodes)
            the_nodes = (NODEPTR)NULL;
    }
    node->next->last = node->last;
    node->last->next = node->next;
	--nnodes;
    free(node);
}
