#include "meshtool.h"

void 
make_crcm_data(elmt)
ELMTPTR elmt;
{
    double rvert[DIM][DIM], r[DIM][DIM];
    double b[DIM], alpha[DIM], det;
    double dot(), cofactor(), determinant(), inradius();
    int i, ineigh, jneigh, ir, ic;

    get_cofactors(elmt);
    
    for(ineigh=0; ineigh<DIM; ineigh++){
        for(i=0; i<DIM; i++){
            rvert[ineigh][i] = 
                elmt->nneigh[0]->r[i] - elmt->nneigh[ineigh+1]->r[i];
        }
    }

    elmt->determinant = dot(elmt->cofactor[0], rvert[1]);
	elmt->inradius = inradius(elmt);
	elmt->influence = 0;

    for(ineigh=0; ineigh<DIM; ineigh++){
        for(jneigh=ineigh; jneigh<DIM; jneigh++){
            r[ineigh][jneigh] = r[jneigh][ineigh] = 
                dot(rvert[ineigh], rvert[jneigh]);
        }
    }

    for(ineigh=0; ineigh<DIM; ineigh++){
        b[ineigh] = 0.5*r[ineigh][ineigh];
    }

    det = determinant(r, DIM);
    for(ir=0; ir<DIM; ir++){
        alpha[ir] = 0;
        for(ic=0; ic<DIM; ic++)
            alpha[ir] += b[ic] * cofactor(r, DIM, ir, ic);
        alpha[ir] /= det;
    }

    for(i=0; i<DIM; i++){
        elmt->crcm[i] = elmt->nneigh[0]->r[i];
        for(ineigh=0; ineigh<DIM; ineigh++){
            elmt->crcm[i] -= alpha[ineigh] * rvert[ineigh][i];
        }
    }

    elmt->crcmsq = 0;
    for(ineigh=0; ineigh<DIM; ineigh++)
        elmt->crcmsq += alpha[ineigh] * b[ineigh];
}

double 
dot(a, b)
double a[DIM], b[DIM];
{
    int i;
    double dot = 0;
    for(i=0; i<DIM; i++)
        dot += a[i]*b[i];
    return(dot);
}

get_cofactors(elmt)
ELMTPTR elmt;
{
    double r[DIM1][DIM1];
    double cofactor();
    int i, ineigh, sign;

    for(ineigh=0; ineigh<DIM1; ineigh++){
        for(i=0; i<DIM; i++)
            r[ineigh][i] = -elmt->nneigh[ineigh]->r[i];
        r[ineigh][DIM] = -1;
    }

    for(ineigh=0; ineigh<DIM1; ineigh++){
        sign = 1;
        if(elmt->instat != INTERIOR && elmt->instat != ineigh)
            sign = -1;
        for(i=0; i<DIM; i++)
            elmt->cofactor[ineigh][i] = sign*cofactor(r, DIM1, ineigh, i);
    }
}

double
inradius(elmt)
ELMTPTR elmt;
{
    double mat[DIM1][DIM1], b[DIM1];
    double determinant(), dot(), cofactor();
    double det, d, dd, top, c;
    int ineigh, i;
 
    if(elmt->instat != INTERIOR)
        return(0.0);
 
    for(ineigh=0; ineigh<DIM1; ineigh++){
        dd = 0;
        for(i=0; i<DIM; i++){
            d = elmt->cofactor[ineigh][i];
            dd += d*d;
        }
        dd = sqrt(dd);
        for(i=0; i<DIM; i++)
            mat[ineigh][i] = elmt->cofactor[ineigh][i]/dd;
    }
 
    for(ineigh=0; ineigh<DIM1; ineigh++)
        b[ineigh] =
            dot(mat[ineigh], elmt->nneigh[(ineigh+1)%DIM1]->r);
 
	top = det = 0;
	for(i=0; i<DIM1; i++){
		c = cofactor(mat, DIM1, i, DIM);
		top += c*b[i];
		det += c;
	}
    return(-top/det);
}
