#include "meshtool.h" 

plotmesh()
{
    ELMTPTR elmt;
	NODEPTR node, ni, nj;
    int ineigh, jneigh;

    FORALLELMTS(elmt)
        if(elmt->instat != INTERIOR)
            continue;
        for(ineigh=0; ineigh<DIM1; ineigh++){
			for(jneigh=ineigh+1; jneigh<DIM1; jneigh++){
                ni = elmt->nneigh[ineigh];
				nj = elmt->nneigh[jneigh];
				connect_nodes(FOREGD, ni, nj);
            }
        }
    NEXTELMT(elmt)

	FORALLNODES(node)
		if(node->clock != NULL)
			connect_nodes(GREEN, node, node->clock);
		if(node->antik != NULL)
			connect_nodes(GREEN, node->antik, node);
	NEXTNODE(node)
}

connect_nodes(shade, n, m)
int shade;
NODEPTR n, m;
{
	if(!graphics)
		return;
	color(shade);
	move(n->r[0], n->r[1]);
	cont(m->r[0], m->r[1]);
}

part_connect_nodes(shade, n, m)
int shade;
NODEPTR n, m;
{
	if(!graphics)
		return;
	color(shade);
	move(n->r[0], n->r[1]);
	cont(0.8*m->r[0]+0.2*n->r[0], 0.8*m->r[1]+0.2*n->r[1]);
}

fill_region(r)
double r[DIM];
{
	int ineigh;
	ELMTPTR elmt, start = NULL;
	double inside();

    FORALLINELMTS(elmt)
		elmt->show = 0;
        for(ineigh=0; ineigh<DIM1; ineigh++)
            if(inside(elmt, r, ineigh) < 0.0)
				goto continu;
		start = elmt;
continu:;
	NEXTELMT(elmt)
	sendplot();

	if(start == NULL)
		return 0;
	else {
		seedfill(start);
		return 1;
	}
}

seedfill(elmt)
ELMTPTR elmt;
{
	NODEPTR n, m;
	int ineigh;

	if(elmt->show || elmt->instat != INTERIOR)
		return;

	elmt->show = 1;
	draw_elmt(elmt);

	for(ineigh=0; ineigh<DIM1; ineigh++){
		n = elmt->nneigh[(ineigh+1)%3];
		m = elmt->nneigh[(ineigh+2)%3];
		if(n->clock != m && n->antik != m
		&& m->clock != n && m->antik != n)
			seedfill(elmt->eneigh[ineigh]);
	}
}

draw_elmt(elmt)
ELMTPTR elmt;
{
	int i, ineigh;
	double r[DIM], cm[DIM];

	for(i=0; i<DIM; i++){
		cm[i] = 0;
		for(ineigh=0; ineigh<DIM1; ineigh++)
			cm[i] += elmt->nneigh[ineigh]->r[i];
		cm[i] /= DIM1;
	}
	initpanel(2 + elmt->show, 0);
	for(ineigh=0; ineigh<DIM1; ineigh++){
		for(i=0; i<DIM; i++)
			r[i] = 0.5*cm[i] + 0.5*elmt->nneigh[ineigh]->r[i];
		panelpoint(r[0], r[1]);
	}
	endpanel();
}
