#include <stdio.h>
#include "menu.h"
#include "bdy.h"
#include "colors.h"

MNUPTR root;
FILE *ps_file;
int plotting = 0;
int explicit_flag = 0;
extern int graphics;

extern int menuport, pixport;
extern double menu_width;

main(argc, argv)
int argc;
char **argv;
{
	MNUPTR zoom_menu, script_menu;
	int zoom_extents(), zoom_window(), zoom_half(), zoom_exp();
	int addnodes(), disp_erase(), explicit();
	int exit(), menu_readbdy_file(), redraw();
	int edgenodes(), writemesh(), clean_bdy();
	int menu_include(), menu_record(), menu_end_record();

	root = menu_make(ROOT);
    zoom_menu = menu_make(BRANCH);
        add_item(zoom_menu, "Extents", LEAF, zoom_extents);
        add_item(zoom_menu, "Window", LEAF, zoom_window);
        add_item(zoom_menu, "Half", LEAF, zoom_half);
        add_item(zoom_menu, "Explicit", LEAF, zoom_exp);
    add_item(root, "ZOOM", BRANCH, zoom_menu);

    script_menu = menu_make(BRANCH);
        add_item(script_menu, "Use_script", LEAF, menu_include);
        add_item(script_menu, "Make_script", LEAF, menu_record);
        add_item(script_menu, "End_script", LEAF, menu_end_record);
    add_item(root, "SCRIPT", BRANCH, script_menu);

	add_item(root, "Readbdy", LEAF, menu_readbdy_file);
	add_item(root, "Redraw", LEAF, redraw);
	add_item(root, "Addnodes", LEAF, addnodes);
	add_item(root, "Edgenodes", LEAF, edgenodes);
	add_item(root, "Triangulate", LEAF, clean_bdy);
	add_item(root, "Writemesh", LEAF, writemesh);
	add_item(root, "Erase", LEAF, disp_erase);
	add_item(root, "Explicit", LEAF, explicit);
    add_item(root, "Quit", LEAF, exit);

    printf("**************************************************\n");
    printf("*           This is MESHTOOL version 1.0         *\n");
    printf("**************************************************\n");
    printf("*            Copyright Caltech 1990              *\n");
    printf("**************************************************\n");

	setplxopt("winlab", "Meshtool");
	init_grafix(0.2, 2, 32768);
	graphics = 2;

	if(argc > 1)
		menu_includefile(argv[1]);

	menu_input();
}

explicit()
{
	explicit_flag = 1-explicit_flag;
	if(explicit_flag)
		printf("Explicit mode\n");
	else
		printf("Mouse mode\n");
}

edgenodes()
{
	double r[2];
	struct curve *curve;
	struct segment *seg;
	double s;

	while(1){
		setvport(menuport);
		box(0.0, 0.0, menu_width, 1.0, MAGENTA, 1);
		setvport(pixport);
		if(!get_gin(r, r+1)){
			printf("End of edgenodes\n");
			redraw();
			return;
		}
		closest_to_curve(&curve, &s, r[0], r[1]);
		get_point(curve, s, r, r+1);
		curve_addpoint(r, curve, s);
	}
}

addnodes()
{
	double r[2];

	while(1){
		setvport(menuport);
		box(0.0, 0.0, menu_width, 1.0, BLUE, 1);
		setvport(pixport);
		if(explicit_flag){
			redraw();
			printf("Next point please\n");
			get_double(r);
			get_double(r+1);
		} else {
			if(!get_gin(r, r+1)){
				printf("End of addnodes\n");
				redraw();
				return;
			}
		}
		inside_addpoint(r);
	}
}

redraw()
{
	if(!graphics)
		return;
	disp_erase();
	drawcurves();
	plotmesh();
	sendplot();
}

menu_readbdy_file()
{
	char bdyfile[256];

	printf("Boundary file name?\n");
	get_string(bdyfile);
	readbdy_file(bdyfile);
}
