/*********
* aspect *
**********

Returns the native resolution of the device - either in physical
units (like inches) or pixels.
*/
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif

void aspect(xsize,ysize)
Coord *xsize,*ysize;
{
    INVOKE(aspect)(xsize, ysize);
    return;
}

void raspect(xsize, ysize)
     Coord *xsize, *ysize;
{
    INVOKE(raspect)(xsize, ysize);
    return;
}

#ifdef _3L
void kaspec(xs, ys)
     float *xs, *ys;
{
    Coord p, q;

    aspect(&p ,&q);
    *xs = p;
    *ys = q;
    return;
}

void kraspe(xs, ys)
     float *xs, *ys;
{
    Coord p, q;

    raspect(&p, &q);
    *xs = p;
    *ys = q;
    return;
}
#endif		/* 3L */

#if COMPILER == SUNF77
void kaspec_(xs, ys)
     float *xs, *ys;
{
    Coord p, q;

    aspect(&p ,&q);
    *xs = p;
    *ys = q;
    return;
}

void kraspe_(xs, ys)
     float *xs, *ys;
{
    Coord p, q;

    raspect(&p, &q);
    *xs = p;
    *ys = q;
    return;
}
#endif		/* SUNF77 */
