/*      N.B..... this routine centres the characters  and leaves the plotter
 *      point at x,y
 */
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif

void sztext(str, pwd, pht)
     char *str;
     Coord *pwd, *pht;
{
    INVOKE(sztext)(str, pwd, pht);
    return;
}

/*
 * If we're doing software clipping we have to do it here. We make the
 * assusmption that the font is "fixed width" to minimize the work.
 */
void dotext(s,x,y,angle, hjust, vjust)
     char *s;
     Coord x,y;
     int angle;
     int hjust, vjust;
{
    int Nhi, Nlo, N;
    Coord atx, aty, wd, ht;
    char *psavc, savc;
    struct _vptab *thisvp;

    if(IND(softclip)) {
	sztext(s, &wd, &ht);
	N = strlen(s);
	if(N == 0 || wd == (Coord) 0) return;

	if(hjust == -1)     atx = x;
	else if(hjust == 0) atx = x - .5*wd;
	else                atx = x - wd;
	if(vjust == -1)     aty = y;
	else if(vjust == 0) aty = y - .5*ht;
	else                aty = y - ht;
/*
 * Now make the easy cuts.... top and bottom and the extreme
 * left and right cases.
 */
        thisvp = &IND(vptab[IND(cvport)]);
	if(aty + ht > thisvp->clipwin[3]) return;
	if(aty      < thisvp->clipwin[1]) return;
	if(atx + wd < thisvp->clipwin[0]) return;
	if(atx      > thisvp->clipwin[2]) return;
/*
 * At this pint there must be some overlap. Calculate how much
 * based on linear interpolation - i.e., assume a fixed width font.
 */
	Nlo = 0;
	Nhi = N;
	if(atx < thisvp->clipwin[0]) {
	    Nlo = (int) ((thisvp->clipwin[0] - atx) * ((double)N)/wd + 0.99);
	}
	if(atx + wd > thisvp->clipwin[2]) {
	    Nhi = (int) ((thisvp->clipwin[2] - atx) * ((double)N)/wd);
	}
/*
 * Temporarily overwrite the character at Nhi wiht a NULL so that
 * we don't have to save the string anywhere. Note that this makes
 * this code non-reentrant.
 */
	psavc = s + Nhi;
	savc = *psavc;
	*psavc = '\0';
	INVOKE(dotext)(s+Nlo, x, y, angle, hjust, vjust);
	*psavc = savc;
    }
    else
	INVOKE(dotext)(s, x, y, angle, hjust, vjust);

    move(x, y);
    return;
}

void intext(prompt, x, y, term, input, maxlen, vjust)
    char *prompt;	/* Prompt to be issued */
    Coord x, y;		/* Location for prompt */
    char *term;		/* Termination characters */
    char *input;	/* Buffer to store result */
    int maxlen;		/* Max. number of chars to store */
    int vjust;		/* Vertical justification (as dotext) */
{
    if(_plx_curdev->intext != 0) {
        Coord wd, ht;
	sztext(prompt, &wd, &ht);

	if (vjust == 0) y -= .5*ht;
	else if (vjust = 1) y -= ht;
        INVOKE(intext)(prompt, x, y, term, input, maxlen);
    } else {
        *input = '\0';	/* Don't let garbage propogate */
    }
    move(x, y);
    return;
}

#ifdef _3L
kdotex(s, x, y, angle, hjust, vjust, len)
     char *s;
     float *x, *y;
     int *angle, *hjust, *vjust;
     int len;
{
    char *p, tmp[128];

    if(len > sizeof(tmp)) return;

    p = tmp;
    while(len--) *p++ = *s++;
    *p++ = '\0';

    dotext(tmp, (Coord)*x, (Coord)*y, *angle, *hjust, *vjust);
}

ksztex(s, pw, ph, len)
    char *s;
    float *pw, *ph;
    int len;
{
    char *p, tmp[128];
    Coord wd, ht;

    if(len > sizeof(tmp)) return;
    p = tmp;
    while(len--) *p++ = *s++;
    *p++ = '\0';

    sztext(tmp, &wd, &ht);
    *pw = wd;
    *ph = ht;
    return;
}

kintex(prompt, x, y, term, input, maxlen, lpmt, lterm, linp)
     char *prompt;
     float *x, *y;
     char *term, *input;
     int *maxlen;
     long lpmt, lterm, linp;
{
     char *p, tmp_prompt[80], tmp_term[80];

     if(lpmt > sizeof(tmp_prompt) || lterm > sizeof(tmp_term)) return;

     p = tmp_prompt;
     while(lpmt--) *p++ = *prompt++;
     *p = '\0';

     p = tmp_term;
     while(lterm--) *p++ = *term++;
     *p = '\0';

     intext(tmp_prompt, (Coord)*x, (Coord)*y, tmp_term, input, *maxlen);
     return;
}
#endif 		/* _3L */

#if COMPILER == SUNF77
void kdotex_(s, x, y, angle, hjust, vjust, len)
     char *s;
     float *x, *y;
     int *angle, *hjust, *vjust;
     int len;
{
    char *p, tmp[128];

    if(len > sizeof(tmp)) return;

    p = tmp;
    while(len--) *p++ = *s++;
    *p++ = '\0';

    dotext(tmp, (Coord)*x, (Coord)*y, *angle, *hjust, *vjust);
}

void ksztex_(s, pw, ph, len)
    char *s;
    float *pw, *ph;
    int len;
{
    char *p, tmp[128];
    Coord wd, ht;

    if(len > sizeof(tmp)) return;
    p = tmp;
    while(len--) *p++ = *s++;
    *p++ = '\0';

    sztext(tmp, &wd, &ht);
    *pw = wd;
    *ph = ht;
    return;
}

void kintex_(prompt, x, y, term, input, maxlen, lpmt, lterm, linp)
     char *prompt;
     float *x, *y;
     char *term, *input;
     int *maxlen;
     long lpmt, lterm, linp;
{
     char *p, tmp_prompt[80], tmp_term[80];

     if(lpmt > sizeof(tmp_prompt) || lterm > sizeof(tmp_term)) return;

     p = tmp_prompt;
     while(lpmt--) *p++ = *prompt++;
     *p = '\0';

     p = tmp_term;
     while(lterm--) *p++ = *term++;
     *p = '\0';

     intext(tmp_prompt, (Coord)*x, (Coord)*y, tmp_term, input, *maxlen);
     return;
}
#endif 		/* SUNF77 */
