/**********
* process *	J.W.Flower, ParaSoft Corporation, March 1988
***********

This routine is the one that actually crunches on the metafile.
This code DOES graphics. Do not call it if you aren't ready.
*/
#ifndef KERNEL
#include <stdio.h>
#endif
#include "plotix.h"
#ifdef isMPW
#include <:sys:meta.h>
#include <:sys:plotix.h>
#else
#include "sys/meta.h"
#include "sys/plotix.h"
#endif

#ifndef KERNEL
extern int _xdebug;
extern FILE *dbgfp;
#else
int _xdebug,dbgfp;
#endif
static unsigned int getuint();
static int getint();

#define SPACE_FAC	((Coord)65535)

/* Notice that we try to be pedantic so that failing to define one of
   the options should yield an error rather than giving you the wrong
   thing.
*/
#if KERNEL && !M_I386
#define Source char far *
#else
typedef char *Source;
#endif

#define getpc()		((*(__PS_input)++) & 0xff)

/* The following variable is required so that all the routines
   in this file can get at the source of data 'BY VALUE'. Otherwise
   the ONLINE case fails when we pass (by value) into getuint.
*/
Source __PS_input;

_plx_process(source, dest)	/* Main processing routine */
     Source source;
     Source dest;
{
    long X,Y;
    Coord x, y;
    unsigned int key, i,j, from, to, hjust, vjust, angle, opt;
    char termstr[32], labstr[128], *s;

    __PS_input = source;

    while(((int)(__PS_input-source)) < PLX_QUANTUM) {
	switch(opt = getpc()) {
	case PL_NOOP:
	    break;

	case PL_OPEN:
	    if(_xdebug) fprintf(dbgfp,"openpl\n");
	    else {
#ifndef KERNEL
			openpl(8192, (FILE *)0);
#else
			openpl(8192, (int *)0);
#endif
#ifdef FLTCORD
			space((Coord)0, (Coord)0, SPACE_FAC, SPACE_FAC);
#endif
	    }
	    break;

	case PL_CLOSE:
	    if(_xdebug) fprintf(dbgfp,"closepl\n");
	    else closepl();
	    break;

	case PL_MOVE:
	    X = (long)getuint();
	    Y = (long)getuint();
	    if(_xdebug) fprintf(dbgfp,"move(%ld, %ld)\n", X, Y);
	    else move((Coord)X, (Coord)Y);
	    break;

	case PL_CONT:
	    X = (long)getuint();
	    Y = (long)getuint();
	    if(_xdebug) fprintf(dbgfp,"cont(%ld, %ld)\n", X, Y);
	    else cont((Coord)X, (Coord)Y);
	    break;

	case PL_TEXT:
	    X = (long)getuint();
	    Y = (long)getuint();
	    angle = (long)getint();
	    hjust = (long)getint();
	    vjust = (long)getint();
	    s = labstr;
	    do {
		    *s = getpc();
	    } while(*s++ != '\0');
	    if(_xdebug) fprintf(dbgfp,"dotext(\"%s\", %ld, %ld, %d, %d, %d)\n",
				labstr, X, Y,angle, hjust,vjust);
	    else dotext(labstr, (Coord)X, (Coord)Y, angle, hjust, vjust);
	    break;
	    
	case PL_INTEXT:
	    X = (long)getuint();
	    Y = (long)getuint();
	    s = labstr;		/* Prompt */
	    do {
		*s = getpc();
	    } while(*s++ != '\0');
	    s = termstr;
	    do {
		*s = getpc();
	    } while(*s++ != '\0');
	    if(_xdebug)
		fprintf(dbgfp, "intext(\"%s\", %ld, %ld, \"%s\", ...)\n",
			labstr, X, Y, termstr);
	    else intext(labstr, (Coord)X, (Coord)Y, termstr, dest, 128);
	    break;

	case PL_COLOR:
	    i = getint();
	    if(_xdebug) fprintf(dbgfp,"color(%d)\n", i);
	    else color(i);
	    break;

	case PL_LINEMOD:
	    i = getint();
	    if(_xdebug) fprintf(dbgfp,"linemod(%d)\n", i);
	    else linemod(i);
	    break;

	case PL_ERASE:
	    if(_xdebug) fprintf(dbgfp,"erase\n");
	    else erase();
	    break;

	case PL_INITP:
	    i = getint();
	    j = getint();
	    if(_xdebug) fprintf(dbgfp,"initpanel(%d, %d)\n", i,j);
	    else initpanel(i,j);
	    break;

	case PL_PANELP:
	    X = (long)getuint();
	    Y = (long)getuint();
	    if(_xdebug) fprintf(dbgfp,"panelpoint(%ld, %ld)\n", X,Y);
	    else panelpoint((Coord)X, (Coord)Y);
	    break;

	case PL_ENDP:
	    if(_xdebug) fprintf(dbgfp,"endpanel\n");
	    else endpanel();
	    break;

	case PL_POINT:
	    X = (long)getuint();
	    Y = (long)getuint();
	    if(_xdebug) fprintf(dbgfp,"point(%ld, %ld)\n", X,Y);
	    else marker(0, (Coord)X, (Coord)Y, 0.1);
	    break;

	case PL_RAIN:
		from = (long)getint();
		to   = (long)getint();
		rainbow(from, to);
		break;

	case PL_GREY:
		from = (long)getint();
		to   = (long)getint();
		greyscale(from, to);
		break;

	case PL_GIN:
	    gin(&x, &y, &key);
	    break;

	case PL_PLOT:
	    if(_xdebug) fprintf(dbgfp,"sendplot\n");
	    return 0;

	case PL_UPLOT:
	    if(_xdebug) fprintf(dbgfp,"usendplot\n");
	    return 0;

	default:
#ifndef KERNEL
	    fprintf(stderr,"Illegal option in graphics: 0x%x\n", opt);
#endif
	    if(_xdebug) {
		fprintf(dbgfp,"Illegal option in graphics: 0x%x\n", opt);
	    }
	    return -1;
	}
    }
    return 0;			/* Return O.K status */
}

static unsigned int getuint()
{
    short ret;

    ret = getpc() & 0xff;
    ret |= ((getpc() << 8) & 0x0000ff00);
    return (ret & 0xffff);
}

static int getint()
{
    short ret;

    ret = getpc() & 0xff;
    ret |= ((getpc() << 8) & 0x0000ff00);
    return (int)ret;
}

#ifdef KERNEL
fprintf(fp, fmstr, v0,v1,v2,v3,v4,v5,v6,v7,v8,v9)
int fp;
char *fmstr;
int v0,v1,v2,v3,v4,v5,v6,v7,v8,v9;
{
    printf(fmstr, v0,v1,v2,v3,v4,v5,v6,v7,v8,v9);
}
#endif

