#include <suntool/sunview.h>
#include <suntool/canvas.h>

struct mousepos {
    int mouse_seen;             /* Has the mouse button been pressed */
    int at_x, at_y;             /* Where, in canvas coordinates */
    int last_x, last_y;         /* Where the mouse last was */
    int trigger;                /* What caused it to be pressed */
    int butstate;		/* Button state, bit mask */
};

struct _plx_dep {
    Frame frame;                /* Frame containing pixwin */
    Canvas canvas;              /* The "window" in which we draw. */
    int frame_fd, canvas_fd;    /* File descriptors corresponding to windows */
    Pixwin *pixwin;             /* The clipping pixwin we're using */
    Pixwin *basewin;            /* The entire pixwin we're using */
    int clipx_org;              /* Origin of current clipping window */
    int clipy_org;      
    int  mapsize;               /* Size of "color map" */
    int  color;                 /* Current line color */
    int char_wd;                /* Character width */
    int char_ht;                /* Character height */
    int nhatch;                 /* Number of hatch patterns */
    Pixrect *hatchpr[16];       /* Hatch patterns */
    int ngrey;                  /* Number of grey scale patterns */
    Pixrect *greypr[16];        /* Greyscale patterns */
    Pixfont *pixfont;           /* Font used for text */
    int (*redraw)();            /* Pointer to repaint procedure */
    int wishx, wishy;           /* User requested window sizes */
#define NCHARLAB        (64)
    char winlab[NCHARLAB];      /* Window label */
    int atx, aty;               /* Window position */
/*
 * Stuff for dealing with the mouse.
 */
    struct mousepos mouse;
/*
 * Stuff for drawing polygons - note there's an upper limit on the
 * number of vertices.
 */
#ifndef MAXPTS
#define MAXPTS  (1024)
#endif
    struct pr_pos polylist[MAXPTS]; /* Array of polygon points */
    int npolys;
    int npts[1];
    int sv_shade, sv_edge;
/*
 * Random linestyles, textures, etc..
 */
    Pr_texture texture;
    Pr_texture *tex_ptr;
/*
 * And the color maps.
 */
#define DEFCMAP (128)
    unsigned char red[DEFCMAP];
    unsigned char gre[DEFCMAP];
    unsigned char blu[DEFCMAP];
};

/*
 * These macros convert between the user and screen coordinates.
 */
#define USER_TO_SCREEN_X(x)     \
        ((int)(IND(mul[0])*(x) + IND(off[0])))
#define USER_TO_SCREEN_Y(y)     \
        ((int)(IND(devy)-1 - (IND(mul[1])*(y) + IND(off[1]))))

/*
 * These macros convert between the full screen and clipping window
 * coordinates.
 */
#define CLIPX(x)        ((x)-DEP(clipx_org))
#define CLIPY(y)        ((y)-DEP(clipy_org))

/*
 * This is the number of allowed linestyles.
 */
#define NUMLIN  (6)

/*
 * Default window size.
 */
#define DEV_x   (768)           /* Default window size */
#define DEV_y   (512)


