/******
* gin *         J.W.Flower    April 1986
*******

Carries out one Graphical input operation. 
Output parameters are :-
                key = Ascii equivalent of key pressed
                x,y = coordinates of located point in user units.
*/
#include <stdio.h>
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif

int gtrack_on()
{
    if(_plx_curdev->gtrack_on)
        return INVOKE(gtrack_on)();
    else
	return -1;
}

void gtrack_off()
{
    INVOKE(gtrack_off)();
    return;
}

int gtrack(pkey, px, py)
     int *pkey;
     Coord *px, *py;
{
    int stat;

    stat = INVOKE(gtrack)(pkey, px, py);
    if(stat < 0) return stat;

    return _inwindow(*px, *py);
}

#ifdef _3L
int ktrkon()
{
    return gtrack_on();
}

int ktrack(pkey, px, py)
     int *pkey;
     float *px, *py;
{
    int ret;
    Coord xx, yy;

    ret = gtrack(pkey, &xx, &yy);
    *px = xx;
    *py = yy;
    return ret;
}

void ktrkof()
{
    gtrack_off();
}
#endif		/* 3L */

#if COMPILER == SUNF77
int ktrkon_()
{
    return gtrack_on();
}

int ktrack_(pkey, px, py)
     int *pkey;
     float *px, *py;
{
    int ret;
    Coord xx, yy;

    ret = gtrack(pkey, &xx, &yy);
    *px = xx;
    *py = yy;
    return ret;
}

void ktrkof_()
{
    gtrack_off();
}
#endif		/* SUNF77 */
