/**********
* xplot.h *         Wendell T. Hicken , ParaSoft Corporation, 1989.
***********

Main header file for the X Windows implementation of PLOTIX.
*/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>
#include <X11/Xresource.h>
#include <X11/cursorfont.h>

struct _plx_dep {
    int fgcolor, linestyle;
    int mouse;
    int xChar, yChar;           /* System font sizes */
    Coord mouse_x, mouse_y;     /* Current mouse position */
    int button,mx,my;
/*
 * Options, settable with (set/get)plx(opt/str)
 */
    int (*redraw)();                    /* Pointer to repaint procedure */
    int wishx, wishy;           /* Size of window */
    int atx, aty;                       /* Where to place window */
#define NCHARLAB        (64)
    char winlab[NCHARLAB];

    unsigned long cmap[256];            /* Color maps */
    unsigned long plxmap[8];
    Colormap xcmap;
    int mono;
/*
 * Major windowing entities.
 */
    Display *display;
    GC gc;              /* This is the graphics context for plotix */
    Window win;
    int screen;
    XFontStruct *font;
    Cursor ptrcursor,hrgcursor;
/*
 * Stuff for dealing with polygons.
 */
#ifndef MAXVERTS
#define MAXVERTS        (1000)
#endif
    int sv_shade, sv_edge;
    int Npts;
    int polyverts[MAXVERTS*2], *polys;
    XPoint polyarray[MAXVERTS];
/*
 * Items connected with the internal event loop.
 */
    int loopmode;
    int fallout;
};

#define MODEDEFAULT QueuedAfterFlush

/*)
 * Macros to convert between user and screen coordinates.
 */
#define USER_to_X(x) (IND(mul[0])*(x) + IND(off[0]))
#define USER_to_Y(y) (IND(devy) - (IND(mul[1])*(y) + IND(off[1])) )

#define X_to_USER(x) (((Coord) (x) - IND(off[0])) / IND(mul[0]))
#define Y_to_USER(y) ((IND(devy) - IND(off[1]) - (Coord) (y))/IND(mul[1]))

/*
 * Number of allowed linestyles.
 */
#define NUMLIN (6)      /* Number of linestyles */

/*
 * Hypothetical color resolution.
 */
#define MAXCOL (unsigned int) 65535

/*
 * Default window size is found at runtime. Need to
 * supply non-zero sizes to prevent NaN's.
 */
#define DEV_x	(0)
#define DEV_y	(0)
