/*----------------------------------------------------------------------*
 *                                                                      *
 *  Strings simulation on dynamically triangulated random surfaces.     *  
 *                                                                      *
 *  Original code by Clive Baillie, Caltech, 1989.                      *
 *  using DIME (Distributed Irregular Mesh Environment) created by      *
 *  Roy Williams, Caltech, 1987.                                        *
 *                                                                      *
 *  Code revised by Paul Coddington and Leping Han, Syracuse, Jan 1992. *
 *                                                                      *
 *----------------------------------------------------------------------*/

#include "stringext.h"
#include "stringdef.h"

int nnn = 1;
int dim = 3;
double hit_size = 0.5;
FILE *out = NULL;


main(argc, argv)
int argc;
char **argv;
{
	int reset(), ascii_print_action(), sweeps();
	int outfile(), add_nodes(), check_mesh(), read_string();
	int string_distort(), string_read(), string_write();
	double string_sqdist();
	int mode;

#ifdef CUBIX
	/* Set up Express variables */
	struct nodenv nodedata;
	exparam(&nodedata);
	procnum = nodedata.procnum;
	nproc = nodedata.nprocs;
#else
	nproc = 1;
	procnum = 0;
#endif
	mode = SINGL;

	/* Initialize the random number generator */
	pranset(42);

	/* Initialize the DIME (triangular mesh) environment */
	DIME_SETUP(argc, argv, mode);
	
	/* Initialize DIME pointers to user functions */
	user_read = string_read;
	user_write = string_write;
	distort = string_distort;
	sqdist = string_sqdist;

	/* Read in and set up the triangular mesh */
        read_string();
	add_nodes();

	/* Initialize various stuff */
	reset();

	/* Read in data from previous run */


	/* Run the Metropolis update */
	sweeps();


	/* Back up the mesh and the data */


	exit(0);
}

