#include "stringext.h"

measure(act)
double *act;
{
	NODEPTR node, n1, n2;
	ELMTPTR elmt;
	double dd, dr;
	int idim;

/***************************GAUSSIAN ACTION **************/
	GAUSS = 0;
	FORALLNODES(node)
		GAUSS += node->user->gauss_action;
	NEXTNODE(node)

/***************************LOG PRODUCT NNEIGH ***********/
	LN_W = 0;
	FORALLNODES(node)
		LN_W += log((double)node->user->nneigh);
	NEXTNODE(node)

/***************************AREA CURVATURE ***************/
	AREA_CURVE = 0;
	FORALLNODES(node)
		AREA_CURVE += node->user->area_action;
	NEXTNODE(node)

/***************************EDGE CURVATURE ***************/
	EDGE_CURVE = 0;
	FORALLNODES(node)
		EDGE_CURVE += node->user->edge_action;
	NEXTNODE(node)
/***************************GYRATION RADIUS***************/
	X2 = 0;
	FORALLNODES(n1)
		FORALLNODES(n2)
			if(n1 >= n2)
				continue;
			dd = 0;
			for(idim=0; idim<dim; idim++){
				dr = n1->user->r[idim] - n2->user->r[idim];
				dd += dr*dr;
			}
			X2 += dd*n1->user->nneigh*n2->user->nneigh;
		NEXTNODE(n2)
	NEXTNODE(n1)
	X2 /= 9*nnode*(nnode-1);
/************************MAXNEIGH***************************/
	NNEIGH = 0;
	FORALLNODES(node)
		if(node->user->nneigh > NNEIGH)
			NNEIGH = node->user->nneigh;
	NEXTNODE(node)
}



avg_measure(act, act2)
double act[NOBS+2];
double act2[NOBS+2];
{
	int i;
	measure(act);
	act[NOBS] = metro_success;
	act[NOBS+1] = flip_success;
	for(i=0; i<NOBS+2; i++)
		act2[i] = act[i]*act[i];

/* DO NOT COMBINE !!! */
/*
#ifdef CUBIX
	combine(act, fsum, sizeof(double), NOBS-1);
	combine(act+NOBS-1, fmax, sizeof(double), 1);
	combine(act+NOBS, fsum, sizeof(double), 2);

	for(i=0; i<NOBS+2; i++)
		if(i != NOBS-1)
			act[i] /= nproc;

	combine(act2, fsum, sizeof(double), NOBS-1);
	combine(act2+NOBS-1, fmax, sizeof(double), 1);
	combine(act2+NOBS, fsum, sizeof(double), 2);

	for(i=0; i<NOBS+2; i++)
		if(i != NOBS-1)
			act2[i] /= nproc;
#endif
*/

}


double action()
{
	double act[NOBS];
	measure(act);
#ifdef ALPHA
	return(GAUSS - alpha*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
#else
	/*
	return(GAUSS - 0.5*dim*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
	*/
	return(GAUSS + 0.5*dim*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
#endif
}

