#include "stringext.h"

/*
#define DUAL
*/

fill_user_structs()
{
	NODEPTR node;
	ELMTPTR elmt;

	FORALLELMTS(elmt)
		get_elmt_data(elmt);
	NEXTELMT(elmt)

	nnode = 0;
	FORALLNODES(node)
		get_node_data(node);
		nnode++;
	NEXTNODE(node)
	printf("%d nodes in fill_user_structs\n", nnode);
	fflush(stdout);
}


get_elmt_data(elmt)
ELMTPTR elmt;
{
	NODEPTR n0, n1, n2;
	int idim, i, in;
	double dot, rr, temp, r[3][MAXDIM];

	n0 = elmt->neigh[0];
	n1 = elmt->neigh[1];
	n2 = elmt->neigh[2];
	for(idim=0; idim<dim; idim++){
		r[0][idim] = n1->user->r[idim] - n2->user->r[idim];
		r[1][idim] = n2->user->r[idim] - n0->user->r[idim];
		r[2][idim] = n0->user->r[idim] - n1->user->r[idim];
	}
	for(i=0; i<3; i++){
		in = (i+1)%3;
		rr = dot = 0;
		for(idim=0; idim<dim; idim++){
			rr += r[i][idim] * r[i][idim];
			dot += r[i][idim] * r[in][idim];
		}
		elmt->user->edge_sq[i] = rr;
		dot /= rr;
		rr = 0;
		for(idim=0; idim<dim; idim++){
			temp = elmt->user->h[idim][i] = r[in][idim] - dot * r[i][idim];
			rr += temp * temp;
		}
		elmt->user->alt_sq[i] = rr;
	}
	elmt->user->area = 0.5*sqrt(elmt->user->edge_sq[0]*elmt->user->alt_sq[0]);
}


get_node_data(node)
NODEPTR node;
{
	ELMTPTR elmt, elmtn;
	NODEPTR noden;
	NODEPTR A, B, C, D;
	NODENEIGHPTR n, nstart;
	int i, idim, in;
	double node_area, node_length, dr[MAXNEIGH], one_dr[MAXNEIGH];
	double edge_curve();
	double hB2, hC2, hD2, AB_AC, BC_BA, DC_DA, AD_AC;
	double AC2, BC2, BA2, DA2, DC2, cota, cotb, cotd, cotan;
	double AB[MAXDIM], BC[MAXDIM], AC[MAXDIM], DA[MAXDIM], DC[MAXDIM];

	node->user->nneigh = 0;
	node->user->edge_action = 0;
	node->user->area_action = 0;
	node->user->gauss_action = 0;

	node_area = 0;
	node_length = 0;
	for(idim=0; idim<dim; idim++)
		dr[idim] = 0.0;

	n = nstart = node->n;
	do {
		node->user->nneigh++;
		elmt = n->elmt;
		elmtn = n->next->elmt;
		i = (indexc(elmt, node)+1)%3;
		in = (indexc(elmtn, node)+2)%3;

		node->user->edge_action += edge_curve(elmt, i, elmtn, in);
		node->user->gauss_action += 0.5*elmt->user->edge_sq[i];
		noden = elmt->neigh[(i+1)%3];
		for(idim=0; idim<dim; idim++)
			one_dr[idim] = noden->user->r[idim] - node->user->r[idim];
#ifndef DUAL
		node_area += elmt->user->area;
#else
/* dual area and length terms */
		AC2 = elmt->user->edge_sq[i];
		BC2 = elmt->user->edge_sq[(i+1)%3];
		BA2 = elmt->user->edge_sq[(i+2)%3];
		DA2 = elmtn->user->edge_sq[(in+1)%3];
		DC2 = elmtn->user->edge_sq[(in+2)%3];
	C = node;
	B = elmt->neigh[i];
	A = noden;
	D = elmtn->neigh[in];
	hB2 = elmt->user->alt_sq[i];
	hC2 = elmt->user->alt_sq[(i+2)%3];
	hD2 = elmtn->user->alt_sq[in];
	for(idim=0; idim<dim; idim++) {
		AB[idim] = B->user->r[idim] - A->user->r[idim];
		BC[idim] = C->user->r[idim] - B->user->r[idim];
		AC[idim] = C->user->r[idim] - A->user->r[idim];
		DA[idim] = A->user->r[idim] - D->user->r[idim];
		DC[idim] = C->user->r[idim] - D->user->r[idim];
	}
	AB_AC = 0.;
	BC_BA = 0.;
	DC_DA = 0.;
	AD_AC = 0.;
	for(idim=0; idim<dim; idim++) {
		AB_AC += AB[idim] * AC[idim];
		BC_BA += BC[idim] * (-AB[idim]);
		DC_DA += DC[idim] * DA[idim];
		AD_AC += (-DA[idim]) * AC[idim];
	}
	cota = AB_AC / ( sqrt(AC2 * hB2) );
	cotb = BC_BA / ( sqrt(BA2 * hC2) );
	cotd = DC_DA / ( sqrt(DA2 * hC2) );
	cotan = AD_AC / ( sqrt(AC2 * hD2) );
		node_area += 0.125 * (BC2*cota + AC2*cotb);
		node_length = 0.5 * (cotb + cotd);
	for(idim=0; idim<dim; idim++)
		one_dr[idim] *= node_length;
#endif
	for(idim=0; idim<dim; idim++)
		dr[idim] += one_dr[idim];
	} while((n = n->next) != nstart);

	for(idim=0; idim<dim; idim++) {
		node->user->area_action += dr[idim] * dr[idim];
	}
	node->user->area_action /= node_area;
/*
printf("|| node_area = %f action = %f AC = %f node_length = %f dr = %f %f %f\n",
node_area, node->user->area_action, sqrt(AC2), node_length, dr[0], dr[1], dr[2]);
*/
}


double edge_curve(elmt, i, elmtn, in)
ELMTPTR elmt, elmtn;
int i, in;
{
	double dot = 0, hh;
	int idim;
	for(idim=0; idim<dim; idim++)
		dot += elmt->user->h[idim][i] * elmtn->user->h[idim][in];
	hh = elmt->user->alt_sq[i] * elmtn->user->alt_sq[in];
	if(hh < SMALL){
/*
#ifndef CUBIX
		printf("warning -- collinear\n");
#endif
*/
		return(0.0);
	}
	else
		return(0.5*(1 + dot / sqrt(hh)));
}


add_node(elmt, i)
ELMTPTR elmt;
int i;
{
	NODEPTR A, B, C, D, E, node_alloc();
	ELMTPTR ABC, CDE, ACD, ABE, elmt_alloc();
	NODENEIGHPTR indexnn(), nodeneigh_alloc();
	int idim, old_abc_a, old_acd_c;

	ABC = elmt;
	B = ABC->neigh[i];
	C = ABC->neigh[(i+1)%3];
	A = ABC->neigh[(i+2)%3];

	ACD = indexnn(A, ABC)->next->elmt;
	D = ACD->neigh[(indexc(ACD, A) + 2)%3];

	old_abc_a = indexc(ABC, A);
	old_acd_c = indexc(ACD, C);

	E = node_alloc();
	ABE = elmt_alloc();
	CDE = elmt_alloc();

	ACD->neigh[old_acd_c] = E;
	indexnn(C, ACD)->elmt = CDE;

	ABC->neigh[old_abc_a] = E;
	indexnn(A, ABC)->elmt = ABE;

	ABE->neigh[0] = A;
	ABE->neigh[1] = B;
	ABE->neigh[2] = E;

	CDE->neigh[0] = C;
	CDE->neigh[1] = D;
	CDE->neigh[2] = E;

	insert(B, ABC, nodeneigh_alloc(), ABE);
	insert(D, ACD, nodeneigh_alloc(), CDE);

	add_neigh(ABC, E);
	add_neigh(CDE, E);
	add_neigh(ACD, E);
	add_neigh(ABE, E);
	sortout(E);

	for(idim=0; idim<dim; idim++)
		E->user->r[idim] = 0.5*(A->user->r[idim] + C->user->r[idim]);
}


add_nodes()
{
	NODEPTR node;
	ELMTPTR elmt;
	int addem;

	nnode = 0;
	FORALLNODES(node)
		nnode++;
	NEXTNODE(node);
	printf("Currently %d nodes; add how many?", nnode);
	fflush(stdout);
	get_int(&addem);

	FORALLELMTS(elmt)
		if(addem-- == 0)
			break;
		add_node(elmt, 0);
	NEXTELMT(elmt)

	nnode = 0;
	FORALLNODES(node)
		nnode++;
	NEXTNODE(node);
	printf("Now %d nodes\n", nnode);
	fflush(stdout);
}


check_mesh()
{
	NODEPTR node, p;
	ELMTPTR elmt, e;
	NODENEIGHPTR n, indexnn();
	int i, k;

	FORALLNODES(node)
		if(node->user->nneigh >= MAXNEIGH){
			printf("Too many neighbors\n");
			return(-1);
		}
		k = 0;
		FORALLNEIGH(node, elmt)
			if(!antik(n, n->next, node)){
				printf("mesh buggered\n");
				return(-1);
			}
			k++;
		NEXTNEIGH(node, elmt)
		if(k != node->user->nneigh){
			printf("nneigh buggered\n");
			return(-1);
		}
		if(node->user->gauss_action < 0.0){
			printf("gauss_action buggered\n");
			return(-1);
		}
		if(node->user->area_action < 0.0){
			printf("area_action buggered\n");
			return(-1);
		}
	NEXTNODE(node)

	FORALLELMTS(elmt)
		if(elmt->user->area < 0.0){
			printf("elmt area buggered\n");
			return(-1);
		}
		for(i=0; i<3; i++){
			n = indexnn(elmt->neigh[i], elmt);
			if(elmt->user->edge_sq[i] < 0.0){
				printf("elmt edge_sq buggered\n");
				return(-1);
			}
			if(elmt->user->alt_sq[i] < 0.0){
				printf("elmt alt_sq buggered\n");
				return(-1);
			}
		}
	NEXTELMT(elmt)
	return(0);
}


string_distort(node, ax, ay)
NODEPTR node;
double *ax, *ay;
{
	*ax = node->user->r[0];
	*ay = node->user->r[1];
}


double string_sqdist(n1, n2)
NODEPTR n1, n2;
{
	int idim;
	double dx, d = 0;
	for(idim=0; idim<dim; idim++){
		dx = n1->user->r[idim] - n2->user->r[idim];
		d += dx*dx;
	}
	return (d);
}

