/**********
* setseed *    J.W.Flower & the infamous Dr. O  March 1985
***********

Used to set the seed for the parallel random number system -
MUST be called or all processors will execute same sequence! - see
Chapter 12 of *THE BOOK*.  Two options:
  i) Input seed from terminal                        
  ii) Read in seed from standard file "Seed".  
ALSO: at the end of production runs, don't forget to store current
seed in "Seed" by running option "d". N.B. You don't need to do this
any more, since the seed is dumped at the end of the backup file 
*/
  
#include "stringext.h"
extern long randx ;

setseed()
{
    FILE *fp ;
    int mode ;
    long seed ;

    printf("Select mode of seed setting : (0=input,1=file) : ") ;
    fflush(stdout);
    scanf("%d",&mode) ;
    printf("%d\n",mode) ;
    fflush(stdout);

    if (mode == 0) {
      printf("Input seed : ");
      fflush(stdout);
      scanf("%ld",&seed);
    }  
    else {
      if ((fp = fopen("Seed","r")) == NULL) {
        printf("Couldn't find Seedfile...assuming 42 !!\n") ;
        fflush(stdout);
        seed = 42L ;
      }
      else {
        fscanf(fp,"%ld",&seed) ;
        fclose(fp) ; 
      }
    }
    pranset(seed) ;

    printf("Seed set to %ld\n",seed);
    fflush(stdout);

    return(0) ;
}

/**********
* dmpseed *    J.W.Flower & the infamous Dr. O, March 1985
***********

Retrieves the current seed from the cube and stores them on disc.
                                                                        */
dmpseed()
{
    long seed ;
    FILE *fp,*fopen() ;

    if ((fp = fopen("Seed","w")) == NULL) {
      perror("dmpseed") ;
      exit(-1) ;
    }
    fprintf(fp,"%ld\n",randx) ;
    fflush(fp) ;
    fclose(fp) ;

    return(0) ;
}
