
#include "stringext.h"

extern FILE *out;

sweeps()
{
	int sweep, sweeps, mes_steps, mes_done, mes_i, i;
	int first_time;
	double metro_move(), flip_move();

	/* Read in the run parameters */
	printf("How many sweeps per measurement? "); fflush(stdout);
	get_int(&sweeps);
	printf("How many measurements?\n" ); fflush(stdout);
	get_int(&mes_steps);

	/*
	printf("Bin size?\n"); fflush(stdout);
	get_int(&binsize);
	printf("Bins per write?\n"); fflush(stdout);
	get_int(&bins_per_write);
	sweeps_per_write = bins_per_write * binsize;
	*/

	binsize = 10;
	sweeps_per_write = 100;

	printf("First Time ???\n" ); fflush(stdout);
	get_int(&first_time);
	printf("\n");

        backup = FALSE;

	/* Initialize the averages */
	for(i=0; i<NOBS+2; i++) {
		bin_ave[i] = 0.;
		bin_ave2[i] = 0.;
	}
	if (first_time) {
		mes_done = 0;
		for(i=0; i<NOBS+2; i++) {
			tot_ave[i] = 0.;
			tot_ave2[i] = 0.;
		}
	} else {
		read_aves(&mes_done);
	}

	/* Do the Monte Carlo run */
	for(mes_i=0; mes_i<mes_steps; mes_i++){
		metro_success = flip_success = 0;

		/* Do the update */
		for(sweep=0; sweep<sweeps; sweep++){
			metro_success += metro_move();
			flip_success  += flip_move();
		}

		metro_success /= sweeps;
		flip_success  /= sweeps;

		/* Do the measurements */
		avg_measure(act, act2);
		for(i=0; i<NOBS+2; i++) {
			bin_ave[i] += act[i];
			bin_ave2[i] += act2[i];
			tot_ave[i] += act[i];
			tot_ave2[i] += act2[i];
		}

	    	if(mes_done % binsize == binsize - 1) {
			for(i=0; i<NOBS+2; i++) {
				bin_ave[i] /= (double)binsize;
				bin_ave2[i] /= (double)binsize;
			}
			nnn = mes_done+1;
			if(out != NULL)
				binary_print_action();
			ascii_print_action();
			for(i=0; i<NOBS+2; i++) {
				bin_ave[i] = 0.;
				bin_ave2[i] = 0.;
			}
	    	}

		/* Back up the mesh and the data */
	    	if ((backup) && 
                    ((mes_done % sweeps_per_write) == sweeps_per_write - 1)) {
			write_string();
			nnn = mes_done+1;
			write_aves(&nnn);
	    	}
		mes_done++;
	}

#ifndef CUBIX
	printf("Accumulated action %f\n", tot_action);
#endif
	if(backup) {
		write_string();
		write_aves(&mes_done);
	}
}

