#include "strings.h"

#define TWO_PI    6.283185307
#define CONST     1.0471976      /* Pi / 3 */
#define TWO_CONST 2.0943951      /* 2 Pi / 3 */

measure(act)
double *act;
{
	NODEPTR node, n1, n2;
	NODENEIGHPTR indexnn();
    	ELMTPTR elmt;
	double dd, dr, noneigh;
	int idim,i,i0,i1;
	double temp_gauss_curve,temp_intr_curve,temp_diff;
	double theta,normdot2,dot,normdot2p,nodarea,temp_ex_curve;

/************** EXTRINSIC and INTRISIC CURVATURE MEASUREMENTS **********/
    GAUSS_CURVE = 0;
    INTR_CURVE = 0;
    DIFF_CURVE = 0;
    INTR_2CURVE = 0;
    GAUSS_2CURVE = 0;
    PROD_CURVE = 0;
    FORALLNODES(node)
	theta = 0.;
	nodarea = 0.;
	FORALLNEIGH(node,elmt)
	   i0= (indexc(elmt,node)+1) % 3;
	   i1 = (indexc(elmt,node)+2) % 3;
	   dot = 0.;
	   normdot2 = 0.;
	   normdot2p = 0.;
	   for (idim=0; idim<dim; idim++) {
	      dot += (elmt->user->h[idim][i0])*(elmt->user->h[idim][i1]);
	      normdot2 += (elmt->user->h[idim][i0])*(elmt->user->h[idim][i0]);
	      normdot2p += (elmt->user->h[idim][i1])*(elmt->user->h[idim][i1]);
    	   }
	   theta += acos(-1. * dot / sqrt(normdot2*normdot2p));
	   nodarea += elmt->user->area;
	NEXTNEIGH(node,elmt)
	noneigh = (double)node->user->nneigh;
        temp_intr_curve = TWO_PI * (6. - noneigh) / noneigh;
	temp_ex_curve = (TWO_PI - theta) * 3. / nodarea;
        temp_diff = theta - CONST * noneigh;
/* printf("tdiff theta %10.3f %10.3f", temp_diff, theta);
 */
	PROD_CURVE += temp_intr_curve * temp_ex_curve * .333333333 * noneigh;
        INTR_2CURVE += temp_intr_curve * temp_intr_curve * .333333333 * noneigh;
	GAUSS_2CURVE += temp_ex_curve * temp_ex_curve * .333333333 * noneigh;
	GAUSS_CURVE += fabs(TWO_PI - theta);
	INTR_CURVE += TWO_CONST * fabs(6. - noneigh);
	DIFF_CURVE += fabs(temp_diff);
    NEXTNODE(node)
    CORR_CURVE = PROD_CURVE/sqrt(INTR_2CURVE*GAUSS_2CURVE); 

/***************************GAUSSIAN ACTION **************/
	GAUSS = 0;
	FORALLNODES(node)
		GAUSS += node->user->gauss_action;
	NEXTNODE(node)

/***************************LOG PRODUCT NNEIGH ***********/
	LN_W = 0;
	FORALLNODES(node)
		LN_W += log((double)node->user->nneigh);
	NEXTNODE(node)

/***************************EXTRINSIC AREA ***************/
	AREA_EX = 0;
	FORALLELMTS(elmt)
		AREA_EX += elmt->user->area;
	NEXTELMT(elmt)

#ifdef AREA
/***************************AREA CURVATURE ***************/
	AREA_CURVE = 0;
	FORALLNODES(node)
		AREA_CURVE += node->user->area_action;
	NEXTNODE(node)

#else
/***************************EDGE CURVATURE ***************/
	EDGE_CURVE = 0;
	FORALLNODES(node)
/* printf("edge act = %10.3f", node->user->edge_action); 
*/
		EDGE_CURVE += node->user->edge_action;
	NEXTNODE(node)
/* printf ("Edge_action = %10.3f", EDGE_CURVE);
*/
#endif AREA

/***************************GYRATION RADIUS***************/
	X2 = 0;
	FORALLNODES(n1)
		FORALLNODES(n2)
			if(n1 >= n2)
				continue;
			dd = 0;
			for(idim=0; idim<dim; idim++){
				dr = n1->user->r[idim] - n2->user->r[idim];
				dd += dr*dr;
			}
			X2 += dd*n1->user->nneigh*n2->user->nneigh;
		NEXTNODE(n2)
	NEXTNODE(n1)
	X2 /= 9*nnode*(nnode-1);

/************************MAXNEIGH***************************/
	NNEIGH = 0;
	FORALLNODES(node)
		if(node->user->nneigh > NNEIGH)
			NNEIGH = node->user->nneigh;
	NEXTNODE(node)
}



avg_measure(act, act2)
double act[NOBS+2];
double act2[NOBS+2];
{
    int i;

    measure(act);
    act[NOBS] = metro_success;
    act[NOBS+1] = flip_success;

    /* Scale the measurements */
    act[0] /= (nnode-1);
    for(i=1; i<5; i++) {
        act[i] /= nnode;
    }
    for(i=6; i<NOBS-1; i++) {
        act[i] /= nnode;
    }

    for(i=0; i<NOBS+2; i++) {
    	act2[i] = act[i]*act[i];
    }
}


double action()
{
    double act[NOBS];
    double curvature;

    measure(act);

#ifdef AREA
    curvature = lambdaA*AREA_CURVE;
#else
    curvature = lambdaE*EDGE_CURVE;
#endif AREA

#ifdef ALPHA
    return(GAUSS - alpha*LN_W + curvature);
#endif ALPHA
#ifdef SIGNBUG
    return(GAUSS + 0.5*dim*LN_W + curvature);
#else
    return(GAUSS - 0.5*dim*LN_W + curvature);
#endif SIGNBUG

}



/* Work out averages and variances (specific heats) and their errors 
   by averaging over data on different processors, which should be 
   completely uncorrelated. */

analyze()
{
   int i;
   double err_ave, err_var, sigmasq;
   double var[NOBS+2], var2[NOBS+2];
   int type1=37, type2=38, type3=39, type4=40;  /* These are just a dummies */
   extern int fsum();

   if (nproc > 1) {
        printf("Average over processors:\n\n"); fflush(stdout);
	for(i=0; i<NOBS+2; i++) {
	   tot_ave[i]  /= mes_done;
	   tot_ave2[i] /= mes_done;
           var[i] = tot_ave2[i] - (tot_ave[i] * tot_ave[i]);
           var[i] *= nnode;
           var2[i] = var[i] * var[i];
	   tot_ave2[i] = tot_ave[i] * tot_ave[i];
        }
        /* Combine the data over processors */
	excombine(tot_ave,  fsum, sizeof(double), NOBS+2, 
		  ALLNODES, NULLPTR, &type1);
	excombine(tot_ave2, fsum, sizeof(double), NOBS+2,
		  ALLNODES, NULLPTR, &type2);
	excombine(var,      fsum, sizeof(double), NOBS+2,
		  ALLNODES, NULLPTR, &type3);
	excombine(var2,     fsum, sizeof(double), NOBS+2,
		  ALLNODES, NULLPTR, &type4);
        /* Work out averages and errors */
	for(i=0; i<NOBS+2; i++) {
	   tot_ave[i]  /= (double)nproc;
	   tot_ave2[i] /= (double)nproc;
	   var[i] /= (double)nproc;
	   var2[i] /= (double)nproc;
	   sigmasq = tot_ave2[i] - (tot_ave[i] * tot_ave[i]);
	   err_ave = sqrt(sigmasq/(double)nproc);
	   sigmasq = var2[i] - (var[i] * var[i]);
	   err_var = sqrt(sigmasq/(double)nproc);
	   printf("%3d  %11.6f  +/- %9.6f     %12.6f  +/- %10.6f\n", 
                  i, tot_ave[i], err_ave, var[i], err_var);
           fflush(stdout);
	}
   }
}

