/* Grabs the autocorrelations for a given operator and writes
 * them to the appropriate files for reading by the fitting program.
 */   

#include <math.h>
#include <stdio.h>

#define NOBS 15
#define M NOBS
#define NBREAK 6  /* Autocorrs on each line */

#define MAXNA 200

#define C1  3   /* Edge action */
#define C2  0   /* Gaussian term */
#define C3  7   /* New measurement */

double EA[M][MAXNA], errEA[M][MAXNA];

main()
{
int NA,half,op,i,j,m;
double temp;
char *strchr();
char *tmp_ptr, fileerror[128], line[128];
FILE *fd, *fopen(), *fp;

      fgets(line,512*16+1,stdin);  /* number of processors */
      fgets(line,512*16+1,stdin);  /* number of nodes */
      fgets(line,512*16+1,stdin);  /* bin size */

      /* Read in NA */
      fgets(line,512*16+1,stdin);
      tmp_ptr = strchr(line,'=');
      if (tmp_ptr == NULL) {
	 perror("got NULL pointer");
	 exit(-3);
      }
      tmp_ptr++;
      sscanf(tmp_ptr, "%d", &NA);
      printf("%d\n", NA); fflush(stdout);
      
      fgets(line,512*16+1,stdin);  /* sweeps per measurement */
      fgets(line,512*16+1,stdin);  /* number of measurements */
      fgets(line,512*16+1,stdin);  /* number of bins */
      
      /* Averages */
      fgets(line,512*16+1,stdin);  /* blank line */
      for (m=0;m<M;m++) {
         fgets(line,512*16+1,stdin);
      }
      /* printf("Averages\n"); */

      /* Specific heats */
      fgets(line,512*16+1,stdin);  /* blank line */
      for (m=0;m<M;m++) {
         fgets(line,512*16+1,stdin);
      }
      /* printf("Specific Heats\n"); */

      /* Minima and maxima */
      fgets(line,512*16+1,stdin);  /* blank line */
      for (m=0;m<M;m++) {
         fgets(line,512*16+1,stdin);
      }
      /* printf("Min and Max\n"); */
    
      /* Autocorrelations */
      for (half=0;half<2;half++) {
         for (i=0;i<3;i++) fgets(line,512*16+1,stdin);  /* blank lines */
         for (i=0;i<NA;i++) {
            scanf("%d", &j);
	    if (j != i) {
	       printf("i = %d  j = %d\n", i,j); fflush(stdout);
	    }
            for (m=0;m<NBREAK;m++) {
	       op = half * NBREAK + m;
	       scanf("%lf", &temp);  /* Gaussian term */
	       if ((op == C1) || (op == C2) || (op == C3)) {
	          EA[op][i] = temp;
	          errEA[op][i] = 0.001;
               }
	    }
         }
         /* printf("autocorrs\n"); fflush(stdout); */
      }

      /* autocorrelation lengths */
      for (half=0;half<2;half++) {
         for (i=0;i<NA+2;i++) fgets(line,512*16+1,stdin);
         /* printf("autocorr lengths\n"); fflush(stdout); */
      }

      fgets(line,512*16+1,stdin); /* blank space */
      if (fgets(line,512*16+1,stdin) != NULL) {
	 printf("WARNING - EOF not found ... line = %s\n", line);
      }


/* Print out autocorrelations */

if ((fd = fopen("corr.data","w")) == NULL) {
   fprintf(stderr,"File corr.data not opened\n");
   exit(-1);
}
fprintf(fd,"%d\n",NA);
for (i=0;i<NA;i++) {
   fprintf(fd,"%3d  ", i);
   fprintf(fd,"%10.6f  %10.6f  ", EA[C1][i],errEA[C1][i]);
   fprintf(fd,"\n");
}
fclose(fd);
 
if ((fd = fopen("spin.data","w")) == NULL) {
   fprintf(stderr,"File spin.data not opened\n");
   exit(-1);
}
fprintf(fd,"%d\n",NA);
for (i=0;i<NA;i++) {
   fprintf(fd,"%3d  ", i);
   fprintf(fd,"%10.6f  %10.6f  ", EA[C2][i],errEA[C2][i]);
   fprintf(fd,"\n");
}
fclose(fd);
 
if ((fd = fopen("susp.data","w")) == NULL) {
   fprintf(stderr,"File susp.data not opened\n");
   exit(-1);
}
fprintf(fd,"%d\n",NA);
for (i=0;i<NA;i++) {
   fprintf(fd,"%3d  ", i);
   fprintf(fd,"%10.6f  %10.6f  ", EA[C3][i],errEA[C3][i]);
   fprintf(fd,"\n");
}
fclose(fd);

   exit(0);

} /* end of main */


char *strchr(ptr,c)
char *ptr;
char c;
{
char *stringptr;

    stringptr = ptr;
    while ((*stringptr != '\0') && (*stringptr != c)) stringptr ++;
    if (*stringptr == c) return stringptr;
    else return NULL;
}

