/*    These are the user specific parts of mesh input/output */

#include "strings.h"
#include <string.h>


read_string()
{
	char string[100];
	double lambda;
	int i=0, islash, ibar=0,mode;
	FILE *in;

    printf("Input Filename (without suffix)?\n");
    get_string(string);

#ifdef CFS
   strcat(string, ".ct");
   sprintf(string, "/cfs/paulc/strings/%s", string);
#else
    /* Don't actually need this, except maybe as a check */
    if ((strncmp(string,"icos",4) != 0) && (strncmp(string,"torus",5) != 0)) {
	islash = -1;
	while(string[i] != '\0'){
		if(string[i] == '/')
			islash = i;
		i++;
	}
	while(string[ibar++] != '_');
	sscanf(string+ibar, "%d", &dim);
	sscanf(string+islash+6, "%lf", &lambda);
	if(string[islash+5] == 'A'){
		lambdaA = lambda;
		lambdaE = 0.0;
	} else {
		lambdaA = 0.0;
		lambdaE = lambda;
	}
	printf("Dim = %d, lambda%c = %f\n", dim, string[islash+5], lambda);
        fflush(stdout);
    }
    strcat(string, ".ct");
#endif CFS

    if((in = fopen(string, "r")) == (FILE *)NULL){
        printf("Cannot open %s\n", string);
		exit(0);
    }
    else {
        readct(in);
    }

	fill_user_structs();
}

write_string()
{
	char filename[100];
	FILE *write;

	if(lambdaE == 0.0)
		sprintf(filename, "N%d/MeshA%4.3f_%d.ct", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/MeshE%4.3f_%d.ct", nnode, lambdaE, dim);

#ifdef CFS
   sprintf(filename, "/cfs/paulc/strings/%s", filename);
#endif CFS

#ifdef DEBUG
	printf("Writing mesh to %s\n", filename);
#endif DEBUG
	if((write = fopen(filename, "w")) == NULL){
		perror(filename);
		return;
	} else
		writect(write);
}



string_read(fp, type, ptr)
FILE *fp;
int type;
char *ptr;
{
    NODEPTR n;
    ELMTPTR e;
    BDYPTR b;
	int i;

    switch(type){
		case MISC:
			return;
        case ELMT:
            e = (ELMTPTR)ptr;
            return;
        case NODE:
            n = (NODEPTR)ptr;
#ifdef DEBUG
printf("(%d)", procnum);
#endif
			for(i=0; i<dim; i++){
				fscanf(fp, "%lf", &n->user->r[i]);
#ifdef DEBUG
printf(" %f ", n->user->r[i]);
#endif
			}
#ifdef DEBUG
printf("\n");
fflush(stdout);
#endif
            return;
        case BDY:
            b = (BDYPTR)ptr;
            return;
    }
}


string_write(fp, type, ptr)
FILE *fp;
int type;
char *ptr;
{
    NODEPTR n;
    ELMTPTR e;
    BDYPTR b;
	int i;

    switch(type){
		case MISC:
			fprintf(fp, "\n");
			return;
        case ELMT:
            e = (ELMTPTR)ptr;
			fprintf(fp, "\n");
            return;
        case NODE:
            n = (NODEPTR)ptr;
			for(i=0; i<dim; i++)
				fprintf(fp, "%f ", n->user->r[i]);
			fprintf(fp, "\n");
            return;
        case BDY:
            b = (BDYPTR)ptr;
			fprintf(fp, "\n");
            return;
    }
}

