#include "curvetool.h"

struct point *the_points;
struct endseg *the_endsegs;
struct segment *the_segments;
struct curve *the_curves;

int pointnum = 0;
int curvenum = 0;

struct point *
point_alloc()
{
	struct point *new;
	static struct point *currpoint = (struct point *)0;

	new = (struct point *)malloc(sizeof(struct point));
	if(!new){
		printf("point_alloc: Too many points\n");
		exit(101);
	}
	new->next = (struct point *)NULL;
	if(currpoint)
		currpoint->next = new;
	else
		the_points = currpoint = new;

	new->loop = NULL;
	sprintf(new->name, "___p%d", pointnum++);
	currpoint = new;
	return (new);
}

struct segment *
segment_alloc()
{
	struct segment *new;
	static struct segment *currsegment = (struct segment *)0;

	new = (struct segment *)malloc(sizeof(struct segment));
	if(!new){
		printf("segment_alloc: Too many segments\n");
		exit(101);
	}
	new->next = (struct segment *)NULL;
	if(currsegment)
		currsegment->next = new;
	else
		the_segments = new;

	currsegment = new;
	return(new);
}

struct endseg *
endseg_alloc()
{
	struct endseg *new;
	static struct endseg *currendseg = (struct endseg *)0;

	new = (struct endseg *)malloc(sizeof(struct endseg));
	if(!new){
		printf("endseg_alloc: Too many endsegs\n");
		exit(101);
	}
	new->next = NULL;
	if(currendseg)
		currendseg->next = new;
	else
		the_endsegs = new;

	currendseg = new;
	return(new);
}

struct endseg *
add_endseg(point)
struct point *point;
{
	struct endseg *e = endseg_alloc();

	e->interior = 0;
	e->x = point->x;
	e->y = point->y;
	if(point->loop){
		e->loop = point->loop->loop;
		point->loop->loop = e;
	} else
		e->loop = e;
	point->loop = e;

	return(e);
}

struct curve *
curve_alloc()
{
	struct curve *new;
	static struct curve *currcurve = (struct curve *)0;

	new = (struct curve *)malloc(sizeof(struct curve));
	if(!new){
		printf("curve_alloc: Too many curves\n");
		exit(101);
	}
	new->next = NULL;
	sprintf(new->name, "___c%d", curvenum++);

	if(currcurve)
		currcurve->next = new;
	else
		the_curves = new;

	currcurve = new;
	return(new);
}
