#include <stdio.h>
#include <math.h>
#include "colors.h"

#define LARGE	1.e12
#define SMALL	1.e-12

struct point {
	char name[20];
	double x, y;
	struct endseg *loop;
	struct point *next;
};

struct endseg {
	double x, y;
	double kx, ky;
	int interior;
	struct segment *segment;
	struct endseg *loop;
	struct endseg *next;
};

struct segment {
	struct endseg *e1, *e2;
	double ax, bx, cx, dx;
	double ay, by, cy, dy;
	double xmin, ymin, xmax, ymax;
	struct segment *next;
};

struct curve {
	char name[20];
	struct point *pstart, *pend;
	struct endseg *start;
	struct curve *next;
};

#define		POINT		0
#define		KNOT		1
#define		ENDSEG		2
#define		NOTHING		3

extern struct point *the_points;
extern struct endseg *the_endsegs;
extern struct segment *the_segments;
extern struct curve *the_curves;
extern int nres;

#define FORALLPOINTS(point) \
	if(point = the_points) do {

#define NEXTPOINT(point) \
	} while(point = point->next);

#define FORALLSEGMENTS(segment)	\
	if(segment = the_segments) do {

#define NEXTSEGMENT(segment)	\
	} while(segment = segment->next);

#define FORALLENDSEGS(endseg)	\
	if(endseg = the_endsegs) do {

#define NEXTENDSEG(endseg)	\
	} while(endseg = endseg->next);

#define FORALLCURVES(curve)	\
	if(curve = the_curves) do {

#define NEXTCURVE(curve)	\
	} while(curve = curve->next);

#define POINT_MARK		2
#define ENDSEG_MARK		5
