#include "curvetool.h"

postscript()
{
	char psfile[256];
	FILE *psfp;

	printf("File name please (without suffix)?\n");
	get_string(psfile);
	strcat(psfile, ".ps");
	if((psfp = fopen(psfile, "w")) == NULL){
		printf("Cannot open %s\n", psfile);
		return 0;
	}
	psout(psfp);
	fclose(psfp);
}

psout(fp)
FILE *fp;
{
	char string[256], hdbuf[256];
	double xmin, ymin, xmax, ymax;
	FILE *pshead;
	int n;
	struct segment *seg;

	strcpy(string, getenv("DIME"));
	strcat(string, "/src/dime/ps.head");
	if((pshead = fopen(string, "r")) == (FILE *)NULL){
		printf("Cannot find Postscript header %s\n", string);
		fflush(stdout);
	}  

	while((n = fread(hdbuf, 1, 256, pshead)) != 0)
		fwrite(hdbuf, 1, n, fp);
	fclose(pshead);

	get_extents(&xmin, &ymin, &xmax, &ymax);
	fprintf(fp, "%f %f %f %f z\n", xmin, ymin, xmax, ymax);

	FORALLSEGMENTS(seg)
		fprintf(fp, "%f %f moveto %f %f %f %f %f %f curveto stroke\n",
			seg->e1->x, seg->e1->y,
			seg->e1->kx, seg->e1->ky,
			seg->e2->kx, seg->e2->ky,
			seg->e2->x, seg->e2->y);
	NEXTSEGMENT(seg)
	fprintf(fp, "showpage\n");
}

write_bdy()
{
	char file[256];
	FILE *fp;

	printf("File name please (without suffix)?\n");
	get_string(file);
	strcat(file, ".bdy");
	if((fp = fopen(file, "w")) == NULL){
		printf("Cannot open %s\n", file);
		return 0;
	}
	bdyout(fp);
	fclose(fp);
}

bdyout(fp)
FILE *fp;
{
	struct point *point;
	struct curve *curve;
	struct segment *seg;
	double sx1, sy1, sx2, sy2, sqdist();

	FORALLPOINTS(point)
		fprintf(fp, "Point %s %f %f\n", point->name, point->x, point->y);
	NEXTPOINT(point)

	fprintf(fp, "\n");

	FORALLCURVES(curve)
		fprintf(fp, "Curve %s\n", curve->name);
		fprintf(fp, "\t%s\n", curve->pstart->name);
		seg = curve->start->segment;
		while(1){
			sx1 = (2*seg->e1->x + seg->e2->x)/3;
			sy1 = (2*seg->e1->y + seg->e2->y)/3;
			sx2 = (2*seg->e2->x + seg->e1->x)/3;
			sy2 = (2*seg->e2->y + seg->e1->y)/3;

			if(sqdist(sx1, sy1, seg->e1->kx, seg->e1->ky)
			 + sqdist(sx2, sy2, seg->e2->kx, seg->e2->ky) < SMALL)

				fprintf(fp, "\t%f %f Lineto\n",
					seg->e2->x, seg->e2->y);

			else

				fprintf(fp, "\t%f %f %f %f %f %f Curveto\n",
					seg->e1->kx, seg->e1->ky,
					seg->e2->kx, seg->e2->ky,
					seg->e2->x,  seg->e2->y);

			if(!seg->e2->interior)
				break;
			seg = seg->e2->loop->segment;
		}
		fprintf(fp, "\t%s\n", curve->pend->name);
	NEXTCURVE(curve)

	fprintf(fp, "End\n");
}
