/****************************************************/
/*    DIME: sortelmts.c                             */
/*    Sorting the elements in Cuthill-McKee order   */
/****************************************************/
/*        Roy Williams Copyright Caltech 1990       */
/****************************************************/
#define DIMECODE
#include "dime.h"
#define elmtx		work_space.ef[0]

sortelmts()
{
	ELMTPTR elmt, list_sort();
	double x;
	int compar();

	FORALLELMTS(elmt)
		elmt->elmtx = elmt->neigh[0]->x + elmt->neigh[1]->x + elmt->neigh[2]->x;
	NEXTELMT(elmt)

	the_elmts = list_sort(the_elmts, compar);
}

compar(elmt1, elmt2)
ELMTPTR elmt1, elmt2;
{
	return(elmt1->elmtx < elmt2->elmtx);
}

ELMTPTR list_sort(list, compar)
ELMTPTR list;
int (*compar)();
{
	ELMTPTR min, max, new, ptr, elmt;
	NODEPTR node;
	int i;
	double fac, vis;

	if(!list)
		return list;

	min = max = list;
	new = min->last;
	do {
		ptr = new;
		do {
			if(compar(new, ptr->next)){
				if(ptr != new){
					move_member(new, ptr);
					if(min == max)	max = new;
				} else
					min = new;
				goto continu;
			}
		} while((ptr = ptr->next) != max);
		move_member(new, max);
		max = new;
continu:;
	} while((new = min->last) != max);
	return(min);
}

move_member(victim, before)
ELMTPTR victim, before;
{
	ELMTPTR vl, vn, bl, bn;
	vl = victim->last;
	if(vl == before)
		return;
	vn = victim->next;
	bn = before->next;
	bl = before->last;

	victim->next = bn;		bn->last = victim;

	victim->last = before;	before->next = victim;

	vl->next = vn;			vn->last = vl;
}
