#include "meshtool.h"
FILE *inbdy;

readbdy_file(filename)
char *filename;
{
	NODEPTR point_addpoint(), curve_addpoint(), newnode, node;
	struct point *point;
	struct curve *curve;
	char bdyfile[256];
	double r[2], s;

	strcpy(bdyfile, filename);
	strcat(bdyfile, ".bdy");
	inbdy = fopen(bdyfile, "r");
	if(inbdy == NULL){
		printf("Cannot find file %s\n", bdyfile);
		return;
	}
	else {
		graphics = 0;
		readbdy(inbdy);
	}

	FORALLPOINTS(point)
		r[0] = point->x;
		r[1] = point->y;
		point_addpoint(r, point);
	NEXTPOINT(point)

	FORALLCURVES(curve)
		node_on_curve(curve) = NULL;
	NEXTCURVE(curve)

	FORALLCURVES(curve)
		if(curve->length < SMALL){
			printf("Curve %s has zero length - exiting\n", curve->name);
			exit(99);
		}
		s = 0.5*curve->length;
		get_point(curve, s, r, r+1);
		if(!(newnode = curve_addpoint(r, curve, s))){
			printf("Meshtool internal error - exiting\n");
			exit(99);
		}
		node_on_curve(curve) = newnode;

		FORALLNODES(node)
			if(node->type != POINT)
				continue;
			if(node->bdy.point == curve->first)
				newnode->antik = node;
			if(node->bdy.point == curve->last)
				newnode->clock = node;
		NEXTNODE(node)
	NEXTCURVE(curve)

	graphics = 2;

	zoom_extents();
	redraw();
}

#define CLOCKOK		1
#define ANTIKOK		2

clean_bdy()
{
	NODEPTR node, n, m, nodea, nodec;
	ELMTPTR elmt;
	int i, count = 0;
	double sa, sc, s, r[2], dist(), arcdist();
	struct curve *curve;

again:
	if(count++ > 100){
		printf("");
		printf("\nTriangulation Insufficient **************\n");
		printf("Click Triangulate again for more*********\n");
		return 0;
	}

	FORALLNODES(node)
		node->nodenum = 0;
		if(node->type != CURVE)
			continue;

		curve = node->bdy.curve;
		if(node->clock->type == POINT){
			nodea = node;
			sa = node->s;
			nodec = node->clock;
			sc = node->bdy.curve->length;
		} else if(node->antik->type == POINT){
			nodea = node->antik;
			sa = 0;
			nodec = node;
			sc = node->s;
		} else {
			nodea = node;
			sa = node->s;
			nodec = node->clock;
			sc = node->clock->s;
		}

		if(dist(nodea->r[0], nodea->r[1], nodec->r[0], nodec->r[1]) 
				< 0.98*arcdist(curve, sa, sc)){
			s = (sa + sc)/2;
			get_point(curve, s, r, r+1);
			if(!curve_addpoint(r, curve, s)){
				printf("Meshtool internal error - exiting\n");
				exit(99);
			}
			printf("#"); fflush(stdout);
			goto again;
		}
	NEXTNODE(node)

	FORALLELMTS(elmt)
		for(i=0; i<3; i++){
			n = elmt->nneigh[i];
			m = elmt->nneigh[(i+1)%3];
			if(n->clock == m) n->nodenum |= CLOCKOK;
			if(n->antik == m) n->nodenum |= ANTIKOK;
			if(m->clock == n) m->nodenum |= CLOCKOK;
			if(m->antik == n) m->nodenum |= ANTIKOK;
		}
	NEXTELMT(elmt)

	FORALLNODES(node)
		if(node->type != CURVE)
			continue;
		if(!(node->nodenum & CLOCKOK)){
			if(node->clock->type == POINT)
				s = (node->s + node->bdy.curve->length)/2;
			else
				s = (node->s + node->clock->s)/2;
			get_point(node->bdy.curve, s, r, r+1);
			if(!curve_addpoint(r, node->bdy.curve, s)){
				printf("Meshtool internal error - exiting\n");
				exit(99);
			}
			printf("*"); fflush(stdout);
			goto again;
		}
		if(!(node->nodenum & ANTIKOK)){
			if(node->antik->type == POINT)
				s = (node->s)/2;
			else
				s = (node->s + node->antik->s)/2;
			get_point(node->bdy.curve, s, r, r+1);
			if(!curve_addpoint(r, node->bdy.curve, s)){
				printf("Meshtool internal error - exiting\n");
				exit(99);
			}
			printf("*"); fflush(stdout);
			goto again;
		}
	NEXTNODE(node)
	disp_erase();
	redraw();

	printf("\nBoundary OK\n");
}
