double        cofactor();
double        determinant();
#define MAXN    4

double tempmatrix[(MAXN*(MAXN+1)*(2*MAXN+1))/6];
int offset[MAXN];
int first = 1;

#define TEMP(s,r,c)                tempmatrix[offset[s] + (r)*(s) + (c)]
#define MATRIXELMT(s,r,c)        matrix[(r)*(s) + (c)]

void 
initdet()
{
    int ic;
    first = 0;
    offset[0] = 0;
    for(ic=0; ic<MAXN-1; ic++)
        offset[ic+1] = offset[ic] + ic*ic;
}

double 
determinant(matrix, size)
double *matrix;
int size;
{
    int ic;
    double det = 0;

    if(first)initdet();

    if(size == 1)
        return(MATRIXELMT(1, 0, 0));

    for(ic=0; ic<size; ic++)
        det += MATRIXELMT(size, 0, ic) * cofactor(matrix, size, 0, ic);
    return(det);
}

double 
cofactor(matrix, size, row, column)
double *matrix;
int size;
int row, column;
{
    int sign = ((row+column)%2)?-1:1;
    int r, c, ir, ic;

    if(first)initdet();

    for(ir=0; ir<size; ir++){
        if((r = ir) == row) continue;
        if(r > row) r--;
        for(ic=0; ic<size; ic++){
            if((c = ic) == column) continue;
            if(c > column) c--;
            TEMP(size-1, r, c) = MATRIXELMT(size, ir, ic);
        }
    }
    return(determinant(&TEMP(size-1, 0, 0), size-1) * sign);
}

/*
double mat4[16] = {1.,0.,0.,0.,  0.,1.,0.,0.,  0.,0.,1.,0.,  0.,0.,0.,1.};
double mat3[9] = {1.,2.,3.,  2.,6.,1.,  2.,1.,4.};
double mat2[4] = {1.,2., 3.,4.};

main()
{
    double determinant();
    printf("%f = 1  \n", determinant(mat4, 4));
    printf("%f = -19\n", determinant(mat3, 3));
    printf("%f = -2 \n", determinant(mat2, 2));
}
*/
