#include "meshtool.h"

#define BAD					0
#define MEDIOCRE			1
#define GOOD				2
#define CLUSTER				4
#define DISCONN				8
#define GROWTREE			16
#define MAKEELMT			32

NODEPTR newnode;

#define MAXNEWELMTS		200
ELMTPTR elmtlist[MAXNEWELMTS];
int nnew;
ELMTPTR center;

int shade;

inside_addpoint(r)
double r[DIM];
{
	raw_addpoint(r);
	newnode->type = INSIDE;
}

NODEPTR curve_addpoint(r, curve, s)
double r[DIM];
struct curve *curve;
double s;
{
	NODEPTR oncurve = node_on_curve(curve);

	raw_addpoint(r);

	if(newnode == NULL)
		return(newnode);

	newnode->type = CURVE;
	newnode->bdy.curve = curve;
	newnode->s = s;

	if(oncurve == NULL)
		return(newnode);

	if(oncurve->s < s){
		while(oncurve->s < s){
			if(oncurve->clock->type == POINT)
				goto insert_after;
			oncurve = oncurve->clock;
		}
		goto insert_before;
	} else {
		while(oncurve->s > s){
			if(oncurve->antik->type == POINT)
				goto insert_before;
			oncurve = oncurve->antik;
		}
		goto insert_after;
	}

insert_after:
	newnode->clock = oncurve->clock;
	newnode->antik = oncurve;
	if(oncurve->clock->type != POINT)
		oncurve->clock->antik = newnode;
	oncurve->clock = newnode;
	return (newnode);

insert_before:
	newnode->antik = oncurve->antik;
	newnode->clock = oncurve;
	if(oncurve->antik->type != POINT)
		oncurve->antik->clock = newnode;
	oncurve->antik = newnode;
	return (newnode);
}

NODEPTR point_addpoint(r, point)
double r[DIM];
struct point *point;
{
	raw_addpoint(r);
	if(newnode == NULL)
		return(newnode);
	newnode->type = POINT;
	newnode->bdy.point = point;
	return(newnode);
}

raw_addpoint(r)
double r[2];
{
	ELMTPTR elmt, elmtnext;
	NODEPTR node_alloc();
	double elmtdistsq(), nodedistsq(), inside(), influenced(), in, inmin;
	int i, ineigh, kneigh, inew, jnew, count = 0, ineighmin;

	if(nnodes < DIM1){
		first_addpoint(r);
		return;
	}

#ifdef DEBUG
	printf("ADDPOINT: ");
	print_pt(r);
	FORALLELMTS(elmt)
	if(elmt->influence != 0){
		printf("Non zero influence\n");
		scanf("%d", &ineigh);
	}
	if((elmt->instat == INTERIOR &&elmt->determinant < SMALL)
	|| (elmt->instat != INTERIOR &&elmt->determinant > -SMALL)){
		printf("DET........%x %d %f\n", elmt, elmt->instat, elmt->determinant);
		scanf("%d", &ineigh);
	}
	NEXTELMT(elmt)
#endif

	nnew = 0;
	center = the_elmts;
again:
	if(count++ > 250){
		print_pt(r);
		printf("center %x\n", center);
		for(ineigh=0; ineigh<DIM1; ineigh++){
			printf("%f ", inside(center, r, ineigh)/center->determinant);
			print_pt(center->nneigh[ineigh]->r);
		}
	}
	if(count > 300){
		printf("Cannot find enclosing element\n");
		return(NULL);
	}
	if(influenced(center, r) <= -SMALL){
		inmin = 1.;
		for(ineigh=0; ineigh<DIM1; ineigh++){
			in = inside(center, r, ineigh);
			if(in < inmin){
				ineighmin = ineigh;
				inmin = in;
			}
		}
		if(inmin < 0.0){
			center = center->eneigh[ineighmin];
			goto again;
		} 
	}

	tree_search(center, r);

#ifdef DEBUG
	printf("\ncenter = %x\n", center);
	print_elmt(center);
#endif

	for(ineigh=0; ineigh<DIM1; ineigh++){
		if(nodedistsq(center->nneigh[ineigh], r) < SMALL*SMALL){
			printf("Already got point ");
			print_pt(r);
			FORALLELMTS(elmt)
				elmt->influence = 0;
			NEXTELMT(elmt)
			return(NULL);
		}
	}

#ifdef DEBUG
	printf("Connection: ");
#endif
	connect_good_cluster(center, r);
#ifdef DEBUG
	printf("\n");
#endif

#ifdef DEBUG
	printf("Disconnection: ");
	if(disconnected(center, r)){
		printf("Disconnected cluster\n");
		return(NULL);
	}
	printf("\n");
#endif

	while(grow_tree(center, r))
		reset_tree(center, r);

	newnode = node_alloc();
	for(i=0; i<DIM; i++)
		newnode->r[i] = r[i];

#ifdef DEBUG
	printf("Make: ");
#endif
	make_elmts_tree(center, r);
#ifdef DEBUG
	printf("\nnnew = %d\n", nnew);
#endif

	shade = FOREGD;
	for(inew=0; inew<nnew; inew++)
		for(jnew=0; jnew<nnew; jnew++)
			if((kneigh = lists_match(elmtlist[inew], elmtlist[jnew])) != -1)
				elmtlist[inew]->eneigh[kneigh] = elmtlist[jnew];

	nnew = 0;
#ifdef DEBUG
	printf("Delete: ");
#endif
	delete_tree(center);
#ifdef DEBUG
	printf("\nndelete = %d\n", nnew);
#endif
	shade = 0;
	if(graphics)
		for(inew=0; inew<nnew; inew++)
			for(jnew=0; jnew<nnew; jnew++)
				lists_match(elmtlist[inew], elmtlist[jnew]);

	for(inew=0; inew<nnew; inew++){
		if(elmtlist[inew] == the_elmts)
			the_elmts = the_elmts->next;
		freeelmt(elmtlist[inew]);
	}
}

tree_search(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	int ineigh;
	double influenced(), einf;

	if(elmt->influence != BAD)
		return;
	einf = influenced(elmt, r);

	if(einf > SMALL){
		elmt->influence = GOOD;
		center = elmt;
	} else if(einf > -SMALL){
		elmt->influence = MEDIOCRE;
	} else {
		elmt->influence = BAD;
		return;
	}
#ifdef DEBUG
	printf("(%x %d) ", elmt, elmt->influence);
#endif
	for(ineigh=0; ineigh<DIM1; ineigh++)
		tree_search(elmt->eneigh[ineigh], r);
}

connect_good_cluster(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	int ineigh;

	if((elmt->influence & CLUSTER) 
	|| (elmt->influence & MEDIOCRE)
	|| elmt->influence == BAD)
		return;

	elmt->influence |= CLUSTER;
#ifdef DEBUG
	printf("(%x %d) ", elmt, elmt->influence);
#endif
	for(ineigh=0; ineigh<DIM1; ineigh++)
		connect_good_cluster(elmt->eneigh[ineigh], r);
}

disconnected(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	int ineigh;

	if((elmt->influence & DISCONN) 
	|| elmt->influence == BAD)
		return 0;

	if(!(elmt->influence & CLUSTER) && (elmt->influence & GOOD))
		return 1;

	elmt->influence |= DISCONN;

	printf("(%x %d) ", elmt, elmt->influence);

	for(ineigh=0; ineigh<DIM1; ineigh++)
		if(disconnected(elmt->eneigh[ineigh], r))
			return 1;
	return 0;
}

grow_tree(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	ELMTPTR elmtn;
	int ineigh;

	if((elmt->influence & GROWTREE) 
	|| !(elmt->influence & CLUSTER))
		return 0;

	for(ineigh=0; ineigh<DIM1; ineigh++){
		elmtn = elmt->eneigh[ineigh];
		if(!(elmtn->influence & CLUSTER) 
				&& inside(elmt, r, ineigh) < SMALL){
			elmtn->influence |= CLUSTER;
#ifdef DEBUG
			printf("Adding (%x %d)\n", elmtn, elmtn->influence);
#endif
			return 1;
		}
	}

	elmt->influence |= GROWTREE;

	for(ineigh=0; ineigh<DIM1; ineigh++)
		if(grow_tree(elmt->eneigh[ineigh], r))
			return 1;
	return 0;
}

reset_tree(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	int ineigh;

	if(!(elmt->influence & GROWTREE))
		return;

	elmt->influence = elmt->influence ^ GROWTREE;

	for(ineigh=0; ineigh<DIM1; ineigh++)
		reset_tree(elmt->eneigh[ineigh], r);
}

make_elmts_tree(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	ELMTPTR elmtn, new, elmt_alloc();
	int ineigh, jneigh;

	if((elmt->influence & MAKEELMT) || !(elmt->influence & CLUSTER))
		return;

	for(ineigh=0; ineigh<DIM1; ineigh++){
		elmtn = elmt->eneigh[ineigh];
		if(!(elmtn->influence & CLUSTER)){
			new = elmtlist[nnew++] = elmt_alloc();
#ifdef DEBUG
			printf("*");
#endif
			for(jneigh=0; jneigh<DIM1; jneigh++){
				if(ineigh == jneigh){
					new->eneigh[ineigh] = elmtn;
					elmtn->eneigh[indexe(elmtn, elmt)] = new;
					new->nneigh[jneigh] = newnode;
				} else {
					new->eneigh[jneigh] = NULL;
					new->nneigh[jneigh] = elmt->nneigh[jneigh];
					if(elmt->instat == jneigh)
						new->instat = jneigh;
				}
			}
			make_crcm_data(new);
		}
	}

	elmt->influence |= MAKEELMT;
#ifdef DEBUG
	printf("(%x %d) ", elmt, elmt->influence);
#endif
	for(ineigh=0; ineigh<DIM1; ineigh++)
		make_elmts_tree(elmt->eneigh[ineigh], r);
}

delete_tree(elmt)
ELMTPTR elmt;
{
	int ineigh;

	if(elmt->influence == 0)
		return;

	if(elmt->influence & CLUSTER){
		elmtlist[nnew++] = elmt;
#ifdef DEBUG
		printf("(%x %d) ", elmt, elmt->influence);
#endif
	}

	elmt->influence = 0;
	for(ineigh=0; ineigh<DIM1; ineigh++)
		delete_tree(elmt->eneigh[ineigh]);
}

int 
lists_match(me, him)
ELMTPTR me, him;
{
	int meneigh, himneigh, match = 0;

	for(meneigh=0; meneigh<DIM1; meneigh++)
		for(himneigh=0; himneigh<DIM1; himneigh++)
			match += (me->nneigh[meneigh] == him->nneigh[himneigh]);

	if(match != DIM)
		return(-1);

	for(meneigh=0; meneigh<DIM1; meneigh++){
		for(himneigh=0; himneigh<DIM1; himneigh++){
			if(me->nneigh[meneigh] == him->nneigh[himneigh])
				goto continu;
		}
#if DIM==2
		if(graphics && me->instat == INTERIOR)
			connect_nodes(shade, 
				me->nneigh[(meneigh+1)%3], me->nneigh[(meneigh+2)%3]);
#endif
		return(meneigh);
continu:;
	}
	printf("Error in lists_match\n");
	exit(1);
}

int
indexe(me, him)
ELMTPTR me, him;
{
	int ineigh;
	for(ineigh=0; ineigh<DIM1; ineigh++)
		if(me->eneigh[ineigh] == him)
			return(ineigh);
	printf("Error in indexe\n");
	exit(1);
}

double
inside(elmt, r, ineigh)
ELMTPTR elmt;
double r[DIM];
int ineigh;
{
	double dot = 0.0;
	int i, ineigh1 = (ineigh+1)%DIM1;

	for(i=0; i<DIM; i++)
		dot += elmt->cofactor[ineigh][i]*
			(r[i] - elmt->nneigh[ineigh1]->r[i]);
	return(dot);
}

double
influenced(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
/* Positive if influenced */
    if(elmt->instat == INTERIOR)
        return(elmt->crcmsq - elmtdistsq(elmt, r));
    else
        return(inside(elmt, r, elmt->instat));
}

double 
elmtdistsq(elmt, r)
ELMTPTR elmt;
double r[DIM];
{
	double d, distsq = 0;
	int i;

	for(i=0; i<DIM; i++){
		d = elmt->crcm[i] - r[i];
		distsq += d*d;
	}
	return(distsq);
}

double 
nodedistsq(node, r)
NODEPTR node;
double r[DIM];
{
	double d, distsq = 0;
	int i;

	for(i=0; i<DIM; i++){
		d = node->r[i] - r[i];
		distsq += d*d;
	}
	return(distsq);
}

print_elmt(elmt)
ELMTPTR elmt;
{
	int ineigh;
	printf("elmt %x\n", elmt);
	for(ineigh=0; ineigh<DIM1; ineigh++)
		print_pt(elmt->nneigh[ineigh]->r);
}

print_pt(r)
double r[DIM];
{
#if DIM==3
	printf("   (%f %f %f)\n", r[0], r[1], r[2]);
#else
	printf("   (%f %f)\n", r[0], r[1]);
#endif
}

#define E(i,j,k)		e[i]->eneigh[j] = e[k];
#define N(i,j,k)		if(k==-1){\
							e[i]->nneigh[j] = &node_at_infinity;\
							e[i]->instat = j;\
						} else \
							e[i]->nneigh[j] = n[k];
first_addpoint(r)
double r[DIM];
{
/**********HACK HACK HACK HACK HACK HACK HACK ********/
	static ELMTPTR e[DIM+2];
	static NODEPTR n[DIM+1];
	static _NODE node_at_infinity;
	ELMTPTR elmt;
	_NODE temp;
	int i, ineigh;

	if(nnodes == 0){
		for(i=0; i<=DIM1; i++)
			e[i] = elmt_alloc();
		for(i=0; i<DIM1; i++)
			n[i] = node_alloc();
		nnodes = 0;
#if DIM==3
		E(0, 0, 1) E(0, 1, 2) E(0, 2, 3) E(0, 3, 4)
		N(0, 0, 0) N(0, 1, 1) N(0, 2, 2) N(0, 3, 3)

		E(1, 0, 0) E(1, 1, 3) E(1, 2, 2) E(1, 3, 4)
		N(1, 0,-1) N(1, 1, 2) N(1, 2, 1) N(1, 3, 3)

		E(2, 0, 0) E(2, 1, 1) E(2, 2, 3) E(2, 3, 4)
		N(2, 0,-1) N(2, 1, 0) N(2, 2, 2) N(2, 3, 3)

		E(3, 0, 0) E(3, 1, 2) E(3, 2, 1) E(3, 3, 4)
		N(3, 0,-1) N(3, 1, 1) N(3, 2, 0) N(3, 3, 3)

		E(4, 0, 0) E(4, 1, 3) E(4, 2, 1) E(4, 3, 2)
		N(4, 0,-1) N(4, 1, 2) N(4, 2, 0) N(4, 3, 1)
#else
		E(0, 0, 1) E(0, 1, 2) E(0, 2, 3)
		N(0, 0, 0) N(0, 1, 1) N(0, 2, 2)

		E(1, 0, 0) E(1, 1, 3) E(1, 2, 2)
		N(1, 0,-1) N(1, 1, 2) N(1, 2, 1)

		E(2, 0, 0) E(2, 1, 1) E(2, 2, 3)
		N(2, 0,-1) N(2, 1, 0) N(2, 2, 2)

		E(3, 0, 0) E(3, 1, 2) E(3, 2, 1)
		N(3, 0,-1) N(3, 1, 1) N(3, 2, 0)
#endif
	}
	for(i=0; i<DIM; i++)
		n[nnodes]->r[i] = r[i];

	if(nnodes == DIM){
		for(i=0; i<DIM; i++){
			node_at_infinity.r[i] = 0;
			for(ineigh=0; ineigh<DIM1; ineigh++)
				node_at_infinity.r[i] += n[ineigh]->r[i];
			node_at_infinity.r[i] /= DIM1;
		}

		FORALLELMTS(elmt)
			make_crcm_data(elmt);
		NEXTELMT(elmt)

		if(e[0]->determinant < 0.0){
			switch_nodes(n[0], n[1]);
			FORALLELMTS(elmt)
				make_crcm_data(elmt);
			NEXTELMT(elmt)
		}
	}
	newnode = n[nnodes++];
}

switch_nodes(n, m)
NODEPTR n, m;
{
	int i;
	double temp;
	struct point *ptemp;
		
	ptemp = n->bdy.point;
	n->bdy.point = m->bdy.point;
	m->bdy.point = ptemp;

	for(i=0; i<DIM; i++){
		temp = n->r[i];
		n->r[i] = m->r[i];
		m->r[i] = temp;
	}
}
