#include "meshtool.h"

writemesh()
{
	char string[256];
	double r[2];
	FILE *out;
	struct curve *curve;
	struct point *point;
	int i, nnode = 0;

	printf("Pick a point in a region\n");
	get_gin(r, r+1);
	if(!fill_region(r)){
		printf("Region not found\n");
		return 0;
	}

	printf("Filename (without suffix)?\n");
	get_string(string);
	strcat(string, ".mesh");
	if((out = fopen(string, "w")) == (FILE *)NULL){
		printf("Cannot open %s\n", string);
		fflush(stdout);
		return 0;
	}

	writect(out);
	fclose(out);
	printf("Mesh Written\n");

}

writect(out)
FILE *out;
{
	NODEPTR node, nodec;
	ELMTPTR elmt;
	int i, ineigh, n;
	char *bdybuf[256];
	int nnode = 0;

	FORALLNODES(node)
		node->nodenum = nnode++;
		node->show = 0;
	NEXTNODE(node)

	FORALLELMTS(elmt)
		if(!elmt->show)
			continue;
		for(ineigh=0; ineigh<3; ineigh++)
			elmt->nneigh[ineigh]->show = 1;
	NEXTELMT(elmt)

	FORALLNODES(node)
		if(!node->show)
			continue;
		fprintf(out, "N %d %d ", node->nodenum, node->type);
		switch(node->type){
			case POINT: 
				fprintf(out, "%d %%\n", node->bdy.point->ptnum);
				break;
			case CURVE: 
				fprintf(out, "%d %f %%\n", 
					node->bdy.curve->curvenum, node->s);
				break;
			case INSIDE:
				fprintf(out, "0 %f %f %%\n", node->r[0], node->r[1]);
				break;
		}
	NEXTNODE(node)

	FORALLELMTS(elmt)
		if(!elmt->show)
			continue;
		for(ineigh=0; ineigh<3; ineigh++){
			if(elmt->eneigh[ineigh]->show)
				continue;
			node  = elmt->nneigh[(ineigh+2)%3];
			nodec = elmt->nneigh[(ineigh+1)%3];
			fprintf(out, "B %d %d %%\n", node->nodenum, nodec->nodenum);
		}
	NEXTELMT(elmt)

	FORALLELMTS(elmt)
		if(!elmt->show)
			continue;
		fprintf(out, "E ");
		for(i=0; i<3; i++)
			fprintf(out, "%d ", elmt->nneigh[i]->nodenum);
		fprintf(out, " %%\n");
	NEXTELMT(elmt)
}
