/* 
 * User level clipping interface. If the device can do clipping in
 * hardware then DO NOT set _g_softclip.
*/
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif
void _setclip(),_endclip();

void setclip(l, b, r, t)
         Coord l, b, r, t;
{
    struct _vptab *thisvp;

    thisvp = &IND(vptab[IND(cvport)]);
    thisvp->clipwin[0] = l;
    thisvp->clipwin[1] = b;
    thisvp->clipwin[2] = r;
    thisvp->clipwin[3] = t;
/*
 * The called function is responsible for setting
 * one of "clip" or "softclip".
 */
    if(_plx_curdev->setclip != 0) {
        INVOKE(setclip)(l,b,r,t);
    }
    else {
	_setclip(l, b, r, t);
	IND(clip) = 1;
	IND(softclip) = 1;
    }
    return;
}

void endclip()
{
    if(_plx_curdev->endclip != 0) {
        INVOKE(endclip)();
    }
    else _endclip();

    IND(softclip) = 0;
    IND(clip) = 0;
}

void _getclip(pcoord)
     Coord *pcoord;
{
    struct _vptab *thisvp;

    thisvp = &IND(vptab[IND(cvport)]);
    pcoord[0] = thisvp->clipwin[0];
    pcoord[1] = thisvp->clipwin[1];
    pcoord[2] = thisvp->clipwin[2];
    pcoord[3] = thisvp->clipwin[3];
    return;
}

#ifdef _3L
void ksetcl(l, b, r, t)
    float *l ,*b, *r, *t;
{
    setclip((Coord)*l, (Coord)*b, (Coord)*r, (Coord)*t);
    return;
}

void kendcl()
{
    endclip();
    return;
}
#endif		/* _3L */

#if COMPILER == SUNF77
void ksetcl_(l, b, r, t)
    float *l ,*b, *r, *t;
{
    setclip((Coord)*l, (Coord)*b, (Coord)*r, (Coord)*t);
    return;
}

void kendcl_()
{
    endclip();
    return;
}
#endif		/* SUNF77 */
