/**********
* devlist *
***********

This file contains a list of supported devices on each of the
supported systems. It can be overridden by the user by merely
supplying a variable of the same name.
*/

/*
 * Copyright ParaSoft Corporation, 1990.
 */
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/plotix.h"
#include "sys/config.h"
#endif

/*
 * Devices supported on this system, together with their abreviations.
 */
#ifdef DEVIND
PLOTIX_DEVS plx_devlist[] = {PLX_NOD, PLX_NUL};
#define SKIP_DEFAULT
#else


#if H_OPSYS == DOS
#ifdef NEC98
PLOTIX_DEVS plx_devlist[] = {PLX_NEC, PLX_PS, PLX_NUL};
#else
#ifdef MSWINDOWS
PLOTIX_DEVS plx_devlist[] = {PLX_MSW, PLX_PS, PLX_NUL};
#else
PLOTIX_DEVS plx_devlist[] = {PLX_BGI, PLX_PS, PLX_NUL};
#endif
#endif

#define SKIP_DEFAULT
#endif

#if H_OPSYS == MPW
PLOTIX_DEVS plx_devlist[] = {PLX_MAC, PLX_PS, PLX_NUL};
#define SKIP_DEFAULT
#endif

#if H_OPSYS == XENIX
PLOTIX_DEVS plx_devlist[] = {PLX_X, PLX_NUL};
#define SKIP_DEFAULT
#endif

#ifndef SKIP_DEFAULT
PLOTIX_DEVS plx_devlist[] = {PLX_X, PLX_NUL};
/*PLOTIX_DEVS plx_devlist[] = {PLX_X, PLX_PS, PLX_SUN, PLX_NUL};*/
#endif
#endif			/* DEVIND */

#ifdef MSWINDOWS	/* Compiler doesn't like files with no code */
void _plx_dummy()
{
    return;
}
#endif
