/*********
 * marker *              J.W.Flower   Sept. 1985
 **********
 
 Draws a marker at the point x,y with size 'size'.
 Current supported markers are :
 
 mkr = 
 0 : point
 1 : diamond
 2 : square
 3 : triangle
 4 : inverted triangle
 5 : cross
 6 : plus
 7 : star
 */
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif
#define NUMMKR  8       /* Total number of markers */

void marker(mkr,x,y,m_size)
     Coord x,y,m_size;
     int mkr;
{
    Coord x0,x1,y0,y1;
    
    switch(mkr % NUMMKR) {
    case 0:                         /* No symbol */
	if(IND(softclip) && !_pointclip(x,y)) 
	    return; /* Clipped */
	INVOKE(point)(x,y);
	move(x, y);
	break;
	
	/* The following marker symbols get clipped by 'move' and 'cont' */
    case 1 :                        /* Diamond */
	x0 = x - .5*m_size;
	x1 = x + .5*m_size;
	y0 = y - .5*m_size;
	y1 = y + .5*m_size;
	
	move(x0,y);
	cont(x,y1);
	cont(x1,y);
	cont(x,y0);
	cont(x0,y);
	
	break;
    case 2 :                        /* Square */
	x0 = x - .3536*m_size;
	x1 = x + .3536*m_size;
	y0 = y - .3536*m_size;
	y1 = y + .3536*m_size;
	
	move(x0,y0); cont(x1,y0);
	cont(x1,y1); cont(x0,y1);
	cont(x0,y0);
	
	break;
    case 3 :                        /* Triangle */
	x0 = x - .433*m_size;
	x1 = x + .433*m_size;
	y0 = y - .25*m_size;
	y1 = y + .5*m_size;
	
	move(x0,y0); cont(x1,y0);
	cont(x,y1); cont(x0,y0);
	
	break;
    case 4 :                        /* Inverted triangle */
	x0 = x - .433*m_size;
	x1 = x + .433*m_size;
	y0 = y - .5*m_size;
	y1 = y + .25*m_size;
	
	move(x0,y1); cont(x1,y1);
	cont(x,y0); cont(x0,y1);
	
	break;
    case 5 :                        /* Cross */
	x0 = x - .3536*m_size;
	x1 = x + .3536*m_size;
	y0 = y - .3536*m_size;
	y1 = y + .3536*m_size;
	
	move(x0,y0); cont(x1,y1);
	move(x0,y1); cont(x1,y0);
	
	break;
    case 6 :                        /* Plus */
	x0 = x - .5*m_size;
	x1 = x + .5*m_size;
	y0 = y - .5*m_size;
	y1 = y + .5*m_size;
	
	move(x,y0); cont(x,y1);
	move(x0,y); cont(x1,y);
	
	break;
    case 7 :                        /* Star = Cross + plus */
	x0 = x - .5*m_size;
	x1 = x + .5*m_size;
	y0 = y - .5*m_size;
	y1 = y + .5*m_size;
	
	move(x,y0); cont(x,y1);
	move(x0,y); cont(x1,y);
	
	x0 = x - .3536*m_size;
	x1 = x + .3536*m_size;
	y0 = y - .3536*m_size;
	y1 = y + .3536*m_size;
	
	move(x0,y0); cont(x1,y1);
	move(x0,y1); cont(x1,y0);
	
	break;
    default:
	    break;
    }
    
    /* Now restore current coords... */
    
    move(x,y);
    return;
}

/*
 * Draw the "unofficial" ParaSoft logo in the indicated box.
 */
static void mk_node(atx, aty, delx, dely)
     Coord atx, aty, delx, dely;
{
    box(atx-delx, aty-dely, atx+delx, aty+dely, 0, 1);
    return;
}

#define LOGO_X(fac)	(x0 + fac*boxwid)
#define LOGO_Y(fac)	(y0 + fac*boxht)

exlogo(x0, y0, x1, y1)
     Coord x0, y0, x1, y1;
{
    Coord boxwid, boxht;
    boxwid = (x1 - x0)/10.;
    boxht  = (y1 - y0)/10.;
/*
 * First draw the links.
 */
    move(LOGO_X(1.0), LOGO_Y(1.0)); 
    cont(LOGO_X(1.0), LOGO_Y(9.0));
    cont(LOGO_X(9.0), LOGO_Y(9.0));
    cont(LOGO_X(9.0), LOGO_Y(1.0));
    cont(LOGO_X(1.0), LOGO_Y(1.0));

    move(LOGO_X(2.5), LOGO_Y(3.5)); 
    cont(LOGO_X(3.5), LOGO_Y(7.5));
    cont(LOGO_X(7.5), LOGO_Y(6.5));
    cont(LOGO_X(6.5), LOGO_Y(2.5));
    cont(LOGO_X(2.5), LOGO_Y(3.5));

    move(LOGO_X(1.0), LOGO_Y(1.0)); cont(LOGO_X(6.5), LOGO_Y(2.5));
    move(LOGO_X(1.0), LOGO_Y(9.0)); cont(LOGO_X(2.5), LOGO_Y(3.5));
    move(LOGO_X(9.0), LOGO_Y(9.0)); cont(LOGO_X(3.5), LOGO_Y(7.5));
    move(LOGO_X(9.0), LOGO_Y(1.0)); cont(LOGO_X(7.5), LOGO_Y(6.5));
/*
 * Draw the "nodes".
 */
    mk_node(x0+1.0*boxwid, y0+1.0*boxht, boxwid, boxht);
    mk_node(x0+1.0*boxwid, y0+9.0*boxht, boxwid, boxht);
    mk_node(x0+9.0*boxwid, y0+1.0*boxht, boxwid, boxht);
    mk_node(x0+9.0*boxwid, y0+9.0*boxht, boxwid, boxht);

    mk_node(x0+2.5*boxwid, y0+3.5*boxht, boxwid, boxht);
    mk_node(x0+3.5*boxwid, y0+7.5*boxht, boxwid, boxht);
    mk_node(x0+7.5*boxwid, y0+6.5*boxht, boxwid, boxht);
    mk_node(x0+6.5*boxwid, y0+2.5*boxht, boxwid, boxht);
    return;
}

#ifdef _3L
kmarke(mkr,x,y,m_size)
     int *mkr;
     float *x, *y, *m_size;
{
    marker(*mkr, (Coord)*x, (Coord)*y, (Coord)*m_size);
}

#endif          /* _3L */

#if COMPILER == SUNF77
kmarke_(mkr,x,y,m_size)
     int *mkr;
     float *x, *y, *m_size;
{
    marker(*mkr, (Coord)*x, (Coord)*y, (Coord)*m_size);
}

#endif          /* SUNF77 */
