/*********
* openpl *
**********

Initialize graphics system.
*/
#include <stdio.h>
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif

static int do_openpl();	/* Prototype */

int openpl(bufsiz, fp)
     int bufsiz;
     FILE *fp;
{
    return do_openpl((char *)0, bufsiz, fp);
}


static int do_openpl(user_buf, bufsiz, fp)
     char *user_buf;
     int bufsiz;
     FILE *fp;
{
    int stat;
/*
 * Start up the system. Check to see if any device has been 
 * allocated and, if not, allocate the default device.
 */
#ifdef PLX_DEBUG
     _ex_print("Entering generic openpl\n");
#endif
    if(_plx_curdev == (struct _plx_ind *)0) {
#ifdef PLX_DEBUG
        _ex_print("Making a new current device\n");
#endif
	stat = make_display((char *)0);
	if(stat < 0) return stat;
    }

#ifdef PLX_DEBUG
     _ex_print("Calling device's openpl\n");
#endif
    if(user_buf == (char *)0)			/* C */
        stat = INVOKE(openpl)(bufsiz, fp);
    else					/* FORTRAN */
	stat = INVOKE(kopenp)(bufsiz, user_buf);
    if(stat < 0) {
#ifdef PLX_DEBUG
         _ex_print("Device's openpl failed.\n");
#endif
	return stat;
    }
/*
 * By this time we need to have the sizes set up. This is really
 * a system programmers responsibility but it's convenient to
 * check here since it's so crucial.
 */
    if(IND(devx) == (Coord)0 || IND(devy) == (Coord)0) return -1;

    IND(softclip) = 0;
    IND(clip) = 0;
    IND(open) = 1;

/* Set up vport #0 to be the whole screen with unit coordinate range */

    vport((Coord)0,(Coord)0,(Coord)1,(Coord)1);
    space((Coord)0,(Coord)0,(Coord)1,(Coord)1);

    color(1);
    linemod(0);         /* Solid lines */
    erase();
    return 1;
}

int aopenpl(bufsiz, fp)
     int bufsiz;
     FILE *fp;
{
    IND(_plx_mode) = PLX_ASYNC;
    return openpl(bufsiz, fp);
}

#ifdef _3L
int kopenp(buffer, size)
     char *buffer;
     int *size;
{
    return do_openpl(buffer, *size, (FILE *)0);
}

int kaopen(buffer, size)
     int *size;
{
    IND(_plx_mode) = PLX_ASYNC;
    return kopenp(buffer, size);
}
#endif		/* _3L */

#if COMPILER == SUNF77
int kopenp_(buffer, size)
     char *buffer;
     int *size;
{
    return do_openpl(buffer, *size, (FILE *)0);
}

int kaopen_(buffer, size)
     int *size;
{
    IND(_plx_mode) = PLX_ASYNC;
    return kopenp_(buffer, size);
}
#endif		/* SUNF77 */
