/********
* panel *               Roy Williams  1986
*********

Routines to draw panels, polygons etc.........
*/
#include "plotix.h"
#ifdef isMPW
#define __SEG__ PLOTIX
#include <:sys:config.h>
#include <:sys:plotix.h>
#else
#include "sys/config.h"
#include "sys/plotix.h"
#endif

void initpanel(color, edge)
int color;
int edge;
{
    if(IND(softclip))
        c_initpanel(color, edge);
    else
        INVOKE(initpanel)(color, edge);
}

void panelpoint(x, y)
Coord x, y;
{
    if(IND(softclip))
        c_panelpoint(x, y);
    else
        INVOKE(panelpoint)(x, y);
}

void endpanel()
{
    if(IND(softclip))
        c_endpanel();
    else
        INVOKE(endpanel)();
}

void polgn(num, x, y, color, edge)
     int num, color, edge;
     Coord *x, *y;
{
    int i;

    if(_plx_curdev->polgn != 0) {
        INVOKE(polgn)(num, x, y, color, edge);
    }
    else {
	initpanel(color, edge);
	for(i=0; i<num; i++) panelpoint(x[i], y[i]);
	endpanel();
    }
    return;
}

void box(x0, y0, x1, y1, shade, edge)
     Coord x0, y0, x1, y1;
     int shade, edge;
{
    if(_plx_curdev->box != 0) {
        INVOKE(box)(x0, y0, x1, y1, shade, edge);
    }
    else {
	initpanel(shade, edge);
	panelpoint(x0, y0);
	panelpoint(x0, y1);
	panelpoint(x1, y1);
	panelpoint(x1, y0);
	endpanel();
    }
    return;
}

#ifdef _3L
kinitp(color, edge)
     int *color, *edge;
{
    initpanel(*color, *edge);
}

kpanlp(x, y)
     float *x, *y;
{
    panelpoint((Coord)*x, (Coord)*y);
}

kendpa()
{
    endpanel();
}

kpolgn(num, x, y, color, edge)
     int *num, *color, *edge;
     float *x, *y;
{
    polgn(*num, (Coord)*x, (Coord)*y, *color, *edge);
}

kbox(x0, y0, x1, y1, shade, edge)
    float *x0, *y0, *x1, *y1;
    int *shade, *edge;
{
    box((Coord)*x0, (Coord)*y0, (Coord)*x1, (Coord)*y1, *shade, *edge);
}

#endif          /* _3L */

#if COMPILER == SUNF77
kinitp_(color, edge)
     int *color, *edge;
{
    initpanel(*color, *edge);
}

kpanlp_(x, y)
     float *x, *y;
{
    panelpoint((Coord)*x, (Coord)*y);
}

kendpa_()
{
    endpanel();
}

kpolgn_(num, x, y, color, edge)
     int *num, *color, *edge;
     float *x, *y;
{
    polgn(*num, (Coord)*x, (Coord)*y, *color, *edge);
}

kbox_(x0, y0, x1, y1, shade, edge)
    float *x0, *y0, *x1, *y1;
    int *shade, *edge;
{
    box((Coord)*x0, (Coord)*y0, (Coord)*x1, (Coord)*y1, *shade, *edge);
}

#endif          /* SUNF77 */

