#include "dime.h"
#define CODE_3D
#include "3d.h"
/*
#include "../string.h"
*/

double rotmat[3][3] = {1.,0.,0., 0.,1.,0., 0.,0.,1.};
double range = 5.;
double light[3] = {0.66666, 0.66666, 0.33333};
int needs_sort = 1;

get_range()
{
	printf("Range = %f, new value?\n", range);
	get_double(&range);
	needs_sort = 1;
}

rotate()
{
	double s, c, yth, zth, rotmat_temp[3][3];
	int i, j;
	NODEPTR node;
	ELMTPTR elmt;
	needs_sort = 1;
	get_polars(&yth, &zth);
	if(yth > 0.9999)
		yth = 0.5*PI;
	else
		yth = asin(yth);


	s = sin(zth);
	c = cos(zth);
	for(i=0; i<3; i++){
		rotmat_temp[0][i] =  c*rotmat[0][i] + s*rotmat[1][i];
		rotmat_temp[1][i] = -s*rotmat[0][i] + c*rotmat[1][i];
		rotmat_temp[2][i] =                               rotmat[2][i];
	}
	for(i=0; i<3; i++)
		for(j=0; j<3; j++)
			rotmat[i][j] = rotmat_temp[i][j];

	s = sin(yth);
	c = cos(yth);
	for(i=0; i<3; i++){
		rotmat_temp[0][i] =  c*rotmat[0][i]             -s*rotmat[2][i];
		rotmat_temp[1][i] =                 rotmat[1][i];
		rotmat_temp[2][i] =  s*rotmat[0][i]             +c*rotmat[2][i];
	}
	for(i=0; i<3; i++)
		for(j=0; j<3; j++)
			rotmat[i][j] = rotmat_temp[i][j];

	s = sin(zth);
	c = cos(zth);
	for(i=0; i<3; i++){
		rotmat_temp[0][i] =  c*rotmat[0][i] - s*rotmat[1][i];
		rotmat_temp[1][i] =  s*rotmat[0][i] + c*rotmat[1][i];
		rotmat_temp[2][i] =                               rotmat[2][i];
	}
	for(i=0; i<3; i++)
		for(j=0; j<3; j++)
			rotmat[i][j] = rotmat_temp[i][j];

	reset_3d();
}

do_rotation()
{
	NODEPTR node;
	ELMTPTR elmt;
	int i, sid;
	double fac, vis;

	FORALLNODES(node)
		for(i=0; i<3; i++)
			node->user->node3d.viewpos[i] =  
				rotmat[i][0]*node->XG +
				rotmat[i][1]*node->YG +
				rotmat[i][2]*node->ZG;
		fac = 1./(1.-node->ZV/range);
		node->XV *= fac;
		node->YV *= fac;
	NEXTNODE(node)
		
	FORALLELMTS(elmt)
		vis =  rotmat[2][0]*elmt->user->elmt3d.area[0]
			 + rotmat[2][1]*elmt->user->elmt3d.area[1]
			 + rotmat[2][2]*elmt->user->elmt3d.area[2];
		elmt->user->elmt3d.visible = (vis > 0.0);

		elmt->user->elmt3d.z = 
			(elmt->neigh[0]->ZV + 
			 elmt->neigh[1]->ZV + 
			 elmt->neigh[2]->ZV)/3;
	NEXTELMT(elmt)
}

render()
{
	int compar(), i;
	ELMTPTR list_sort(), elmt;
	NODEPTR node;
	double xmin, ymin, xmax, ymax, xd, yd, xorg, yorg, scale;
	double ax, ay, az, bx, by, bz, shade, varea[3], x, y;

	reset_3d();
	disp_erase();

	FORALLELMTS(elmt)
/*
		if(!elmt->user->elmt3d.visible)
			continue;
*/
		shade = 0.0;
		ax = elmt->neigh[1]->XV - elmt->neigh[0]->XV;
		bx = elmt->neigh[2]->XV - elmt->neigh[0]->XV;
		ay = elmt->neigh[1]->YV - elmt->neigh[0]->YV;
		by = elmt->neigh[2]->YV - elmt->neigh[0]->YV;
		az = elmt->neigh[1]->ZV - elmt->neigh[0]->ZV;
		bz = elmt->neigh[2]->ZV - elmt->neigh[0]->ZV;
		varea[0] = ay*bz - az*by;
		varea[1] = az*bx - ax*bz;
		varea[2] = ax*by - ay*bx;
		for(i=0; i<3; i++)
			shade += light[i]*varea[i];
		shade /= sqrt(varea[0]*varea[0] + varea[1]*varea[1] + varea[2]*varea[2]);
		shade = 0.5*(1-shade)*(BLACK-WHITE) + WHITE;
		initpanel((int)(shade), 1);
		for(i=0; i<3; i++){
			panelpoint(elmt->neigh[i]->XV, elmt->neigh[i]->YV);
		}
		endpanel();
	NEXTELMT(elmt)

	if(mesh_is_distributed)
		usendplot();
	else
		sendplot();
}

contor3d(func, nlevel)
/*
    Using color 'shade', do a pressure contour plot with 'nlevel'
    contour levels, spaced equally from the minimum to maximum pressure.
*/
double (*func)();
int nlevel;
{
    ELMTPTR elmt;
    NODEPTR node;
    double f[3], minlocal, maxlocal, Min, Max;
    int i, imin, imax;

	reset_3d();
	disp_erase();

    Max = -1.e20;
    Min = 1.e20;
    fmulti(stdout);
	FORALLNODES(node)
		if((*func)(node) > Max)    Max = (*func)(node);
		if((*func)(node) < Min)    Min = (*func)(node);
	NEXTNODE(node)

    combine(&Max, fmax, sizeof(double), 1);
    combine(&Min, fmin, sizeof(double), 1);
	if(Max - Min < 1.e-8)
		return;

	FORALLELMTS(elmt)
/*
		if(!elmt->user->elmt3d.visible)
			continue;
*/
		minlocal = maxlocal = f[0] = (*func)(elmt->neigh[0]);
		for(i=1; i<3; i++){
			f[i] = (*func)(elmt->neigh[i]);
			if(f[i] < minlocal) minlocal = f[i]; 
			if(f[i] > maxlocal) maxlocal = f[i];
		}
		if(minlocal < Min) minlocal = Min;
		if(maxlocal > Max) maxlocal = Max;
		imin = nlevel*(minlocal - Min)/(Max - Min);
		imax = nlevel*(maxlocal - Min)/(Max - Min);
		for(i=imin; i<= imax; i++)
			contor_an_elmt(elmt, Min + i*(Max-Min)/nlevel, f, 
				(int)(0.6*i*(RAINEND-RAINSTART)/nlevel + RAINSTART));

		color(1);
		move(elmt->neigh[2]->XV, elmt->neigh[2]->YV);
		for(i=0; i<3; i++)
			cont(elmt->neigh[i]->XV, elmt->neigh[i]->YV);
		if(!mesh_is_distributed)
			sendplot();
	NEXTELMT(elmt)
	if(mesh_is_distributed)
		usendplot();
	else
		sendplot();
}

contor_an_elmt(elmt, level, f, shade)
/*
    As above, but only for a single elmt. 'f' are the pressure values
    at the 3 neighboring nodes of the elmt.
*/
struct elmt *elmt;
double level, f[3];
int shade;
{
    int ou, nu, i, i1, first = 1;
    double zz, xx, yy;
    nu = (f[0] > level);
    for(i=0; i<3; i++){
        ou = nu;
        i1 = (i+1)%3;
        nu = (f[i1] > level);
        if(ou ^ nu){
            zz = (level - f[i])/(f[i1] - f[i]);
            xx = zz*elmt->neigh[i1]->XV + (1-zz)*elmt->neigh[i]->XV;
            yy = zz*elmt->neigh[i1]->YV + (1-zz)*elmt->neigh[i]->YV;
            if(first){
                first = 0;
                initpanel(shade, 0);
            }
            panelpoint(xx, yy);
        }
        if(nu){
            if(first){
                first = 0;
                initpanel(shade, 0);
            }
            panelpoint(elmt->neigh[i1]->XV, elmt->neigh[i1]->YV);
        }
    }
    if(!first)
		endpanel();
}

#define M_PI			3.1415926536

curvature()
{
	double angle();
	contor3d(angle, 16);
}

double angle(basis)
NODEPTR basis;
{
	NODENEIGHPTR n, nstart;
	double cc, c[3], dot, *a, *an;
	double br[3], nr[3], angle = 0;
	NODEPTR noden;
	ELMTPTR elmt;

	n = nstart = basis->n;
	get_3d_coords(basis, br);

	do {
		a = n->elmt->user->elmt3d.area;
		an = n->next->elmt->user->elmt3d.area;
		get_3d_coords(n->elmt->neigh[(indexc(n->elmt, basis)+2)%3], nr);
		c[0] = a[1]*an[2] - a[2]*an[1];
		c[1] = a[2]*an[0] - a[0]*an[2];
		c[2] = a[0]*an[1] - a[1]*an[0];
		dot = c[0]*(br[0]-nr[0]) + 
			  c[1]*(br[1]-nr[1]) + 
			  c[2]*(br[2]-nr[2]);
		cc = sqrt(c[0]*c[0] + c[1]*c[1] + c[2]*c[2]);
		if(dot > 0.0)
			angle += asin(cc);
		else
			angle -= asin(cc);
	} while((n = n->next) != nstart);
	return(0.5 + angle/(4*M_PI));
}
