#ifndef CUBIX
#include "dime.h"
#define CODE_3D
#include "3d.h"
/*
#include "../string.h"
*/
#include <sys/file.h>
#define NODENO      work_space.ni[0]
#endif

write_taac()
{
#ifndef CUBIX
	int nnode = 0, nelmt = 0, fd, ibuf[4], i, ncopy;
	double norm[3], ri, rcm[3], rmax;
	char filename[60];
	ELMTPTR elmt;
	NODEPTR node;

	printf("Taac filename please?\n");
	get_string(filename);
	if((fd = open(filename, O_WRONLY | O_CREAT, 0644)) == -1){
		printf("Cannot create %s\n");
		return;
	}

	for(i=0; i<3; i++)
		rcm[i] = 0.0;

	FORALLNODES(node)
		node->NODENO = nnode++;
		for(i=0; i<3; i++){
			ri = node->user->node3d.coord[i];
			rcm[i] += ri;
		}
	NEXTNODE(node)

	for(i=0; i<3; i++)
		rcm[i] /= nnode;
	rmax = 0.0;
	FORALLNODES(node)
		for(i=0; i<3; i++){
			ri = node->user->node3d.coord[i];
			if(fabs(ri - rcm[i]) > rmax)
				rmax = fabs(ri - rcm[i]);
		}
	NEXTNODE(node)

	write(fd, &nnode, sizeof(int));
	ibuf[3] = 1;
	FORALLNODES(node)
		for(i=0; i<3; i++)
			ibuf[i] = 256*((node->user->node3d.coord[i] - rcm[i])/rmax);
		write(fd, ibuf, 4*sizeof(int));
	NEXTNODE(node)

	write(fd, &nnode, sizeof(int));

	FORALLNODES(node)
		for(i=0; i<3; i++)
			norm[i] = 0.0;

		ncopy = 0;
		FORALLNEIGH(node, elmt)
			ncopy++;
			for(i=0; i<3; i++)
				norm[i] += elmt->user->elmt3d.area[i];
		NEXTNEIGH(node, elmt)

		for(i=0; i<3; i++)
			ibuf[i] = 8192*(norm[i]/ncopy);
		write(fd, ibuf, 4*sizeof(int));
	NEXTNODE(node)

	FORALLELMTS(elmt)
		nelmt++;
	NEXTELMT(elmt)
	ibuf[0] = 1 + 4*nelmt;
	ibuf[1] = nelmt;
	write(fd, ibuf, 2*sizeof(int));

	ibuf[0] = 3;
	FORALLELMTS(elmt)
		for(i=0; i<3; i++)
			ibuf[i+1] = 4*elmt->neigh[i]->NODENO;
		write(fd, ibuf, 4*sizeof(int));
	NEXTELMT(elmt)

	close(fd);
#endif
}
