#include <math.h>
#include <fcntl.h>
#include <stdio.h>

#define	MULT	1103515245
#define	ADD 	12345
#define	MASK	( 0x7fffffff )
#define	TWOTO31	( (double)MASK + 1.0 )
long	AAA;	/* multiplier */
long	BBB;	/* summand    */
long	randx;	/* last value */

extern double lambdaE, lambdaA;
extern int nnode, dim;

pranset(_s_eed)
long   _s_eed;
{

	AAA = MULT & MASK ;
	BBB = ADD  & MASK ;

	randx = (AAA*_s_eed + BBB) & MASK;
	
}

double pranf()
/*
	Return a random double in [0, 1.0)
*/
{
	double retvalue;

	retvalue=randx / TWOTO31;
	randx = (AAA*randx + BBB)& MASK;
	return( retvalue );
}
normal(r1, r2)
double  *r1, *r2;       /* Output, they are normally distributed, with sigma=1 */
/*
	This is the Polar method for normal distributions, as described on or near
page 104 of Knuth, Semi-numerical Algorithms.  To quote Knuth, "The polar
method is quite slow, but it has essentially perfect accuracy, and it is very
easy to write a program for the polar method..."  'nuf said.  Algorithm due
to Box, Muller and Marsaglia.
*/
{
	double v1, v2; /* uniformly distributed on [-1, 1) */
	double s;      /* radius of a point pulled from a uniform circle */
	double foo;    /* A useful intermediate value. */
	double pranf();

	do{
		v1 = 2.0 * pranf()- 1.0;
		v2 = 2.0 * pranf()- 1.0;
		s = v1*v1 + v2*v2;
	} while(s >= 1.0);
	foo = sqrt( -2.0 * log(s)/s);
	*r1 = v1 * foo;
	*r2 = v2 * foo;
}

setseed()
{
  FILE *fp,*fopen() ;
  int seed,mode,i ;
	char filename[50];
	if(lambdaE == 0.0)
		sprintf(filename, "N%d/seedA%4.3f_%d", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/seedE%4.3f_%d", nnode, lambdaE, dim);

  printf("Select mode of seed setting: \n");
  printf("0  <->  by hand\n");
  printf("1  <->  read in from file called '%s'\n",filename);
  /*
  scanf("%d",&mode);
  */
  get_int(&mode);

  if ( mode == 0 ) {
    printf("Input seed ");
	/*
    scanf("%d",&seed);
    printf("%d\n",seed);
	*/
	get_int(&seed);
    pranset(seed);
  }  
  else {
    if( (fp = fopen(filename,"r")) == NULL) {
      printf("Couldn't find file called '%s'\n",filename) ;
      exit(1);
    }
    fscanf(fp,"%d",&seed);
    fclose(fp) ; 
    printf("%d\n",seed);
    pranset(seed);
  }
  printf("seed set\n");
  return(0) ;
}

dmpseed()
{
  FILE *fp,*fopen() ;
	char filename[50];
	if(lambdaE == 0.0)
		sprintf(filename, "N%d/seedA%4.3f_%d", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/seedE%4.3f_%d", nnode, lambdaE, dim);

  fp = fopen(filename,"w") ;
    fprintf(fp,"%d",randx);
  fclose(fp) ;
  printf("Dumped randx to file called '%s'\n",filename) ;
  return(0) ;
}
