#include <stdio.h>
#include <math.h>
#include "menu.h"
#include "gr_prim.h"

extern int pixport, menuport, monitorport;
extern double menu_width, z_xmin, z_ymin, z_xmax, z_ymax;
extern int graphics;

#define PI	3.1415927

MNUPTR Root, current_menu = (MNUPTR)NULL;
FILE *logfp = (FILE *)NULL, *infp = stdin;

menu_include()
{
	char batchfile[50];
	printf("Include file? "); fflush(stdout);
	fscanf(infp, "%s", batchfile);
	menu_includefile(batchfile);
}

menu_includefile(batchfile)
char *batchfile;
{
	infp = fopen(batchfile, "r");
	if(infp == (FILE *)NULL)
		printf("Cannot open %s\n", batchfile);fflush(stdout);
}

menu_record()
{
	char file[50];
	if(logfp != NULL){
		printf("Log file already activated\n");
		return;
	}
	printf("Log file name? "); fflush(stdout);
	get_string(file);
	if(infp != stdin){
		printf("Cannot log from command file\n");
		return;
	}
	logfp = fopen(file, "w");
	if(logfp == (FILE *)NULL)
		printf("Cannot open %s\n", file);fflush(stdout);
}

menu_end_record()
{
	if(logfp == (FILE *)NULL){
		printf("No log file open\n");
		return;
	}
	fclose(logfp);
	logfp = (FILE *)NULL;
}

get_double(f)
double *f;
{
	fscanf(infp, "%lf", f);
	printf("%f\n", *f);fflush(stdout);
	if(logfp != (FILE *)NULL){
		fprintf(logfp, "%f\n", *f);
		fflush(logfp);
	}
}

get_int(f)
int *f;
{
	fscanf(infp, "%d", f);
	printf("%d\n", *f);fflush(stdout);
	if(logfp != (FILE *)NULL){
		fprintf(logfp, "%d\n", *f);
		fflush(logfp);
	}
}

get_string(s)
char *s;
{
	fscanf(infp, "%s", s);
	if(logfp != (FILE *)NULL){
		fprintf(logfp, "%s\n", s);
		fflush(logfp);
	}
}

