#ifdef MAIN
#define EXTERN 
#else
#define EXTERN extern
#endif

/* definitions */

#define MAXDIM		4
#define MAXNEIGH	128
#define NOBS		6

#define LARGE		1.e25
#define SMALL		1.e-25

struct user_node {
	double r[MAXDIM];
	double gauss_action;
	double area_action;
	double edge_action;
	int nneigh;
};

struct user_bdy	{
	double unused;
};

struct user_elmt {
	double area;
	double edge_sq[3];
	double alt_sq[3];
	double h[MAXDIM][3];
};

extern int dim;
extern int nnode;
extern double temp, alpha, lambdaA, lambdaE;

#define GAUSS		act[0]
#define LN_W		act[1]
#define AREA_CURVE	act[2]
#define EDGE_CURVE	act[3]
#define X2		act[4]
#define NNEIGH		act[5]

#define GAUSS2		act2[0]
#define LN_W2		act2[1]
#define AREA_CURVE2	act2[2]
#define EDGE_CURVE2	act2[3]
#define X22		act2[4]
#define NNEIGH2		act2[5]

#define BINGAUSS		bin_ave[0]
#define BINLN_W			bin_ave[1]
#define BINAREA_CURVE		bin_ave[2]
#define BINEDGE_CURVE		bin_ave[3]
#define BINX2			bin_ave[4]
#define BINNNEIGH		bin_ave[5]

#define BINGAUSS2		bin_ave2[0]
#define BINLN_W2		bin_ave2[1]
#define BINAREA_CURVE2		bin_ave2[2]
#define BINEDGE_CURVE2		bin_ave2[3]
#define BINX22			bin_ave2[4]
#define BINNNEIGH2		bin_ave2[5]

#define AVEGAUSS		tot_ave[0]
#define AVELN_W			tot_ave[1]
#define AVEAREA_CURVE		tot_ave[2]
#define AVEEDGE_CURVE		tot_ave[3]
#define AVEX2			tot_ave[4]
#define AVENNEIGH		tot_ave[5]

#define AVEGAUSS2		tot_ave2[0]
#define AVELN_W2		tot_ave2[1]
#define AVEAREA_CURVE2		tot_ave2[2]
#define AVEEDGE_CURVE2		tot_ave2[3]
#define AVEX22			tot_ave2[4]
#define AVENNEIGH2		tot_ave2[5]


/* string */

extern double pranf();
#define RAN		((double)pranf())

#define SWEEPSPERWRITE 100

#define BINSIZE        10	/* SWEEPSPERPRINT */

EXTERN double bin_ave[NOBS+2];
EXTERN double bin_ave2[NOBS+2];
EXTERN double tot_ave[NOBS+2];
EXTERN double tot_ave2[NOBS+2];
EXTERN double act[NOBS+2];
EXTERN double act2[NOBS+2];

extern MNUPTR root;
#ifdef MAIN
int nnn = 1;
int dim =3;
long nproc = 1;
double hit_size = 0.5;
FILE *out = NULL;
#else
EXTERN int nnn;
EXTERN int dim;
EXTERN long nproc;
EXTERN double hit_size;
EXTERN FILE *out;
#endif

extern int nnode;
extern int procnum;
EXTERN double lambdaA, lambdaE, tot_action;
EXTERN double metro_success, flip_success;


/* dime_string */

EXTERN NODEPTR metro_victim;

EXTERN NODEPTR A, B, C, D;
EXTERN ELMTPTR ABC, ACD;

EXTERN struct user_node oldnode;
EXTERN struct user_elmt oldelmtbuf[MAXNEIGH];
EXTERN struct user_node oldnodebuf[MAXNEIGH];

EXTERN int nnode;
