/*********
* dotext *                J.W.Flower   Dec 1986
**********

This routine writes graphical text at position (x,y) with the justification
according to the ljust and hjust flags which are set as

        ljust = -1      string to right of 'dot'
                 0      string centered on 'dot'
                 1      string to left  of 'dot'

        hjust = -1      string above 'dot'
                 0      string centered on 'dot'
                 1      string below 'dot'

*/
#include "plotix.h"
#include "sys/plotix.h"
#include "xplot.h"

void dotext(string, x, y, angle, ljust, hjust)
char *string;
Coord x, y;
int ljust, hjust, angle;
{
    int x_curr,y_curr,high,wide,length,dummy;
    XCharStruct temp;

    XSetForeground(display,gc,_g_cmap[1]);   /* Black */
    x_curr = (int) USER_to_X(x);
    y_curr = (int) USER_to_Y(y);
    length = strlen(string);
    XTextExtents(_g_font,string,length,&dummy,&dummy,&dummy,&temp);
    high = temp.ascent+temp.descent;
    wide = temp.width;

    if (ljust == 0)     x_curr -= (wide >> 1);
    else if (ljust > 0) x_curr -= wide;

    if (hjust == 0)     y_curr += (high >> 1);
    else if (hjust > 0) y_curr += high;

    XDrawString(display,_g_win,gc,x_curr,y_curr,string,length);
    XSetForeground(display,gc,_g_cmap[_g_fgcolor]);
}
