/**********
* linemod *             J.W.Flower, ParaSoft Corporation, April 1989
***********
 
Generate a different linestyle.
0 -----------------------------   Solid
1 -   -   -   -   -   -           Dotted
2 ----   -   ----   -             Dot-Dashed
3 ----    ----    ----    ----    Short-Dashed
4 -------    -------    -------   Long-Dashed
5 --   -  --- --   -  --- --      Odd-Dashed
*/
#include "plotix.h"
#include "sys/plotix.h"
#include "xplot.h"

void linemod(style)
     int style;
{
    XGCValues gcv;
    static int dash_list_length[]= {2,4,2,2,3};
    static unsigned char dotted[2]={3,1};
    static unsigned char dot_dashed[4]={3,4,3,1};
    static unsigned char short_dashed[2]={4,4};
    static unsigned char long_dashed[2]={4,7};
    static unsigned char odd_dashed[3]={1,2,3};
    static unsigned char *dash_list[]={
	dotted,dot_dashed,short_dashed,long_dashed,odd_dashed};

    _g_linestyle = style % NUMLIN;
    if (_g_linestyle == 0) {
	XSetLineAttributes(display,gc,1,LineSolid,CapButt,JoinMiter);
    } else {
        XSetDashes(display,gc,0,dash_list[_g_linestyle-1],
		dash_list_length[_g_linestyle-1]);
	XSetLineAttributes(display,gc,1,LineOnOffDash,CapButt,JoinMiter);
    }
    return;
}

