/*********
* marker *              J.W.Flower   Sept. 1985
**********

Draws a marker at the point x,y with size 'size'.
Current supported markers are :

  mkr = 
        0 : point
        1 : diamond
        2 : square
        3 : triangle
        4 : inverted triangle
        5 : cross
        6 : plus
        7 : star
*/
#include "plotix.h"
#include "sys/plotix.h"
#include "xplot.h"

#define NUMMKR  8       /* Total number of markers */

void marker(mkr,x,y,m_size)
Coord x,y,m_size;
int mkr;
{
    Coord x0,x1,y0,y1;

    switch(mkr % NUMMKR) {
        case 0:                         /* No symbol */
            if(_g_softclip && !_pointclip(x,y)) 
                return; /* Clipped */
            _point(x,y);
            break;

/* The following marker symbols get clipped by 'move' and 'cont' */
        case 1 :                        /* Diamond */
            x0 = x - .5*m_size;
            x1 = x + .5*m_size;
            y0 = y - .5*m_size;
            y1 = y + .5*m_size;

            move(x0,y);
            cont(x,y1);
            cont(x1,y);
            cont(x,y0);
            cont(x0,y);
            break;
 
       case 2 :                        /* Square */
           x0 = x - .3536*m_size;
           x1 = x + .3536*m_size;
           y0 = y - .3536*m_size;
           y1 = y + .3536*m_size;
           move(x0,y0); 
           cont(x1,y0); cont(x1,y1); 
           cont(x0,y1); cont(x0,y0);
           break;

       case 3 :                        /* Triangle */
           x0 = x - .433*m_size;
           x1 = x + .433*m_size;
           y0 = y - .25*m_size;
           y1 = y + .5*m_size;
           move(x0,y0); cont(x1,y0); 
           cont(x,y1); cont(x0,y0); 
           break;

       case 4 :                        /* Inverted triangle */
           x0 = x - .433*m_size;
           x1 = x + .433*m_size;
           y0 = y - .5*m_size;
           y1 = y + .25*m_size;
           move(x0,y1); cont(x1,y1);
           cont(x,y0); cont(x0,y1);
           break;

       case 5 :                        /* Cross */
           x0 = x - .3536*m_size;
           x1 = x + .3536*m_size;
           y0 = y - .3536*m_size;
           y1 = y + .3536*m_size;
           move(x0,y0); cont(x1,y1);
           move(x0,y1); cont(x1,y0);
           break;

       case 6 :                        /* Plus */
           x0 = x - .5*m_size;
           x1 = x + .5*m_size;
           y0 = y - .5*m_size;
           y1 = y + .5*m_size;
           move(x,y0); cont(x,y1);
           move(x0,y); cont(x1,y);
           break;

       case 7 :                        /* Star = Cross + plus */
           x0 = x - .5*m_size;
           x1 = x + .5*m_size;
           y0 = y - .5*m_size;
           y1 = y + .5*m_size;
           move(x,y0); cont(x,y1);
           move(x0,y); cont(x1,y);
                  
           x0 = x - .3536*m_size;
           x1 = x + .3536*m_size;
           y0 = y - .3536*m_size;
           y1 = y + .3536*m_size;
           move(x0,y0); cont(x1,y1);
           move(x0,y1); cont(x1,y0);
           break;

       default :
           break;
    }
                
/* Now restore current coords... */

    move(x,y);
    return;
}


#if _3L
kmarke(mkr,x,y,m_size)
     int *mkr;
     float *x, *y, *m_size;
{
    marker(*mkr, (Coord)*x, (Coord)*y, (Coord)*m_size);
}
#endif          /* _3L */
