/***********
* plotdecl *
************

Definitions of external variables used by a particular PLOTIX driver. These
are divided into two types.
*/
#include "plotix.h"
#include "sys/plotix.h"

/* --------------------- DEVICE DEPENDENT DEFINITIONS ----------------------- */
#include "xplot.h"
#define DEV_x   (0)     /* Determined at runtime */
#define DEV_y   (0)     /* Determined at runtime */

unsigned long _g_cmap[256];
int _g_fgcolor = 1;             /* Foreground drawing color */
int _g_mouse = 0;               /* Number of mouse buttons */
Coord _g_mouse_x, _g_mouse_y;   /* Last position of mouse */
int _g_linestyle;               /* Current line drawing color */
GC gc; 				/* Current graphics context */
Display *display;
Cursor _g_cursor;
Colormap _g_xcmap;
int screen;
int _g_mono;
Window _g_win;
XFontStruct *_g_font;
int (*_g_redraw)() = NULL;	/* Pointer to repaint procedure */
int _g_wishx = 0, _g_wishy = 0;	/* Requested screen size */
int _g_atx = 0, _g_aty = 0;
char *_g_winlab = "Plotix";

/* -------------------- DEVICE INDEPENDENT DEFINITIONS ---------------------- */

VPTAB vptab[NVPORT];
int cvport = 0; 	        /* Currently active vport */
int _g_softclip = 0;    	/* Flag: software clipping enabled ? */
int _g_clip = 0;		/* Flag: clipping enabled ? */
int _g_open = 0;                /* Flag: openpl called ? */

Coord _g_xold, _g_yold; /* Current plotting position */

int _g_grey_lo, _g_grey_hi;
int _g_rain_lo, _g_rain_hi;

/* Conversion from world to device co-ordinates is achieved via the relation
        dev = mul * wld + off
*/
Coord _g_off[2];
#ifdef FLTCORD
Coord _g_mul[2] = {(Coord) DEV_x, (Coord) DEV_y};
#else
Coord _g_mul[2] = {1,1};
#endif

/* The default viewport coordinates are from 0 to 1 */

Coord _g_V0[2] = { (Coord) 0, (Coord) 0};
#ifdef FLTCORD
Coord _g_V1[2] = { (Coord) 1.,(Coord) 1.};
#else
Coord _g_V1[2] = {DEV_x, DEV_y};
#endif

/* The default world co-ordinates are from 0 to 1 */

Coord _g_W0[2] = {(Coord) 0,(Coord) 0};
#ifdef FLTCORD
Coord _g_W1[2] = {(Coord) 1.,(Coord) 1.};
#else
Coord _g_W1[2] = {DEV_x,DEV_y};
#endif

/* For MS Windows version, these are defined in MSWLOOP.C */
Coord _g_devx = (Coord) DEV_x; 
Coord _g_devy = (Coord) DEV_y;

