#ifndef _PLOTIXdotH
#define _PLOTIXdotH

#ifdef __STDC__
#include <stdio.h>
#endif

#ifdef MSWINDOWS
extern int _g_spawnwin;
#endif

/* Default to FLTCORD if neither is defined. */
#ifndef FLTCORD
#ifndef INTCORD
#define FLTCORD
#endif
#endif

#ifdef FLTCORD
typedef double Coord;
#endif

#ifdef INTCORD
typedef unsigned int Coord;
#endif

#ifdef __STDC__			/* Function protypes */
void aclosepl(void);
void aerase(void);
int agin(int *key, Coord *x, Coord *y);
int aopenpl(int bufsiz, FILE *fp);
void asendplot(void);
void aspect(Coord *xsize, Coord *ysize);
void box(Coord,Coord,Coord,Coord,int,int);
void closepl(void);
void color(int shade);
void cont(Coord x, Coord y);
void contour(double (*zpass)(), int nx, int ny,
	double levelmin, double levelmax, int nlevel, int panels);
void dotext(char *s, Coord x, Coord y, int angle,
	int hjust, int vjust);
void endclip(void);
void endpanel(void);
#ifndef isMPW
void erase(void);
#endif
int getplxopt(char *, ...);
int getpoint(Coord *xf, Coord *yf);
int gin(int *key,Coord *x,Coord *y);
void greyscale(int lo, int hi);
void initlevel(double (*zpass)(int x, int y), int nxpass, int nypass,
	double levelpass, int passwantedge);
void initpanel(int color, int edge);
void label(char *s, Coord x, Coord y);
void linemod(int s);
void marker(int mkr, Coord x, Coord y, Coord m_size);
void move(Coord x, Coord y);
int openpl(int bufsiz, FILE *fp);
void ortho_space(Coord x0,Coord y0,Coord x1,Coord y1,int position);
void panelpoint(Coord x, Coord y);
int plothwm(void);
void polgn(int num, Coord *x, Coord *y, int color, int edge);
void rainbow(int lo, int hi);
void sendplot(void);
void setclip(Coord x0, Coord y0, Coord x1, Coord y1);
int setplxopt(char *, ...);
int setvport(int);
void space(Coord x0, Coord y0, Coord x1, Coord y1);
void usendplot(void);
int vport(Coord x0, Coord y0, Coord x1, Coord y1);
#else		/* No function protypes, but try to be nice anyway */
void aclosepl();
void aerase();
int agin();
int aopenpl();
void asendplot();
void aspect();
void box();
void closepl();
void color();
void cont();
void contour();
void dotext();
void endclip();
void endpanel();
#ifndef isMPW
void erase();
#endif
int getplxopt();
int getpoint();
int gin();
void greyscale();
void initlevel();
void initpanel();
void label();
void linemod();
void marker();
void move();
int openpl();
void ortho_space();
void panelpoint();
int plothwm();
void polgn();
void rainbow();
void sendplot();
void setclip();
int setplxopt();
int setvport();
void space();
void usendplot();
int vport();
#endif		/* __STDC__ */
#endif
