/*********
* plxopt *		J.W.Flower, ParaSoft Corporation.
**********

This file contains machine-specific options supported by a particular 
device. Because of the vagaries of "varargs" functions and the like
we adopt a rather simple interface - a string is used to indicate
what operation is required and a single 32-bit parameter is allowed.

NOTE we are implicitly assuming that everything interesting can
fit into 32-bits.
*/
#include <stdio.h>
#include "plotix.h"
#include "sys/plotix.h"
#include "xplot.h"

int setplxopt(option, val)
     char *option;
     long val;
{
    if(!strcmp(option, "redraw"))         _g_redraw = val;
    else if(!strcmp(option, "width"))     _g_wishx = val;
    else if(!strcmp(option, "height"))    _g_wishy = val;
    else if(!strcmp(option, "winlab"))	  _g_winlab = (char *)val;
    else if(!strcmp(option, "winx"))	  _g_atx = (int)val;
    else if(!strcmp(option, "winy"))	  _g_aty = (int)val;
    else return -1;

    return 0;
}

int getplxopt(option, pval)
     char *option;
     long *pval;
{
    if(!strcmp(option, "nlcolors")) {
	if(_g_mono) *pval = 2;
	else *pval = 256;
	return 0;
    }
    else if(!strcmp(option, "nlstyles")) {
	*pval = NUMLIN;
	return 0;
    }
    return -1;
}
