#ifndef _sysPLOTIXdotH
#define _sysPLOTIXdotH
/*********
* plotix *		J.W.Flower,  ParaSoft Corp., Feb 1988
**********

Header file for the various system parameters used in the PLOTIX
system.
*/

/* You MUST include "plotix.h" before this file in order to get the
   following typedef.
*/
extern Coord _g_off[2], _g_mul[2];
extern Coord _g_V0[2], _g_V1[2];
extern Coord _g_W0[2], _g_W1[2];

extern int _g_open;
extern int _g_clip, _g_softclip;
extern Coord _g_xold, _g_yold;
extern int _g_rain_lo, _g_rain_hi;
extern int _g_grey_lo, _g_grey_hi;
#ifdef MSWINDOWS
extern int _g_spawnwin;
#endif
extern Coord _g_devx, _g_devy;

/* Flgs for sync/async modes */

extern int _plx_mode;

#define PLX_SYNC		(0)		/* Synchronous mode command */
#define PLX_ASYNC		(1)		/* Asynchronous mode command */

/* The nodes and the host deal in quanta of size .... */

#define PLX_QUANTUM	(1024)

#ifdef __STDC__		/* Function prototypes for our protection */
void c_endpanel(void);
void c_initpanel(int shade, int edgestyle);
void c_panelpoint(Coord x, Coord y);
void _cont(Coord x, Coord y);
void _endpanel(void);
void _getclip(Coord *px);
void _g_putch(int c);
void _g_putint(int val);
void _initpanel(int color, int edge);
int _inwindow(Coord x, Coord y);
void _lineclip(Coord x0, Coord y0, Coord x1, Coord y1);
void _marker(int mkr, Coord x, Coord y, Coord size);
void _move(Coord x, Coord y);
void _panelpoint(Coord x, Coord y);
int _plx_filt(int option, char *buffer, int length, char *reply);
void _point(Coord x, Coord y);
int _pointclip(Coord x, Coord y);
void _vpinit(void);
#else			/* No prototypes but try to be helpful anyway */
void c_endpanel();
void c_initpanel();
void c_panelpoint();
void _cont();
void _endpanel();
void _getclip();
void _g_putch();
void _g_putint();
void _initpanel();
int _inwindow();
void _lineclip();
void _marker();
void _move();
void _panelpoint();
int _plx_filt();
void _point();
int _pointclip();
void _vpinit();
#endif			/* __STDC__ */
#endif
