/**********
* xloop.c *
**********/
#include "plotix.h"
#include "xplot.h"
#include <stdio.h>

void doEvent();
int loopcheck();
void processevent();
int loopmode = MODEDEFAULT;
extern int _fallout,_button,_g_mx,_g_my;
extern int _g_plotix;

void doEvent(c)
    int c;		/* Argument isn't used */
{
    while(loopcheck());
}

int loopcheck()
{
    int numevents;

    if (!_g_plotix) return 0;
    numevents = XEventsQueued(display,loopmode);
    if (!numevents) return 0;
    processevent();
    return (numevents - 1);
}


/* This procedure assumes there is an event waiting... if not, it will
   wait for one. */
void processevent() {
    XEvent report;
    int count;
    char buffer;
    KeySym key;

    XNextEvent(display,&report);
    switch(report.type) {
    case Expose:
	while (XCheckTypedEvent(display,Expose,&report));
	if(_g_redraw != NULL) _g_redraw();
	break;
    case ConfigureNotify:
	_g_devx	= (Coord) report.xconfigure.width;
	_g_devy = (Coord) report.xconfigure.height;
	setvport(cvport);
	break;
    case ButtonPress:
        _g_mx = report.xbutton.x; 
	_g_my = report.xbutton.y;
	_fallout = 1;
	_button = report.xbutton.button;
	break;
    case KeyPress:
	count = XLookupString(&report,&buffer,1,&key,NULL);
	if (count > 0) {
	    _fallout = 1;
	    _button = (int) buffer;
	}
	/* This is done so we can process more keysyms later if necessary by
	adding code something like this:
	switch(key) {
	case XK_return:
	    _fallout = 1; _button = '\n'; break;
	}
	and so on...  These are keys without ASCII strings */

	if (_fallout) {
	    _g_mx = report.xkey.x;
	    _g_my = report.xkey.y;
	}
	break;
    default:
	break;	
    }
    return;
}
