/**********
* xplot.h *         Wendell T. Hicken , ParaSoft Corporation, 1989.
***********

Main header file for the X Windows implementation of PLOTIX.
*/
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/Xos.h>
#include <X11/keysym.h>
#include <X11/Xresource.h>

#define MODEDEFAULT QueuedAfterFlush
#define USER_to_X(x) (_g_mul[0]*(x) + _g_off[0])
#define USER_to_Y(y) (_g_devy - (_g_mul[1]*(y) + _g_off[1]) )
#define X_to_USER(x) (((Coord) (x) - _g_off[0]) / _g_mul[0])
#define Y_to_USER(y) ((_g_devy - _g_off[1] - (Coord) (y))/_g_mul[1])
#define NVPORT (8)      /* Max number of active viewports */
#define NUMLIN (6)	/* Number of linestyles */
typedef struct {
    Coord V0[2], V1[2];             /* Viewport position */
    Coord W0[2], W1[2];             /* User coordinate system */
    int clip;                       /* Clipping state */
    Coord clipwin[4];               /* Clipping window */
} VPTAB;

extern VPTAB vptab[NVPORT];
extern int cvport;              /* Currently active vport */
extern unsigned long _g_plxmap[8];
extern int _g_fgcolor, _g_linestyle;
extern int _g_mouse;
extern int _g_softclip;         /* Flag: software clipping enabled ? */
extern int _g_xChar, _g_yChar;  /* System font sizes */
extern Coord _g_devx, _g_devy;  /* Size of current window */
extern Coord _g_xold, _g_yold;  /* Current plotting position */
extern Coord _g_mouse_x, _g_mouse_y;    /* Current mouse position */
extern Coord _g_off[2],_g_mul[2];       /* Defines current space */
extern int (*_g_redraw)();	/* Pointer to repaint procedure */
extern int _g_wishx, _g_wishy;
extern int _g_atx, _g_aty;
extern char *_g_winlab;
extern unsigned long _g_cmap[256];
extern int _g_mono;
extern GC gc;		/* This is the graphics context for plotix */
extern Display *display;
extern Window _g_win;
extern int screen;
extern XFontStruct *_g_font;
extern Cursor _g_cursor;
extern Colormap _g_xcmap;

#if 0
/* Define prototypes for internal functions */
void _initpanel(int, int);      /* _PANEL  .C */
void _panelpoint(Coord, Coord); /* _PANEL  .C */
void _endpanel(void);           /* _PANEL  .C */
void _point(Coord, Coord);      /* _POINT  .C */
void _move(Coord, Coord);       /* _MOVE   .C */
void _cont(Coord, Coord);       /* _CONT   .C */
void _getclip(Coord *);         /* _CLIPPER.C */
void _vpinit(void);             /* SPACE   .C */
void _openwin(void);            /* MSWIN   .C */
void _closewin(void);           /* MSWIN   .C */
void _sizechange(int,int);      /* GIN     .C */
#endif

