#include <stdio.h>
#include <math.h>
#include "menu.h"
#define PTTOL		(0.04*wzoom)
#define MAXNEIGH	20

#define XELMT(e)	(e->neigh[0]->x + e->neigh[1]->x + e->neigh[2]->x)/3
#define YELMT(e)	(e->neigh[0]->y + e->neigh[1]->y + e->neigh[2]->y)/3

#define FORALLNODES(node)	if((node = the_nodes) != NULL){ do {
#define NEXTNODE(node)		} while((node = node->next) != the_nodes); }

#define PI	3.1415927
#define START_BDY		1
#define IN_PROGRESS		2

struct node {
	double x, y;
	struct node *clock, *antik;
	int number;
	int nneigh;
	struct node *neigh[MAXNEIGH];
	struct node *oppalias;
	struct node *next;
} *startnode, *curr_node, *the_nodes = NULL;

struct elmt {
	struct node *neigh[3];
	int number;
	struct elmt *next;
} *the_elmts = NULL;

int nbdy = 0;
int bdy_state = 0;
int grid_on;
double grid_spacing;
extern double xzoom, yzoom, wzoom;
#define SETCLIP		setclip(xzoom, yzoom, xzoom+wzoom, yzoom+wzoom)

main(argc, argv)
int argc;
char **argv;
{
	MNUPTR Root, bdy_make, zoom, triang, alias;
	int output(), start_bdy(), grid(), cursor(), end_bdy(), redraw(), exp_node();
	int extents(), window(), disp_erase(), exp_zoom();
	int node_inside(), node_online(), get_and_connect(), to_node();
	int alias_lines();

	Root = menu_make(ROOT);
	add_item(Root, "REDRAW", LEAF, redraw);
	add_item(Root, "GRID", LEAF, grid);
	add_item(Root, "WRITE", LEAF, output);
	add_item(Root, "ERASE", LEAF, disp_erase);

	bdy_make = menu_make(BRANCH);
	add_item(Root, "BDY_MAKE", BRANCH, bdy_make);
		add_item(bdy_make, "START_BDY", LEAF, start_bdy);
		add_item(bdy_make, "TO_CURSOR", LEAF, cursor);
		add_item(bdy_make, "TO_NODE", LEAF, to_node);
		add_item(bdy_make, "EXPLICIT", LEAF, exp_node);
		add_item(bdy_make, "END_BDY", LEAF, end_bdy);

	zoom = menu_make(BRANCH);
	add_item(Root, "ZOOM", BRANCH, zoom);
		add_item(zoom, "EXTENTS", LEAF, extents);
		add_item(zoom, "WINDOW", LEAF, window);
		add_item(zoom, "EXPLICIT", LEAF, exp_zoom);

	alias = menu_make(BRANCH);
	add_item(Root, "ALIAS", BRANCH, alias);
		add_item(alias, "LINE_SEGMENTS", LEAF, alias_lines);

	triang = menu_make(BRANCH);
	add_item(Root, "TRIANGULATE", BRANCH, triang);
		add_item(triang, "NODE_INSIDE", LEAF, node_inside);
		add_item(triang, "NODE_ONLINE", LEAF, node_online);
		add_item(triang, "CONNECT", LEAF, get_and_connect);

	openpl(2000, stdout);
	menu_setup((argc>1) ? argv[1]:"");
	disp_erase();
	menu_input();
}

alias_lines()
{
	struct node *node, *picked_node[2];
	int inode, key;
	double x, y, px, py, qx, qy, cos;

	for(inode=0; inode<2; inode++){
		if(inode == 0)
			printf("Pick first line segment\n");
		else
			printf("Pick second line segment\n");
		get_gin(&key, &x, &y);
		if(x < xzoom)
			return;
		FORALLNODES(node)
			if(node->clock == NULL)
				continue;
			qx = node->clock->x - node->x;
			qy = node->clock->y - node->y;
			px = x - node->x;
			py = y - node->y;
			cos = (px*qx + py*qy)/(qx*qx + qy*qy);
			if(cos < 0.0 || cos > 1.0)
				continue;
			px -= cos*qx;
			py -= cos*qy;
			if(fabs(px) + fabs(py) < PTTOL){
				if(inode == 1 && node == picked_node[0])
					continue;
				picked_node[inode] = node;
				goto got_node;
			}
		NEXTNODE(node)
		printf("Line segment not found\n");
		return;
got_node:
		color(5);
		draw(node, node->clock);
		sendplot();
	}
	for(inode=0; inode<2; inode++){
		picked_node[inode]->oppalias = picked_node[1-inode];
	}
}

struct node *get_node()
{
	struct node *node;
	int key;
	double x, y, dx, dy, ta, tc, t;

	get_gin(&key, &x, &y);
	if(x < xzoom)
		return(NULL);

	if((node = the_nodes) != NULL){
		do {
			dx = x - node->x;
			dy = y - node->y;
			if(dx*dx + dy*dy < PTTOL*PTTOL){
				if(node->clock != NULL){
					ta = atan2(node->antik->y - node->y,
							node->antik->x - node->x);
					tc = atan2(node->clock->y - node->y,
							node->clock->x - node->x) - ta;
					t = atan2(dy, dx) - ta;
					if(tc < 0.0) tc += 2*PI;
					if(t  < 0.0) t  += 2*PI;
					if(t >= tc && tc != 0.0)
						continue;
				}
				return(node);
			}
		} while((node = node->next) != the_nodes);
	}
	printf("Node not found\n");
	return(NULL);
}

get_and_connect()
{
	struct node *node1, *node2;
	while(1){
		printf("Click on first node\n");
		if((node1 = get_node()) == NULL){
			printf("End of connecting\n");
			return;
		}
		color(2);
		draw_marker(node1);
		printf("Click on second node\n");
		if((node2 = get_node()) == NULL){
			printf("End of connecting\n");
			return;
		}
		color(1);
		draw_marker(node1);
		color(4);
		draw(node1, node2);
		connect(node1, node2);
	}
}

connect(node1, node2)
struct node *node1, *node2;
{
	int ineigh;
	if(!neighbor(node1, node2)){
		node1->neigh[node1->nneigh++] = node2;
		node2->neigh[node2->nneigh++] = node1;
	}
}

neighbor(node1, node2)
struct node *node1, *node2;
{
	int ineigh;
	for(ineigh=0; ineigh<node1->nneigh; ineigh++)
		if(node1->neigh[ineigh] == node2)
			return(1);
	return(0);
}

node_inside()
{
	double x, y;
	struct node *nalloc(), *node;
	if(bdy_state){
		printf("Finish current bdy first\n");
		return;
	}
	while(1){
		if(!get_valid_pt(&x, &y)){
			printf("End of node_inside\n");
			return;
		}
		node = nalloc();
		node->x = x;
		node->y = y;
		color(1);
		draw_marker(node);
		sendplot();
	}
}

node_online()
{
	double x, y, qx, qy, px, py, cos, d;
	struct node *nalloc(), *node, *put_node_online(), *aliasnode, *newnode;
	int ibdy, key;
	if(bdy_state){
		printf("Finish current bdy first\n");
		return;
	}

	get_gin(&key, &x, &y);
	if(x < xzoom)
		return;

	FORALLNODES(node)
		if(node->clock == NULL)
			continue;
		qx = node->clock->x - node->x;
		qy = node->clock->y - node->y;
		px = x - node->x;
		py = y - node->y;
		cos = (px*qx + py*qy)/(qx*qx + qy*qy);
		if(cos < 0.0 || cos > 1.0)
			continue;
		px -= cos*qx;
		py -= cos*qy;
		if(fabs(px) + fabs(py) < PTTOL){
			newnode = put_node_online(node, cos);
			if(node->oppalias != NULL){
				aliasnode = newnode->antik->oppalias;
				aliasnode = put_node_online(aliasnode, 1-cos);
				newnode->antik->oppalias = aliasnode;
				aliasnode->oppalias = newnode->antik;
				newnode->oppalias = aliasnode->antik;
				aliasnode->antik->oppalias = newnode;
			}
			return;
		}
	NEXTNODE(node)
	printf("Line segment not found\n");
}

struct node *put_node_online(node, cos)
struct node *node;
double cos;
{
	struct node *newnode;
	newnode = nalloc();
	newnode->x = (1-cos)*node->x + cos*node->clock->x;
	newnode->y = (1-cos)*node->y + cos*node->clock->y;
	newnode->clock = node->clock;
	node->clock->antik = newnode;
	newnode->antik = node;
	node->clock = newnode;
	color(1);
	draw_marker(newnode);
	sendplot();
	return(newnode);
}

start_bdy()
{
	struct node *nalloc(), *node;
	double x, y;
	if(bdy_state){
		printf("Finish current bdy first\n");
		return;
	}
	bdy_state = START_BDY;
}

cursor()
{
	double x, y;
	int key;
	if(!bdy_state){
		printf("Start a bdy first\n");
		return;
	}

	while(1){
		if(!get_valid_pt(&x, &y)){
			printf("End of To_Cursor\n");
			return;
		}
		line_to(x, y);
	}
}

to_node()
{
	struct node *old, *node, *nalloc();
	if(!bdy_state){
		printf("Start a bdy first\n");
		return;
	}
	printf("Click on node\n");
	if((old = get_node()) == NULL)
		return;
	line_to(old->x, old->y);
}

exp_node()
{
	double x, y;
	printf("x, y please\n");
	get_double(&x);
	get_double(&y);
	line_to(x, y);
}

line_to(x, y)
double x, y;
{
	struct node *nalloc(), *node;
	color(0);
	node = nalloc();
	if(bdy_state == START_BDY){
		startnode = curr_node = node;
		node->x = x;
		node->y = y;
		color(1);
		draw_marker(node);
		bdy_state = IN_PROGRESS;
	} else {
		if(curr_node != startnode)
			draw_marker(curr_node);
		node->x = x;
		node->y = y;
		node->antik = curr_node;
		curr_node->clock = node;
		color(1);
		draw_marker(curr_node);
		draw_marker(node);
		draw(curr_node, node);
		curr_node = node;
	}
	sendplot();
}

end_bdy()
{
	if(!bdy_state){
		printf("No current bdy\n");
		return;
	}

	color(0);
	draw_marker(startnode);
	draw_marker(curr_node);

	curr_node->clock = startnode;
	startnode->antik = curr_node;
	color(1);
	draw_marker(curr_node);
	draw_marker(startnode);
	draw(curr_node, startnode);
	sendplot();
	nbdy++;
	bdy_state = 0;
}

redraw()
{
	int ineigh;
	struct node *node;
	if(grid_on)
		draw_grid(1);
	if((node = the_nodes) != NULL){
		do {
			draw_marker(node);
			for(ineigh=0; ineigh < node->nneigh; ineigh++){
				if(node < node->neigh[ineigh]){
					color(1);
					draw(node, node->neigh[ineigh]);
				}
			}
			if(node->clock != NULL){
				color(node->oppalias == NULL ? 1:5);
				draw(node, node->clock);
			}
		} while((node = node->next) != the_nodes);
	}
	sendplot();
}


grid()
{
	grid_on = 1-grid_on;
	if(!grid_on){
		draw_grid(0);
		printf("Grid Off\n");
		return;
	}
	printf("Grid spacing?\n");
	get_double(&grid_spacing);
	draw_grid(1);
}

draw_grid(shade)
int shade;
{
	int minx, miny, maxx, maxy, x, y;
	minx = xzoom/grid_spacing + 1;
	miny = yzoom/grid_spacing + 1;
	maxx = (xzoom+wzoom)/grid_spacing + 1;
	maxy = (yzoom+wzoom)/grid_spacing + 1;
	color(shade);
	for(x=minx; x<=maxx; x++)
		for(y=miny; y<=maxy; y++)
			point(x*grid_spacing, y*grid_spacing);
	color(1);
	sendplot();
}
	
output()
{
	char string[30];
	FILE *out;
	struct node *node;
	struct elmt *elmt;
	int i, ibdy;

	if(bdy_state){
		printf("Finish boundaries first\n");
		return;
	}
	if(the_nodes == NULL){
		printf("Nothing to write out\n");
		return;
	}

	hook_up_boundaries();

	node = the_nodes;
	i = 0;
	do {
		sortneigh(node);
		node->number = i++;
	} while((node = node->next) != the_nodes);

	make_elmts();

	if(the_elmts == NULL){
		printf("No triangles\n");
		return;
	}

	printf("Filename (without suffix)?\n");
	get_string(string);
	strcat(string, ".ct");
	if((out = fopen(string, "w")) == (FILE *)NULL){
		printf("Cannot open %s\n", string);
		fflush(stdout);
		abort(998);
	}

	elmt = the_elmts;
	do {
		fprintf(out, "E%-3d: ", elmt->number);
		for(i=0; i<3; i++)
			fprintf(out, "N%-3d ", elmt->neigh[i]->number);
		fprintf(out, "\n");
	} while((elmt = elmt->next) != the_elmts);

	node = the_nodes;
	do {
		fprintf(out, "N%-3d: ", node->number);
		fprintf(out, "X%f Y%f ", node->x, node->y);

		if(node->clock != NULL)
			fprintf(out, "B%-3d ", node->clock->number);

		do_aliases(node, out);

		elmt = the_elmts;
		do {
			for(i=0; i<3; i++)
				if(elmt->neigh[i] == node)
					fprintf(out, "E%-3d ", elmt->number);
		} while((elmt = elmt->next) != the_elmts);

		fprintf(out, "\n");
	} while((node = node->next) != the_nodes);

	closepl();
	exit(0);
}

do_aliases(node, out)
struct node *node;
FILE *out;
{
	struct node *noden;

	if(node->oppalias != NULL)
		fprintf(out, "O%-3d ", node->oppalias->number);

	noden = node;
	while(noden->oppalias != NULL){ 
		noden = noden->oppalias->clock;
		if(noden == node)
			return;
		fprintf(out, "A%-3d ", noden->number);
	}
	if(node->antik == NULL)
		return;
	noden = node;
	while((noden = noden->antik->oppalias) != NULL){
		if(noden == node){
			printf("Error in do_aliases\n");
			abort(990);
		}
		fprintf(out, "A%-3d ", noden->number);
	}
}

make_elmts()
{
	struct node *node, *node1, *node2;
	struct elmt *ealloc(), *elmt;
	int ineigh, i;
	node = the_nodes;
	do {
		for(ineigh=0; ineigh<node->nneigh; ineigh++){
			node1 = node->neigh[ineigh];
			if(node->clock != NULL && node->clock == node1)
				continue;
			node2 = node->neigh[(ineigh+1) % node->nneigh];
			if(!neighbor(node1, node2)){
				color(3);
				marker(1, node->x, node->y, 3*PTTOL*wzoom);
				marker(1, node1->x, node1->y, 3*PTTOL*wzoom);
				marker(1, node2->x, node2->y, 3*PTTOL*wzoom);
				sendplot();
				the_elmts = NULL;
				printf("Incomplete Triangulation\n");
				return;
			}
			if((elmt = the_elmts) != NULL){
				do {
					for(i=0; i<3; i++){
						if(elmt->neigh[i] != node)		continue;
						if(elmt->neigh[(i+1)%3] != node1)	continue;
						if(elmt->neigh[(i+2)%3] != node2)	continue;
						goto old;
					}
				} while((elmt = elmt->next) != the_elmts);
			}
			elmt = ealloc();
			elmt->neigh[0] = node;
			elmt->neigh[1] = node1;
			elmt->neigh[2] = node2;
			showelmt(elmt);
old:;
		}
	} while((node = node->next) != the_nodes);
}

showelmt(elmt)
struct elmt *elmt;
{
	int i;
	initpanel(5, 1);
	for(i=0; i<3; i++)
		panelpoint(0.5*elmt->neigh[i]->x + 0.5*XELMT(elmt),
				   0.5*elmt->neigh[i]->y + 0.5*YELMT(elmt));
	endpanel();
	sendplot();
}

hook_up_boundaries()
{
	int ibdy, number = 0;
	struct node *node;
	FORALLNODES(node)
		if(node->clock != NULL)
			connect(node, node->clock);
	NEXTNODE(node)
}

sortneigh(this)
struct node *this;
{
	double angle[MAXNEIGH], pseudarg(), dx, dy;
	int perm[MAXNEIGH], in, inp, dummy, finished;
	struct node *storage[MAXNEIGH];
	for(in=0; in<this->nneigh; in++){
		perm[in] = in;		/* A permutation to be found */
		storage[in] = this->neigh[in];	/* Store the neighbors */
		dx = this->neigh[in]->x - this->x;
		dy = this->neigh[in]->y - this->y;
		if(fabs(dx) + fabs(dy) < .000001)
			abort(9);
		angle[in] = pseudarg(dx, dy); /* Could use atan2, but this is quicker */
	}
/*	Inefficient sort, but only expect 6 or so in list */
	do {
		finished = 1;
		for(inp=1; inp<this->nneigh; inp++){
			in = inp-1;
			if(angle[perm[in]] > angle[perm[inp]]){
				dummy = perm[in];
				perm[in] = perm[inp];
				perm[inp] = dummy;
				finished = 0;
			}
		}
	} while(!finished);
/* Sorting complete. Now get stuff from store according to permutation 'perm'*/
	for(in=0; in<this->nneigh; in++)
		this->neigh[in] = storage[perm[in]];
}

double pseudarg(x, y)
/*
	Returns a pseudo angle from 0 to 4, monotonic with 
	real angle from 0 to 2 pi.
*/
double x, y;
{
	if(x >= 0.0){ 
		if(y >= 0.0)		return(y/(x+y));
		else				return(3 + x/(x-y));
	}else{
		if(y >=0.0)			return(2 - y/(y-x));
		else				return(3 - x/(x+y));
	}
}

struct elmt *ealloc()
{
	struct elmt *new;
	static int number = 0;
	new = (struct elmt *)malloc(sizeof(struct elmt));
	if(new == NULL){
		printf("Malloc failed for elmt\n");
		abort(997);
	}
	new->number = number++;
	if(the_elmts == NULL){
		new->next = new;
		the_elmts = new;
	} else {
		new->next = the_elmts->next;
		the_elmts->next = new;
	}
	return(new);
}

struct node *nalloc()
{
	struct node *new;
	new = (struct node *)malloc(sizeof(struct node));
	if(new == NULL){
		printf("Malloc failed for node\n");
		abort(999);
	}
	new->nneigh = 0;
	new->clock = new->antik = NULL;
	new->oppalias = NULL;
	if(the_nodes == NULL){
		new->next = new;
		the_nodes = new;
	} else {
		new->next = the_nodes->next;
		the_nodes->next = new;
	}
	return(new);
}

get_valid_pt(ax, ay)
double *ax, *ay;
{
	int key, gx, gy;
	sendplot();

	get_gin(&key, ax, ay);
	if(*ax < xzoom)
		return(0);

	if(grid_on){
		if(*ax > 0.0)
			*ax = ((int)(*ax/grid_spacing + 0.5))*grid_spacing;
		else
			*ax = ((int)(*ax/grid_spacing - 0.5))*grid_spacing;
		if(*ay > 0.0)
			*ay = ((int)(*ay/grid_spacing + 0.5))*grid_spacing;
		else
			*ay = ((int)(*ay/grid_spacing - 0.5))*grid_spacing;
	}
	return(1);
}

do_zoom()
{
	space  (xzoom-LEFT*wzoom, yzoom, xzoom+wzoom, yzoom+wzoom);
	SETCLIP;
	disp_erase();
	redraw();
}

window()
{
	double x, y, fac;
	int key;
	printf("Click New Center\n"); fflush(stdout);
	get_gin(&key, &x, &y);
	printf("Zoom Factor\n"); fflush(stdout);
	get_double(&fac);
	wzoom /= fac;
	xzoom = x - 0.5*wzoom;
	yzoom = y - 0.5*wzoom;
	do_zoom();
}

extents()
{
#define TESTX(x)		if(x < xmin) xmin=x; if(x > xmax) xmax = x
#define TESTY(y)		if(y < ymin) ymin=y; if(y > ymax) ymax = y
	double xmin, xmax, ymin, ymax;
	int ibdy;
	struct node *node;

	if((node = the_nodes) != NULL){
		xmin = xmax = node->x;
		ymin = ymax = node->y;

		do {
			TESTX(node->x);
			TESTY(node->y);
		} while((node = node->next) != the_nodes);
	}

	wzoom = 1.2*((xmax-xmin > ymax-ymin) ? (xmax-xmin):(ymax-ymin));
	if(wzoom < 1.e-12){
		xzoom = yzoom = 0.0;
		wzoom = 1.0;
	} else {
		xzoom = xmin - 0.083*wzoom;
		yzoom = ymin - 0.083*wzoom;
	}
	do_zoom();
}

exp_zoom()
{
	printf("Screen Origin (x, y) and width?\n");
	get_double(&xzoom);
	get_double(&yzoom);
	get_double(&wzoom);
	do_zoom();
}

draw(node1, node2)
struct node *node1, *node2;
{
	move(node1->x, node1->y);
	cont(node2->x, node2->y);
}


draw_marker(node)
struct node *node;
{
	double ta, tc, p, q, t;
	int i, imax;

	if(node->clock == NULL || node->antik == NULL)
		marker(2, node->x, node->y, PTTOL);
	else {
		tc = atan2(node->clock->y - node->y, node->clock->x - node->x);
		ta = atan2(node->antik->y - node->y, node->antik->x - node->x);
		if(tc <= ta)
			tc += 2*PI;
		imax = (tc-ta)*2;
		if(imax == 0)
			imax = 1;
		for(i=0; i<=imax; i++){
			t = ta + i*(tc-ta)/imax;
			p = node->x + PTTOL*cos(t);
			q = node->y + PTTOL*sin(t);
			if(i==0)
				move(p, q);
			else
				cont(p, q);
		}
	}
}
