#include <stdio.h>
#define WHITE		8
#define BLACK		59
#define RAINSTART	60
#define RAINEND		127
extern double menu_width, z_xmin, z_ymin, z_xmax, z_ymax;
double menu_width, z_xmin, z_ymin, z_xmax, z_ymax;
extern FILE *ps_file;
extern int plotting;
extern int graphics;

int need_stroke = 0;
int edgesave;

Erase()
{
	if(graphics)
		erase();
}

Move(x, y)
double x, y;
{
	if(graphics)
		move(x, y);
	if(plotting){
		if(need_stroke){
			fprintf(ps_file, "s\n");
			need_stroke = 0;
		}
		fprintf(ps_file, "%3.3f %3.3f m\n", x, y);
	}
}

Cont(x, y)
double x, y;
{
	if(graphics)
		cont(x, y);
	if(plotting){
		need_stroke = 1;
		fprintf(ps_file, "%3.3f %3.3f c\n", x, y);
	}
}

Color(shade)
int shade;
{
	if(graphics)
		color(shade);
	if(plotting)
		fprintf(ps_file, "%d C\n", shade%8 + 1);
}

Marker(i, x, y, s)
int i;
double x, y, s;
{
	if(graphics)
		marker(i, x, y, s);
}

Initpanel(shade, edge)
int shade, edge;
{
	double grey;
	if(graphics)
		initpanel(shade, edge);
	if(plotting){
		edgesave = edge;
		if(need_stroke){
			fprintf(ps_file, "s\n");
			need_stroke = 0;
		}
		if(shade <= RAINEND && shade >= RAINSTART)
			grey = (double)(shade - RAINSTART)/(RAINEND - RAINSTART);
		else if(shade <= BLACK && shade >= WHITE)
			grey = (double)(shade - WHITE)/(BLACK - WHITE);
		else 
			grey = (double)(shade%8)/8.;
		
		fprintf(ps_file, "%f i\n", grey);
	}
}

Panelpoint(x, y)
double x, y;
{
	if(graphics)
		panelpoint(x, y);
	if(plotting)
		fprintf(ps_file, "%3.3f %3.3f p\n", x, y);
}

Endpanel()
{
	if(graphics)
		endpanel();
	if(plotting){
		if(edgesave)
			fprintf(ps_file, "E\n");
		else
			fprintf(ps_file, "e\n");
	}
}

Linemod(s)
int s;
{
	if(graphics)
		linemod(s);
	if(plotting)
		fprintf(ps_file, "%2d l\n", s);
}

Usendplot()
{
	if(graphics)
		usendplot();
	if(plotting){
		if(need_stroke){
			fprintf(ps_file, "s\n");
			need_stroke = 0;
		}
		fflush(ps_file);
	}
}

Sendplot()
{
	if(graphics)
		sendplot();
	if(plotting){
		if(need_stroke){
			fprintf(ps_file, "s\n");
			need_stroke = 0;
		}
		fflush(ps_file);
	}
}

Openpl(buf, fp)
int buf;
FILE *fp;
{
	if(graphics)
		openpl(buf, fp);
}

Space(x0, y0, x1, y1)
double x0, y0, x1, y1;
{
	if(graphics)
		space(x0, y0, x1, y1);
}

Ortho_space(x0, y0, x1, y1, i)
double x0, y0, x1, y1;
int i;
{
	if(graphics)
		ortho_space(x0, y0, x1, y1, i);
}

Vport(x0, y0, x1, y1)
double x0, y0, x1, y1;
{
	return(graphics ? vport(x0, y0, x1, y1) : 0);
}

Setvport(port)
int port;
{
	if(graphics)
		setvport(port);
}
