
      PROGRAM pippo

      implicit none

      integer f_in, f_out, f_all, f_all2, f_dat
      integer max_files, n_groups_max, no, no2, no22
      integer no23, n_lambda_max

      parameter ( f_in   =  5 )
      parameter ( f_out  =  6 )
      parameter ( f_all  = 10 )
      parameter ( f_all2 = 11 )
      parameter ( f_dat  = 21 )
      parameter ( no   = 6 )
      parameter ( no2  = 2*no+1 )
      parameter ( no22 = 2*no2  )
      parameter ( no23 = no22 + 1 )
      parameter ( max_files = 100 )
      parameter ( n_groups_max =  20 )
      parameter ( n_lambda_max =  200 )

      integer n_files, i_file, n_confs, n_groups, n_lambda
      integer i_group, s_group, conf_group, n_confs_per_group
      integer volume, time_scale, n_int, n_ext
      integer volume2, time_scale2, n_int2, n_ext2
      integer i_confs, i_obs, i_scratch, i_lambda
      integer len_file_name(max_files)

      real * 4 lmin, lmax, ldel, lambda
      real * 4 buffer1(6), buffer2(6)
      real * 8 scratch(no22), mean(no22)
      real * 8 gram(0:n_groups_max+2,n_lambda_max,no23)
      real * 8 vlam(n_lambda_max), weigth(n_lambda_max)
      real * 8 vdif(n_lambda_max)
      real * 8 m_action_c, action_c, action_cc, wmax, wmin
      
      character * 80 file_name(max_files)

      OPEN(unit=f_dat ,status='new', file='bbbgram.dat', err=101)

      write(f_out,*)' Input lambda value for runs'
      read (f_in ,*)lambda
      write(f_out,*)' lambda  = ', lambda
      write(f_dat,*)' lambda  = ', lambda

      write(f_out,*)' Input lambda minimum'
      read (f_in ,*)lmin
      write(f_out,*)' lambda minimum = ', lmin
      write(f_dat,*)' lambda minimum = ', lmin

      write(f_out,*)' Input lambda maximum'
      read (f_in ,*)lmax
      write(f_out,*)' lambda maximum = ', lmax
      write(f_dat,*)' lambda maximum = ', lmax

      write(f_out,*)' Input delta lambda'
      read (f_in ,*)ldel
      write(f_out,*)' delta lambda = ', ldel
      write(f_dat,*)' delta lambda = ', ldel

      N_lambda = int(((lmax-lmin)/ldel)+.0001)
      write(f_out,*)' n_lambda = ', n_lambda
      write(f_dat,*)' n_lambda = ', n_lambda
      if(n_lambda.gt.n_lambda_max)stop'n_lambda>n_lambda_max'
      vlam(1)=lmin
      vdif(1)=vlam(1)-lambda
      do i_scratch =2, n_lambda
         vlam(i_scratch) = vlam(i_scratch-1)+ldel
         vdif(i_scratch) = vlam(i_scratch) - lambda
      enddo

      write(f_out,*)' Input number of confs to be read'
      read (f_in ,*)n_confs
      write(f_out,*)' number of confs to read = ', n_confs
      write(f_dat,*)' number of confs to read = ', n_confs

      write(f_out,*)' Input number of groups for jack'
      read (f_in ,*)n_groups
      write(f_out,*)' number of groups for jack = ', n_groups
      write(f_dat,*)' number of groups for jack = ', n_groups
      if(n_groups .gt. n_groups_max)then
         write(f_out,*)n_groups, n_groups_max
         stop'n_groups> n_groups_max'
      endif

      n_confs_per_group = n_confs / n_groups
      write(f_out,*)' n confs per group  = ', n_confs_per_group
      write(f_dat,*)' n confs per group  = ', n_confs_per_group
      if(n_confs_per_group*n_groups.ne.n_confs)
     $     stop'n_confs_per_group*n_groups.ne.n_confs'

      write(f_out,*)' Input number of files'
      read (f_in ,*)n_files
      write(f_out,*)' n_files = ', n_files
      write(f_dat,*)' n_files = ', n_files
      if(n_files .gt. max_files)then
         write(f_out,*)n_files, max_files
         stop'n_files> max_files'
      endif

      wmax = -1.e18
      wmin =  1. e18

      do s_group = 0, n_groups_max
         do i_lambda = 1, n_lambda_max
            do i_obs = 1, no23
               gram(s_group,i_lambda,i_obs) = 0.0 
            enddo
         enddo
      enddo

      do i_file = 1, n_files
         write(f_out,*)' Input file name n.',i_file
         read (f_in ,201)len_File_name(i_file),file_name(i_file)
         write(f_out,*)i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         write(f_dat,*)i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         OPEN(unit=f_all ,status='old', 
     $        file=file_name(i_file)
     $        (1:len_file_name(i_file))//'.all'
     $        , err=102,readonly)
         OPEN(unit=f_all2,status='old', 
     $        file=file_name(i_file)
     $        (1:len_file_name(i_file))//'.all2'
     $        , err=103,readonly)
         close(f_all)
         close(f_all2)
      enddo

      i_confs = 0
      do i_file = 1, n_files
         write(f_out,*)'phase 1, working on ',i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         write(f_dat,*)'phase 1, working on ',i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         OPEN(unit=f_all ,status='old', 
     $        file=file_name(i_file)(1:len_file_name(i_file))//'.all'
     $        , err=102,readonly)
         OPEN(unit=f_all2,status='old', 
     $        file=file_name(i_file)(1:len_file_name(i_file))//'.all2'
     $        , err=103,readonly)
         if(i_file.eq.1)then
            read(f_all,*)volume, time_scale, n_int, n_ext
            write(f_out,*)'volume, time_scale, n_int, n_ext'
            write(f_dat,*)'volume, time_scale, n_int, n_ext'
            write(f_out,*)volume, time_scale, n_int, n_ext
            write(f_dat,*)volume, time_scale, n_int, n_ext
         else
            read(f_all,*)volume2, time_scale2, n_int2, n_ext2
            write(f_out,*)'n_int, n_ext'
            write(f_dat,*)'n_int, n_ext'
            write(f_out,*)n_int2, n_ext2
            write(f_dat,*)n_int2, n_ext2
            if(volume2.ne.volume)then
               write(f_out,*)volume,volume2
               stop'different volume files'
            endif
            if(time_scale2.ne.time_scale)then
               write(f_out,*)time_scale,time_scale2
               stop'different time_scale files'
            endif
         endif
         read(f_all2,*)volume2, time_scale2, n_int2, n_ext2
         if(volume2.ne.volume)then
            write(f_out,*)volume,volume2
            stop'different volume files'
         endif
         if(time_scale2.ne.time_scale)then
            write(f_out,*)time_scale,time_scale2
            stop'different time_scale files'
         endif
 1101    continue
         read(f_all ,*,err=1103)buffer1
         read(f_all2,*,err=1103)buffer2
         i_confs=i_confs+1
         do i_obs = 1, no
            scratch(i_obs) = buffer1(i_obs)
            scratch(no+1+i_obs) = buffer2(i_obs)
         enddo
         scratch(3) = scratch(3)/ float(volume)
         scratch(no+1) =  scratch(3) + lambda * scratch(6)
         do i_obs = 1, no2
            mean(i_obs) = mean(i_obs) + scratch(i_obs)
            mean(no2+i_obs) = mean(no2+i_obs) + scratch(i_obs)**2
         enddo
         if(i_confs .eq. n_confs)goto 1102
         goto 1101
 1103    continue
         close(f_all)
         close(f_all2)
      enddo
      goto 106
 1102 continue
      close(f_all)
      close(f_all2)
      do i_obs = 1, no22
         mean(i_obs) = mean(i_obs) / float(n_confs)
      enddo
      do i_obs = 1, no22
         write(f_out,*)i_obs, mean(i_obs)
         write(f_dat,*)i_obs, mean(i_obs)
      enddo
      m_action_c = mean(6) * volume
      write(f_out,*)'Mean Total Curvature',m_action_c
      write(f_dat,*)'Mean Total Curvature',m_action_c

      i_confs = 0
      i_group = 1
      conf_group = 0
      do i_file = 1, n_files
         write(f_out,*)'phase 2, working on ',i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         write(f_dat,*)'phase 2, working on ',i_file,' '
     $        ,file_name(i_file)(1:len_file_name(i_file))
         OPEN(unit=f_all ,status='old', 
     $        file=file_name(i_file)(1:len_file_name(i_file))//'.all'
     $        , err=102,readonly)
         OPEN(unit=f_all2,status='old', 
     $        file=file_name(i_file)(1:len_file_name(i_file))//'.all2'
     $        , err=103,readonly)
         read(f_all,*)volume2, time_scale2, n_int2, n_ext2
         if(volume2.ne.volume)then
            write(f_out,*)volume,volume2
            stop'different volume files'
         endif
         if(time_scale2.ne.time_scale)then
            write(f_out,*)time_scale,time_scale2
            stop'different time_scale files'
         endif
         read(f_all2,*)volume2, time_scale2, n_int2, n_ext2
         if(volume2.ne.volume)then
            write(f_out,*)volume,volume2
            stop'different volume files'
         endif
         if(time_scale2.ne.time_scale)then
            write(f_out,*)time_scale,time_scale2
            stop'different time_scale files'
         endif
 1104    continue
         read(f_all ,*,err=1105)buffer1
         read(f_all2,*,err=1105)buffer2
         i_confs=i_confs+1
         conf_group=conf_group+1
         if(conf_group.eq.n_confs_per_group+1)then
            conf_group = 1
            i_group=i_group+1
            write(f_out,*)'ph. 2, starting new group:',
     $           'i_file,i_confs,i_group'
            write(f_out,*)i_file,i_confs,i_group
         endif
         action_c  = buffer1(6) * volume
         action_cc = action_c - m_action_c
         do i_obs = 1, no
            scratch(i_obs) = buffer1(i_obs)
            scratch(no+1+i_obs) = buffer2(i_obs)
         enddo
         scratch(3) = scratch(3)/ float(volume)
         scratch(no+1) =  scratch(3) + lambda * scratch(6)
         do i_obs = no2+1,no22
            scratch(i_obs) = scratch(i_obs-no2)**2
         enddo
         do i_lambda = 1, n_lambda
            weigth(i_lambda) = dexp(-vdif(i_lambda)*action_cc)
            if(weigth(i_lambda).gt.wmax)wmax=weigth(i_lambda)
            if(weigth(i_lambda).lt.wmin)wmin=weigth(i_lambda)
         enddo
         do i_lambda = 1, n_lambda
            do s_group=0,n_groups
               if(s_group.ne.i_group)then
                  gram(s_group,i_lambda,no23) = 
     $                 gram(s_group,i_lambda,no23) 
     $                 + weigth(i_lambda)
                  do i_obs=1,no22
                     gram(s_group,i_lambda,i_obs) =
     $                    gram(s_group,i_lambda,i_obs) 
     $                    + scratch(i_obs) * weigth(i_lambda)
                  enddo
               endif
            enddo
         enddo
         
         if(i_confs .eq. n_confs)goto 1106

         goto 1104
 1105    continue
         close(f_all)
         close(f_all2)
      enddo
      goto 106
 1106 continue
      close(f_all)
      close(f_all2)

      write(f_out,*)'Maximum weigth = ',wmax
      write(f_dat,*)'Maximum weigth = ',wmax
      write(f_out,*)'Minimum weigth = ',wmin
      write(f_dat,*)'Minimum weigth = ',wmin

      do i_obs=1,no22
         do s_group=0,n_groups
            do i_lambda = 1, n_lambda
               gram(s_group,i_lambda,i_obs) =
     $              gram(s_group,i_lambda,i_obs) 
     $              / gram(s_group,i_lambda,no23)
            enddo
         enddo
      enddo

      do i_obs=no2+1,no22
         do s_group=0,n_groups
            do i_lambda = 1, n_lambda
               gram(s_group,i_lambda,i_obs) =
     $              gram(s_group,i_lambda,i_obs) 
     $              - gram(s_group,i_lambda,i_obs-no2)**2
            enddo
         enddo
      enddo

      do i_obs=19,19
         do s_group=0,n_groups
            do i_lambda = 1, n_lambda
               gram(s_group,i_lambda,i_obs) =
     $              gram(s_group,i_lambda,i_obs)  
     $              *vlam(i_lambda)**2 * float(volume)
            enddo
         enddo
      enddo

      do i_obs=1,no22
         do s_group=1,n_groups
            do i_lambda = 1, n_lambda
               gram(n_groups+1,i_lambda,i_obs) =
     $              gram(n_groups+1,i_lambda,i_obs) 
     $              + gram(s_group,i_lambda,i_obs) 
               gram(n_groups+2,i_lambda,i_obs) =
     $              gram(n_groups+2,i_lambda,i_obs) 
     $              + gram(s_group,i_lambda,i_obs)**2 
            enddo
         enddo
      enddo

      do i_obs=1,no22
            do i_lambda = 1, n_lambda
               gram(n_groups+1,i_lambda,i_obs) =
     $              gram(n_groups+1,i_lambda,i_obs) /float(n_groups)
               gram(n_groups+2,i_lambda,i_obs) =
     $              gram(n_groups+2,i_lambda,i_obs) /float(n_groups)
            enddo
      enddo

      do i_obs=1,no22
            do i_lambda = 1, n_lambda
               gram(n_groups+2,i_lambda,i_obs) = sqrt(float(n_groups)*
     $              (gram(n_groups+2,i_lambda,i_obs) 
     $              -gram(n_groups+1,i_lambda,i_obs)**2)) 
            enddo
      enddo

      do i_obs=1,no22
         do i_lambda = 1, n_lambda
            write(f_dat,202)i_obs,vlam(i_lambda)
     $           ,gram(0,i_lambda,i_obs) 
     $           ,gram(n_groups+2,i_lambda,i_obs) 
         enddo
      enddo

      close(f_dat)

      stop
 101  stop'Error opening bbbgram.dat output file'
 102  stop'Error opening .all  input file'
 103  stop'Error opening .all2 input file'
 106  stop'Error: less than n_confs configurations read'
 201  format(q,a)
 202  format(1x,'OOO',1x,i2,1x,f12.4,1x,g16.7,1x,g16.7)

      end
