/****************************************************/
/*    DIME: dime_setup.c                             */
/*    These are functions used by many              */
/*    different DIME utilities.                     */
/****************************************************/
/*        Roy Williams Copyright Caltech 1987       */
/****************************************************/

#define DIMECODE
#include "string.h"

int *allprocs;
char *buffer;
int mesh_is_distributed;
int (*distort)() = NULL;
double (*sqdist)();
/*
int (*shall_we_swop)();
int (*refine_func)();
int (*swops_func)();
*/

NODEPTR the_nodes;
ELMTPTR the_elmts;

int uns, ues, ubs;


dime_setup(argc, argv, pass_uns, pass_ues, pass_ubs, pass_mesh)
int argc;
char **argv;
int pass_uns, pass_ues, pass_ubs;
int pass_mesh;
/*
	Sets up cube parameters and triangulates the users boundary.
*/
{
	int num,max_doc;
	int default_shall_we_swop();
	double default_sqdist();

	mesh_is_distributed = pass_mesh;

/*
	swops_func = NULL;
	refine_func = NULL;
	shall_we_swop = default_shall_we_swop;
*/

	uns = pass_uns;
	ues = pass_ues;
	ubs = pass_ubs;

	/* Find max_doc = log_{base 2} nproc */
	max_doc = 0;
	num = nproc;
	while (num > 0) {
	   num /= 2;
	   max_doc++;
	}

	num = 	sizeof(_ELMT) + ues + 
			3*(sizeof(_NODE) + uns + sizeof(_BDY) + ubs) +
			16*(4 + sizeof(ALIAS));
	buffer = malloc(num);
	allprocs = (int *)malloc((1<<max_doc)*sizeof(int));
	for(num=0; num<(1<<max_doc); num++) allprocs[num] = num;

	the_nodes = (NODEPTR)NULL;
	the_elmts = (ELMTPTR)NULL;

	sqdist = default_sqdist;

	printf("**************************************************\n");
	printf("*           This is DIME version 2.0             *\n");
	printf("**************************************************\n");
	if(max_doc == 0)
	printf("*           Running on 1 processor               *\n");
	else
	printf("*           Running on %4d processors           *\n", 1<<max_doc);
	printf("**************************************************\n");
	printf("*            Copyright Caltech 1988              *\n");
	printf("**************************************************\n");
	printf("User_node size %d bytes\n", uns);
	printf("User_elmt size %d bytes\n", ues);
	printf("User_bdy  size %d bytes\n", ubs);
	fflush(stdout);

}

