/****************************************************/
/*    DIME: mesh_io.c                               */
/*    To read and write meshes & their data to disk */
/****************************************************/
/*        Roy Williams Copyright Caltech 1987       */
/****************************************************/

#include "string.h"


int (*user_read)();
int (*user_write)();

read_string()
{
	char string[100];
	double lambda, action();
	int i=0, islash, ibar=0;
	FILE *in;

    printf("Input Filename (without suffix)?\n");
    get_string(string);

	islash = -1;
	while(string[i] != '\0'){
		if(string[i] == '/')
			islash = i;
		i++;
	}
	while(string[ibar++] != '_');
	sscanf(string+ibar, "%d", &dim);
	sscanf(string+islash+6, "%lf", &lambda);
	if(string[islash+5] == 'A'){
		lambdaA = lambda;
		lambdaE = 0.0;
	} else {
		lambdaA = 0.0;
		lambdaE = lambda;
	}
	printf("Dim = %d, lambda%c = %f\n", dim, string[islash+5], lambda);
    strcat(string, ".ct");

    if((in = fopen(string, "r")) == (FILE *)NULL){
        printf("Cannot open %s\n", string);
		exit(0);
	}
    else
        readct(in);

	fill_user_structs();
	tot_action = action();
}

write_string()
{
	char filename[100];
	FILE *write;

	if(lambdaE == 0.0)
		sprintf(filename, "N%d/MeshA%4.3f_%d.ct", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/MeshE%4.3f_%d.ct", nnode, lambdaE, dim);

	printf("Writing mesh to %s\n", filename);
	if((write = fopen(filename, "w")) == NULL){
		perror(filename);
		return;
	} else
		writect(write);
}



string_read(fp, type, ptr)
FILE *fp;
int type;
char *ptr;
{
    NODEPTR n;
    ELMTPTR e;
    BDYPTR b;
	int i;

    switch(type){
		case MISC:
			return;
        case ELMT:
            e = (ELMTPTR)ptr;
            return;
        case NODE:
            n = (NODEPTR)ptr;
#ifdef DEBUG
printf("(%d)", procnum);
#endif
			for(i=0; i<dim; i++){
				fscanf(fp, "%lf", &n->user->r[i]);
#ifdef DEBUG
printf(" %f ", n->user->r[i]);
#endif
			}
#ifdef DEBUG
printf("\n");
fflush(stdout);
#endif
            return;
        case BDY:
            b = (BDYPTR)ptr;
            return;
    }
}


string_write(fp, type, ptr)
FILE *fp;
int type;
char *ptr;
{
    NODEPTR n;
    ELMTPTR e;
    BDYPTR b;
	int i;

    switch(type){
		case MISC:
			fprintf(fp, "\n");
			return;
        case ELMT:
            e = (ELMTPTR)ptr;
			fprintf(fp, "\n");
            return;
        case NODE:
            n = (NODEPTR)ptr;
			for(i=0; i<dim; i++)
				fprintf(fp, "%f ", n->user->r[i]);
			fprintf(fp, "\n");
            return;
        case BDY:
            b = (BDYPTR)ptr;
			fprintf(fp, "\n");
            return;
    }
}

