#include "string.h"

extern FILE *out;

read_aves(mes_done)
int *mes_done;
{
    char filename[100];
    FILE *in;

    sprintf(filename, "N%dVavesE%4.3f.ct", nnode, lambdaE);

    printf("Reading aves from %s\n", filename);
    if((in = fopen(filename, "r")) == (FILE *)NULL){
        printf("Cannot open aves %s\n", filename);
	exit(0);
    } else {
#ifdef CUBIX
	fmulti(in);
#endif
	fread(mes_done, sizeof(int), 1, in); 
	fread(tot_ave, sizeof(double), NOBS+2, in); 
	fread(tot_ave2, sizeof(double), NOBS+2, in); 
	fclose(in);
    }
    printf("Sweeps so far %d\n", *mes_done);
    fflush(stdout);
}


write_aves(mes_done)
int *mes_done;
{
	char filename[100];
	FILE *write;

	sprintf(filename, "N%dVavesE%4.3f.ct", nnode, lambdaE);

	printf("Writing aves to %s\n", filename);
	if((write = fopen(filename, "w")) == NULL){
	    perror(filename);
	    return;
	} else {
#ifdef CUBIX
	    fmulti(write);
#endif
	    fwrite(mes_done, sizeof(int), 1, write); 
	    fflush(write);
	    fwrite(tot_ave, sizeof(double), NOBS+2, write); 
	    fflush(write);
	    fwrite(tot_ave2, sizeof(double), NOBS+2, write); 
	    fclose(write);
	}
}


outfile()
{
	char filename[100];

	if(out != NULL)
		fclose(out);

	if(lambdaE == 0.0)
		sprintf(filename, "N%d/A%4.3f_%d", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/E%4.3f_%d", nnode, lambdaE, dim);

	/*
	printf("Sending data to %s\n", filename);
	*/

	if((out = fopen(filename, "w")) == NULL){
		perror(filename);
	}
#ifdef CUBIX
	fmulti(out);
#endif
}


ascii_print_action()
{
	int i;
	if (nnn == 1) avg_measure(act, act2);
#ifdef CUBIX
	fmulti(stdout);
#endif
	/*
	if(procnum == 0) {
	*/
		printf("Proc %d (%d):\n",procnum,nnn);
		/*
		printf("Gauss, Ln W               %10.5f %10.5f\n", GAUSS, LN_W);
		printf("Curve, Area Edge          %10.5f %10.5f\n", AREA_CURVE, EDGE_CURVE);
		printf("x2                        %10.5f\n", X2);
		printf("Success, Metro Flip       %10.5f %10.5f\n", metro_success, flip_success);
		printf("Max neigh                 %10.5f\n", NNEIGH);
		printf("Total Action              %10.5f\n", 
#ifdef ALPHA
GAUSS - alpha*LN_W + lambdaE*EDGE_CURVE);
#else
GAUSS - 0.5*dim*LN_W + lambdaE*EDGE_CURVE);
#endif
		printf("Square Gauss, Ln W        %10.5f %10.5f\n", GAUSS2, LN_W2);
		printf("Square Curve, Area Edge   %10.5f %10.5f\n", AREA_EX2, EDGE_CURVE2);
		printf("Square x2                 %10.5f\n", X22);
		*/

		printf("%10.3f %10.3f\n", BINGAUSS, BINLN_W);
		printf("%10.3f %10.3f\n", BINAREA_EX, BINEDGE_CURVE);
		printf("%10.3f %10.3f\n", BINX2,BINGAUSS_CURVE);
		printf("%10.3f %10.3f\n", BININTR_CURVE, BINDIFF_CURVE);
        printf("%10.3f %10.3f\n", BINGAUSS_2CURVE, BININTR_2CURVE);
	    printf("%10.3f %10.3f\n", BINPROD_CURVE, BINCORR_CURVE );
	    printf("\n");
		printf("%10.3f %10.3f\n", BINGAUSS2, BINLN_W2);
		printf("%10.3f %10.3f\n", BINAREA_EX2, BINEDGE_CURVE2);
        printf("%10.3f %10.3f\n", BINX22, BINGAUSS_CURVE2);
		printf("%10.3f %10.3f\n", BININTR_CURVE2, BINDIFF_CURVE2);
        printf("%10.3f %10.3f\n", BINGAUSS_2CURVE2, BININTR_2CURVE2);
	    printf("%10.3f %10.3f\n", BINPROD_CURVE2, BINCORR_CURVE2);
 	        printf(" now averages: \n");
		printf("%10.3f %10.3f\n", AVEGAUSS/nnn, AVELN_W/nnn);
		printf("%10.3f %10.3f\n", AVEAREA_EX/nnn, AVEEDGE_CURVE/nnn);
		printf("%10.3f %10.3f\n", AVEX2/nnn,AVEGAUSS_CURVE/nnn);
		printf("%10.3f %10.3f\n", AVEINTR_CURVE/nnn
	    , AVEDIFF_CURVE/nnn);
        printf("%10.3f %10.3f\n", AVEGAUSS_2CURVE/nnn,
			AVEINTR_2CURVE/nnn); 
        printf("%10.3f %10.3f\n", AVEPROD_CURVE/nnn, AVECORR_CURVE/nnn);
		printf("\n");
		printf("%10.3f %10.3f\n", AVEGAUSS2/nnn, AVELN_W2/nnn);
		printf("%10.3f %10.3f\n", AVEAREA_EX2/nnn, AVEEDGE_CURVE2/nnn);
		printf("%10.3f %10.3f\n", AVEX22/nnn,AVEGAUSS_CURVE2/nnn);
		printf("%10.3f %10.3f\n", AVEINTR_CURVE2/nnn, AVEDIFF_CURVE2/nnn);
        printf("%10.3f %10.3f\n", AVEGAUSS_2CURVE2
        /nnn, AVEINTR_2CURVE2/nnn);
	    printf("%10.3f %10.3f\n", AVEPROD_CURVE2/nnn, AVECORR_CURVE2/nnn);
		       printf(" now bin measurements: \n");
	/*
	}
	*/
#ifdef CUBIX
	fsingl(stdout);
#endif
	fflush(stdout);
}


binary_print_action()
{
/*
file out contains records with fields: TOT AVE
	0. Gaussian action
	1. Log W
	2. Area curvature
	3. Edge Curvature
	4. x2
	5. Maximum # neighbors
	6. metropolis success rate
	7. flip success rate
	+ squares of all these
*/
	float temp[NOBS+2];
	char *ptr;
	int i;
	long itemp;
	if(out == NULL)
		return;

	/* close and open file - i.e. rewind */
	outfile();

	/* write number of processors i.e. bins */
	if(procnum == 0) {
		itemp = nproc;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(&itemp,&itemp,4);
#endif
#endif
		fwrite(&itemp, sizeof(long), 1, out); 
	}

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave2[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 
	fflush(out);
}


void _ex_swaw(from, to, N)
    char *from, *to;
    int N;
{
    char q[4];
    int i;
	
    for(i=0 ; i<N/4 ; i++) {
	q[0] = *(from+3); q[1] = *(from+2);  q[2] = *(from+1); q[3] = *from;
	memcpy(to, q, 4);
	from += 4;
	to += 4;
    }
}

