
#ifdef MAIN
#define EXTERN 
#else
#define EXTERN extern
#endif

#include "dime.h"

/* Definitions */

#define MAXDIM		4
#define MAXNEIGH	256
#define NOBS		14

#define LARGE		1.e25
#define SMALL		1.e-25


/* Express variables */

EXTERN int procnum;
EXTERN long nproc;


/* Structures */

struct user_node {
	double r[MAXDIM];
	double gauss_action;
	double area_action;
	double edge_action;
	int nneigh;
};

struct user_bdy	{
	double unused;
};

struct user_elmt {
	double area;
	double edge_sq[3];
	double alt_sq[3];
	double h[MAXDIM][3];
    };

/* Data definitions */

#define GAUSS		act[0]
#define LN_W		act[1]
#define AREA_EX	act[2]
#define EDGE_CURVE	act[3]
#define X2		act[4]
#define NNEIGH		act[5]
#define GAUSS_CURVE  act[6]
#define INTR_CURVE   act[7]
#define DIFF_CURVE   act[8]
#define GAUSS_2CURVE act[9]
#define INTR_2CURVE act[10]
#define PROD_CURVE act[11]
#define CORR_CURVE act[12]

#define GAUSS2		act2[0]
#define LN_W2		act2[1]
#define AREA_EX2	act2[2]
#define EDGE_CURVE2	act2[3]
#define X22		act2[4]
#define NNEIGH2		act2[5]
#define GAUSS_CURVE2   act2[6]
#define INTR_CURVE2    act2[7]
#define DIFF_CURVE2   act2[8]
#define GAUSS_2CURVE2  act2[9]
#define INTR_2CURVE2  act[10]
#define PROD_CURVE2  act[11]
#define CORR_CURVE2 act[12]

#define BINGAUSS	bin_ave[0]
#define BINLN_W		bin_ave[1]
#define BINAREA_EX	bin_ave[2]
#define BINEDGE_CURVE	bin_ave[3]
#define BINX2		bin_ave[4]
#define BINNNEIGH	bin_ave[5]
#define BINGAUSS_CURVE  bin_ave[6]
#define BININTR_CURVE     bin_ave[7]
#define BINDIFF_CURVE  bin_ave[8]
#define BINGAUSS_2CURVE   bin_ave[9]
#define BININTR_2CURVE  bin_ave[10]
#define BINPROD_CURVE  bin_ave[11]
#define BINCORR_CURVE bin_ave[12]  

#define BINGAUSS2	bin_ave2[0]
#define BINLN_W2	bin_ave2[1]
#define BINAREA_EX2	bin_ave2[2]
#define BINEDGE_CURVE2	bin_ave2[3]
#define BINX22		bin_ave2[4]
#define BINNNEIGH2	bin_ave2[5]
#define BINGAUSS_CURVE2  bin_ave2[6]
#define BININTR_CURVE2     bin_ave2[7]
#define BINDIFF_CURVE2   bin_ave2[8]
#define BINGAUSS_2CURVE2   bin_ave2[9]
#define BININTR_2CURVE2  bin_ave2[10]
#define BINPROD_CURVE2 bin_ave2[11]
#define BINCORR_CURVE2 bin_ave2[12]

#define AVEGAUSS	tot_ave[0]
#define AVELN_W		tot_ave[1]
#define AVEAREA_EX	tot_ave[2]
#define AVEEDGE_CURVE	tot_ave[3]
#define AVEX2		tot_ave[4]
#define AVENNEIGH	tot_ave[5]
#define AVEGAUSS_CURVE    tot_ave[6]
#define AVEINTR_CURVE     tot_ave[7]
#define AVEDIFF_CURVE   tot_ave[8]
#define AVEGAUSS_2CURVE   tot_ave[9]
#define AVEINTR_2CURVE tot_ave[10]
#define AVEPROD_CURVE tot_ave[11]
#define AVECORR_CURVE tot_ave[12]

#define AVEGAUSS2	tot_ave2[0]
#define AVELN_W2	tot_ave2[1]
#define AVEAREA_EX2	tot_ave2[2]
#define AVEEDGE_CURVE2	tot_ave2[3]
#define AVEX22		tot_ave2[4]
#define AVENNEIGH2	tot_ave2[5]
#define AVEGAUSS_CURVE2    tot_ave2[6]
#define AVEINTR_CURVE2     tot_ave2[7]
#define AVEDIFF_CURVE2    tot_ave2[8]
#define AVEGAUSS_2CURVE2   tot_ave2[9]
#define AVEINTR_2CURVE2   tot_ave2[10]
#define AVEPROD_CURVE2 tot_ave2[11]
#define AVECORR_CURVE2 tot_ave2[12]

EXTERN double bin_ave[NOBS+2];
EXTERN double bin_ave2[NOBS+2];
EXTERN double tot_ave[NOBS+2];
EXTERN double tot_ave2[NOBS+2];
EXTERN double act[NOBS+2];
EXTERN double act2[NOBS+2];

EXTERN int nnode;       /* Number of nodes */
EXTERN double alpha, lambdaA, lambdaE, tot_action;
EXTERN double metro_success, flip_success;
EXTERN int binsize, bins_per_write, sweeps_per_write;

#ifndef MAIN
extern int nnn;
extern int dim;
extern double hit_size;
#endif

