
      PROGRAM timings

      INTEGER flag

C      PRINT *,'1 : a + b '
C      PRINT *,'2 : a * b '
C      PRINT *,'3 : a / b '
C      PRINT *,'4 : a + b * c '
C      PRINT *,'5 : sqrt(a) '
C      PRINT *,'6 : exp(a) '

      READ(5,*) flag
      PRINT *, 'flag = ', flag

      IF (flag.EQ.1) THEN
	 CALL time_add
      ELSE IF (flag.EQ.2) THEN
	 CALL time_mult
      ELSE IF (flag.EQ.3) THEN 
         CALL time_both
      ELSE IF (flag.EQ.4) THEN 
         CALL time_div
      ELSE IF (flag.EQ.5) THEN 
          CALL time_sqrt
      ELSE IF (flag.EQ.6) THEN 
          CALL time_exp
      ENDIF

      STOP
      END

C______________________________________________________________________

      SUBROUTINE time_add
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,sum

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      a_init = 6434.3243
      b_init = 3340.49033

      sum = 0.0

      DO isweep=1, nsweeps
 
	 a = a_init + isweep
	 b = b_init + isweep
	 c = a + b
	 b = b + c
	 d = b + c - a
	 sum = sum - a + b + c + d

      ENDDO

      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END

C_______________________________________________________________________


      SUBROUTINE time_mult
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,sum,inv_nsweeps

      a_init = 126.3243
      b_init = 1.49033

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      sum = 0

      inv_nsweeps = 1 / float(nsweeps)

      DO isweep=1, nsweeps
 
	 a = a_init * isweep * inv_nsweeps
	 b = b_init * a
	 c = a * b
	 b = c * a
	 a = b * c * a
	 d = b * c
	 c = a * b 
	 a = c * d
	 sum = sum + a

      ENDDO
      
      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END

C_______________________________________________________________________


      SUBROUTINE time_div
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,sum,inv_nsweeps

      a_init = 128.3243
      b_init = 0.49033

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      sum = 0

      inv_nsweeps = 1.0 / float(nsweeps)

      DO isweep=1, nsweeps
 
	 a = a_init / isweep
	 b = b_init / (a + a_init)  
	 c = (a / b) / inv_nsweeps
	 b = c / a
	 a = (b / c) / a
	 d = b / c
	 c = a / b 
	 a = c / d
	 sum = sum + a 

      ENDDO
      
      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END


C_______________________________________________________________________


      SUBROUTINE time_both
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,sum,inv_nsweeps

      a_init = 6.3243
      b_init = 0.49033

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      sum = 0.0

      inv_nsweeps = 1.0 / float(nsweeps)

      DO isweep=1, nsweeps
 
	 a = a_init * isweep - 20.10943
	 b = b_init * inv_nsweeps + 0.000002323
	 c = a * b + b_init
	 b = c * b_init - a_init
	 a = (a + c) * inv_nsweeps + a_init * b
	 b = a + b * c
	 d = a + c * 0.314159
	 c = a * b - d
	 a = a_init + c * d
	 sum = sum + a

      ENDDO
      
      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END

C_______________________________________________________________________


      SUBROUTINE time_sqrt
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,sum

      a_init = 687364.3243
      b_init = 93844.49033

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      sum = 0

      DO isweep=1, nsweeps
 
	 a = a_init + isweep
	 b = b_init + isweep
	 c = sqrt(a) 
	 d = sqrt(b) 
	 a = sqrt(c) 
	 b = sqrt(d) 
	 c = sqrt(a) 
	 d = sqrt(b) 
	 a = sqrt(c) 
	 b = sqrt(d) 
	 c = sqrt(a) 
	 d = sqrt(b) 
	 sum = sum + c + d

      ENDDO
      
      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END

C_______________________________________________________________________



      SUBROUTINE time_exp
      
      INTEGER isweep, nsweeps
      REAL*8 a,b,c,d,a_init,b_init,add,sum

      a_init = 4.33847243
      b_init = 0.0384449033

      READ(5,*) nsweeps
      PRINT *, 'nsweeps = ', nsweeps

      sum = 0

      DO isweep=1, nsweeps
 
	 add = float(isweep) / float(nsweeps)
	 a = a_init - add
	 b = b_init - add
	 c = exp(a) 
	 d = exp(b) 
	 a = a_init + add
	 b = b_init + add
	 a = exp(a) 
	 b = exp(b) 
	 sum = sum + a + b - c - d

      ENDDO
      
      PRINT *, ' '
      PRINT *, 'a = ', a
      PRINT *, 'b = ', b
      PRINT *, 'c = ', c
      PRINT *, 'd = ', d
      PRINT *, 'sum = ', sum

      RETURN
      END

C_______________________________________________________________________

