
      IMPLICIT NONE

      INTEGER nx, ny, n, nm, n6, n6m
      INTEGER dim, dm, g_slow, n_obs
      INTEGER f_out, f_all, f_all2, f_ico, f_oco
      CHARACTER * 7 default, white, black, red, green, blue, cyan
      CHARACTER * 7 magenta, yellow
      real two_pi

      PARAMETER ( nx =      6 )
      PARAMETER ( ny =      6 )
      PARAMETER ( n_obs = 12 )
      PARAMETER ( n  = nx * ny )
      PARAMETER ( n6 = 6 * n )
      PARAMETER ( n6m = n6 - 1 )
      PARAMETER ( nm =   n - 1 )
      PARAMETER ( dim = 3 )
      PARAMETER ( dm = dim - 1 )
      PARAMETER ( g_slow =   1 )
      PARAMETER ( f_out = 1 )
      PARAMETER ( f_ico = 2 )
      PARAMETER ( f_oco = 3 )
      PARAMETER ( f_all = 81 )
      PARAMETER ( f_all2 = 82 )
      PARAMETER ( two_pi = 6.283185307 )
      PARAMETER ( default = 'default' )
      PARAMETER ( white   = 'white' )
      PARAMETER ( black   = 'black' )
      PARAMETER ( red     = 'red' )
      PARAMETER ( green   = 'green' )
      PARAMETER ( blue    = 'blue' )
      PARAMETER ( cyan    = 'cyan' )
      PARAMETER ( magenta = 'magenta' )
      PARAMETER ( yellow  = 'yellow' )

      INTEGER i_seed1, i_seed2, time_scale, n_sweeps, i_sweep
      INTEGER write_all, i_correlated, n_correlated, n_discard
      INTEGER i_one_sweep
      INTEGER start_mode

      INTEGER m_start_s(0:nm), m_end_s(0:nm)
      INTEGER n_connectivity_s(0:nm)
      INTEGER s_neighbor_m(0:n6m)
      INTEGER m_next_m(0:n6m), m_former_m(0:n6m), m_back_m(0:n6m)
      INTEGER s_site_m(0:n6m), s_right_m(0:n6m), s_left_m(0:n6m)
      INTEGER c_copyx_m(0:n6m), c_copyy_m(0:n6m)
      INTEGER c_coprx_m(0:n6m), c_copry_m(0:n6m)
      INTEGER c_coplx_m(0:n6m), c_coply_m(0:n6m)
      INTEGER g_i_n_copy, g_i_n_add

      REAL anx2, any2, md_half
      REAL tlog(0:n6m)
      REAL field(0:dm,0:nm)
      REAL square_m(0:n6m), lno_m(0:dm,0:n6m), rno_m(0:dm,0:n6m)
      REAL g_n_copy, g_n_add, offx, offy
      REAL sw_lacc, sw_sacc
      REAL sw_c2x, sw_c2y, sw_sxs, sw_msxs, sw_sys, sw_msys
      REAL old_action, new_action, scale, trial, lambda
      REAL rand_uni

      REAL*8 ind_lacc, ind_sacc, tot_lacc, tot_sacc
      REAL*8 sw_obs(n_obs), ind_obs(2,n_obs), tot_obs(2,3,n_obs)

      CHARACTER g_input_char
      CHARACTER * 1 bibbol
      CHARACTER * 7 color(9)
      CHARACTER * 10 phrase(n_obs)

      COMMON/table/tlog
      COMMON /ic / i_seed1, i_seed2, time_scale
     $     ,n_sweeps, i_sweep, write_all,start_mode
     $     ,i_correlated, n_correlated, n_discard,i_one_sweep
      COMMON /bib/ bibbol
      COMMON /scratch/rand_uni
      COMMON /flotta/ anx2, any2, md_half
      COMMON / site / n_connectivity_s
      COMMON/link/ m_start_s, m_end_s, s_neighbor_m, m_next_m,
     $     m_former_m, c_copyx_m, c_copyy_m, s_site_m, m_back_m
      COMMON/triangle/
     $     c_coprx_m, c_copry_m, c_coplx_m, c_coply_m,
     $     s_right_m, s_left_m
      COMMON/two/ g_input_char, color, g_i_n_copy, g_i_n_add, g_n_copy
     $     , g_n_add, offx, offy, phrase
      COMMON/obs_sw/sw_sacc, sw_lacc, sw_c2x, sw_c2y
     $     ,sw_sxs, sw_msxs, sw_sys, sw_msys
      COMMON/all_acc/tot_lacc, tot_sacc, ind_lacc, ind_sacc
      COMMON/new_obs/sw_obs, ind_obs, tot_obs
      COMMON/fields/field, scale, trial, lambda
      COMMON/actions/old_action, new_action
      COMMON/fast/square_m, rno_m, lno_m

      REAL rand_u(97), rand_c, rand_cd, rand_cm
      INTEGER rand_i97, rand_j97, rand_ivec
      LOGICAL rand_test
      COMMON /raset1/ rand_u, rand_c, rand_cd, rand_cm, rand_i97
     $     , rand_j97, rand_ivec, rand_test

CC======== new variables for express ===========

      integer num_nodes
      parameter (num_nodes = 4 )
      integer nddata(4)
      common /node_info/ nddata
