
/*JOB=XXS12A,XEQ=KR2,ALL=M22,CASE=832,ACCT=(745000800,SPT000230)
S12A,STCRB.
JOB,JN=ABS12A,M=1000,T=1000,CL=CD.
OPTION,LPP=60.
*ACCESS,DN=FT14,PDN=C72D6N120,ID=PHILIPPE.
*SKIPF,DN=FT14.
CFT,OFF=CT.
LDR,SET=INDEF.
SAVE,DN=FT15,PDN=C72D12N240,ID=PHILIPPE,RT=300.
EXIT.
DUMPJOB.
DEBUG,BLOCKS.MAXDIM=144:144.
FLODUMP.
/EOF
      PROGRAM MAIN
C ----------------------------------------------------------------------
      PARAMETER ( NP = 3 )
      PARAMETER ( NH = 2 )
      PARAMETER ( LD = 12 )
      PARAMETER ( LP = 3*NP )
      PARAMETER ( LH = 3*NH+2 )
      PARAMETER ( LA = LP*LH )
      PARAMETER ( LVE = LH*NP )
      PARAMETER ( NHI = 2 )
      PARAMETER ( NBOX = 100 )
      PARAMETER ( I7 = 4+2*LD+LD*LD+7+NBOX )
      COMMON/ALL/PO(LD,-LH+1:LA+LH),EPS,EPSH,IBAV,BMAX
      COMMON/META/RMIN(LD),RMAX(LD),RATE,ARE,SCA
     &           ,SEC,RMO(LD),RQMO(LD),AIN(LD,LD),ABOX
     &           ,BOX(NBOX),R4,R6,R8,CORP,CORH,CORD
C ----------------------------------------------------------------------
C     ISTST=0 FOR THE COLD START
      ISTST=0
      EPS=.7
C NUMBER OF ITERATIONS
      LSTART=500
      IBAV=0
      NJOB=48
      RSTART=.5
      BMAX=5.
      CALL MC (ISTST,LSTART,NJOB,RSTART,.FALSE.)
      STOP
      END
C ----------------------------------------------------------------------
      SUBROUTINE MC (ISTST,LSTART,NJOB,RSTART,SHORT)
C ----------------------------------------------------------------------
      PARAMETER ( NP = 3 )
      PARAMETER ( NH = 2 )
      PARAMETER ( LD = 12 )
      PARAMETER ( LP = 3*NP )
      PARAMETER ( LH = 3*NH+2 )
      PARAMETER ( LA = LP*LH )
      PARAMETER ( LVE = LH*NP )
      PARAMETER ( NHI = 2 )
      PARAMETER ( NBOX = 100 )
      PARAMETER ( I7 = 4+2*LD+LD*LD+7+NBOX )
      COMMON/ALL/PO(LD,-LH+1:LA+LH),EPS,EPSH,IBAV,BMAX
      COMMON/META/RMIN(LD),RMAX(LD),RATE,ARE,SCA
     &           ,SEC,RMO(LD),RQMO(LD),AIN(LD,LD),ABOX
     &           ,BOX(NBOX),R4,R6,R8,CORP,CORH,CORD
      DIMENSION C(2*LD+I7)
      DIMENSION DIFF(LD)
C ----------------------------------------------------------------------
      DIMENSION COMMENT(8)
      LOGICAL SHORT
      DIMENSION AMEAN(2*(2*LD+I7)),AM(2*LD+I7),ASD(2*LD+I7)
      EQUIVALENCE ( RMIN(1) , C(1) )
      CHARACTER*10 TITRE1(12),TITRE2(12)
      CHARACTER*10 TITRE3(12),TITRE4(12)
      CHARACTER*10 TITRE5(12)
      CHARACTER*8 VERSION
      DATA VERSION /'MARK   4'/
      DATA TITRE1/12*'          '/
      DATA TITRE2/12*'          '/
      DATA TITRE3/12*'          '/
      DATA TITRE4/12*'          '/
      DATA TITRE5/12*'          '/
      TITRE1(1)='RMIN'
      TITRE1(LD+1)='RMAX'
      TITRE2(1)='ACCE RATE'
      TITRE2(2)='AREA'
      TITRE2(3)='SCALAR PR'
      TITRE2(4)='X CARRE'
      TITRE2(5)='CENTER'
      TITRE2(LD+5)='INERTIA'
      TITRE3(1)='TENSOR'
      IF(LD.LT.4) TITRE3(LD**2+1)='VOLUME'
      IF(LD.GE.4) TITRE3(12)='????????'
      TITRE4(1)='HISTOGRA'
      TITRE5(1)='R4'
      TITRE5(2)='R6'
      TITRE5(3)='R8'
      TITRE5(4)='COR P'
      TITRE5(5)='COR H'
      TITRE5(6)='COR D'
C **********************************************************************
      EPSH=EPS*.5
      JD=DATE()
      JH=CLOCK()
C **********************************************************************
      WRITE(6,101) JD,JH,LH,LP,LD,BMAX
 101   FORMAT('1    PROGRAM FOR SURFACE THEORY'
     &  ,10X,2A10,/'     LATTICE SIZE: ',I4,' * ',I4,40X,'D =',I3
     &  ,10X,' BMAX=',F6.2)
      WRITE(6,104)NJOB,LSTART,IBAV,EPS
104   FORMAT('     NUMBER OF ITERATIONS',I6,' *',I6,'  DISCARDED',I5
     &       ,/'     EPS  =  ',F10.6)
C **********************************************************************
      CALL REMARK (' ')
      ENCODE (64,100,COMMENT) LH,LP,NJOB,LSTART
100   FORMAT(' LATTICE SIZE = ',I4,' *',I4,I10,' *',I5,'  ITERATIONS')
      CALL REMARK (COMMENT)
C **********************************************************************
      IF (ISTST.EQ.0) THEN
         DO 6769 I=1,LD
         DO 6769 J=1,LA
         PO(I,J)=RSTART*(1.-2.*RANF())
6769     CONTINUE
         ENCODE (64,110,COMMENT) RSTART
110      FORMAT(' COLD START',5X,'R =',F6.2)
      ELSE
         BACKSPACE 14
         BACKSPACE 14
         READ(14)JDO,JHO,SEED,LHO,LPO,EPSO,LDO,LSWEEP,PO
         IF ( LHO.NE.LH .OR. LPO.NE.LP .OR. LDO.NE.LD )
     &   CALL ABORT ('MISMATCH')
         CALL RANSET(SEED)
         ENCODE (64,111,COMMENT) JDO,JHO
111      FORMAT (' STARTING FROM',2A10,'    ')
      ENDIF
      CALL REMARK (COMMENT)
      PRINT 112 ,COMMENT
112   FORMAT (8A8)
      CALL REMARK (' ')
      NSWEEP=0
      DO 30 IJOB=1,NJOB
      IJ=0
      DO 40 I=1,2*LD+I7
      DO 50 J=1,2
      IJ=IJ+1
50    AMEAN(IJ)=0.
      AM(I)=0.
40    ASD(I)=0.
C **********************************************************************
      DO 2 IB=1,LSTART
      IF(IJOB.EQ.2) IBAV=0
      NSWEEP=NSWEEP+1
      CALL SURF(SHORT)
      IF(IB.GT.IBAV)THEN
      IF ( .NOT.SHORT) CALL MEASU
      DO 10 I=1,2*LD+I7
10    AMEAN(I)=AMEAN(I)+C(I)
      DO 20 I=1,2*LD+I7
20    AMEAN(2*LD+I7+I)=AMEAN(2*LD+I7+I)+C(I)**2
      IF(MOD(1*IB,LSTART).EQ.0)THEN
      ANU=IB-IBAV
      ANUM=IB-IBAV-1
      IF(IB.EQ.IBAV+1)ANUM=1.
      DO 11 I=1,I7+2*LD
      AM(I)=AMEAN(I)/ANU
      ASD(I)=AMEAN(I+I7+2*LD)/ANU
11    ASD(I)=SQRT((ASD(I)-AM(I)**2)/ANUM)
      PRINT 140,TITRE1
      PRINT 120,NSWEEP,(AM(IW),IW=1,2*LD)
      PRINT 130,(ASD(IW),IW=1,2*LD)
      PRINT 140,TITRE2
      PRINT 130,(AM (IW),IW=2*LD+1,4*LD+4)
      PRINT 130,(ASD(IW),IW=2*LD+1,4*LD+4)
      PRINT 140,TITRE3
      PRINT 130,(AM (IW),IW=4*LD+5,LD**2+4*LD+5)
      PRINT 130,(ASD(IW),IW=4*LD+5,LD**2+4*LD+5)
      IF (.NOT.SHORT) THEN
      PRINT 140,TITRE4
      PRINT 130,(AM (IW),IW=LD**2+4*LD+6,LD**2+4*LD+5+NBOX)
      PRINT 130,(ASD(IW),IW=LD**2+4*LD+6,LD**2+4*LD+5+NBOX)
      PRINT 140,TITRE5
      PRINT 130,(AM (IW),IW=LD**2+4*LD+6+NBOX,LD**2+4*LD+11+NBOX)
      PRINT 130,(ASD(IW),IW=LD**2+4*LD+6+NBOX,LD**2+4*LD+11+NBOX)
      ENDIF
      SUM=0.
      DO 210 ID=1,LD
      DIFF(ID)= AM(LD+ID) - AM(ID)
210   SUM=SUM+DIFF(ID)
      SUM=SUM/LD
      PRINT 200 , SUM,DIFF
200   FORMAT(/,' MEAN BOX LENGTH',3X,G8.3,5X,12G8.3)
140   FORMAT(/,9X,12A10)
      ENDIF
120   FORMAT(1X,I7,12G10.3,/,(8X,12G10.3))
130   FORMAT(8X,12G10.3)
      ENDIF
      SEED = RANGET ()
      X=RANF()
C*************************  RANGET LOOSES ONE RANDOM NUMBER !!
 2    CONTINUE
      PRINT 1984
1984  FORMAT('1')
C **********************************************************************
30       WRITE(15)JD,JH,SEED,LH,LP,EPS,LD,NJOB*LSTART-IBAV,PO,AM,ASD
     &           ,BMAX,NBOX,VERSION
      WRITE(6,103)
 103  FORMAT(//,'---------------------------------------')
      RETURN
      END
C ----------------------------------------------------------------------
      SUBROUTINE SURF(MEAS)
C ----------------------------------------------------------------------
      LOGICAL MEAS
      PARAMETER ( NP = 3 )
      PARAMETER ( NH = 2 )
      PARAMETER ( LD = 12 )
      PARAMETER ( LP = 3*NP )
      PARAMETER ( LH = 3*NH+2 )
      PARAMETER ( LA = LP*LH )
      PARAMETER ( LVE = LH*NP )
      PARAMETER ( NHI = 2 )
      PARAMETER ( NBOX = 100 )
      PARAMETER ( I7 = 4+2*LD+LD*LD+7+NBOX )
      COMMON/ALL/PO(LD,-LH+1:LA+LH),EPS,EPSH,IBAV,BMAX
      COMMON/META/RMIN(LD),RMAX(LD),RATE,ARE,SCA
     &           ,SEC,RMO(LD),RQMO(LD),AIN(LD,LD),ABOX
     &           ,BOX(NBOX),R4,R6,R8,CORP,CORH,CORD
C ----------------------------------------------------------------------
      DIMENSION DIS(6,LD,LVE),R2(6,LVE),RS(6,LVE),PNE(6,LD,LVE)
     1         ,AR(LVE),BFO(LVE),BFN(LVE),PT(LD,LVE),ACCEPT(LVE)
     2         ,POM(LD,LA)
C ----------------------------------------------------------------------
      RATE = 0.
      IF (MEAS) THEN
      ARE  = 0.
      SEC = 0.
      SCA  = 0.
      DO 3 ID=1,LD
      RMO(ID)=0.
      RQMO(ID)=0.
      DO 3 KD=1,LD
      AIN(ID,KD)=0.
3     CONTINUE
      ENDIF
C ----------------------------------------------------------------------
      DO 10 ICO=1,3
      CALL SCOPY ( LD*LH , PO ( 1,LA-LH+1 ) , 1 , PO ( 1,-LH+1 ) , 1 )
      CALL SCOPY ( LD*LH , PO ( 1,1       ) , 1 , PO ( 1, LA+1 ) , 1 )
      DO 5 I=1,6
      DO 5 IVE=1,LVE
      R2(I,IVE)=0.
      RS(I,IVE)=0.
5     CONTINUE
C ----------------------------------------------------------------------
      DO 20 ID=1,LD
C ----------------------------------------------------------------------
      IPO=ICO-3
      DO 21 IVE=1,LVE
      IPO=IPO+3
      IPD=IPO+1
      IPG=IPO-1
      IPUD=IPO+LH
      IPUG=IPUD-1
      IPDG=IPO-LH
      IPDD=IPDG+1
      PNE(1,ID,IVE)=PO(ID,IPD)
      PNE(2,ID,IVE)=PO(ID,IPUD)
      PNE(3,ID,IVE)=PO(ID,IPUG)
      PNE(4,ID,IVE)=PO(ID,IPG)
      PNE(5,ID,IVE)=PO(ID,IPDG)
      PNE(6,ID,IVE)=PO(ID,IPDD)
21    CONTINUE
C ----------------------------------------------------------------------
      DO 22 I=1,6
      IPO=ICO-3
      DO 22 IVE=1,LVE
      IPO=IPO+3
22    DIS(I,ID,IVE)=PNE(I,ID,IVE)-PO(ID,IPO)
C ----------------------------------------------------------------------
      DO 20 I=1,6
      IP=MOD(I,6)+1
      DO 20 IVE=1,LVE
      R2(I,IVE)=R2(I,IVE) + DIS(I,ID,IVE)**2
20    RS(I,IVE)=RS(I,IVE) + DIS(I,ID,IVE) * DIS(IP,ID,IVE)
C ----------------------------------------------------------------------
      DO 25 IVE=1,LVE
25    AR(IVE)=0.
C ----------------------------------------------------------------------
      DO 30 I=1,6
      IP=MOD(I,6)+1
      DO 30 IVE=1,LVE
      AR(IVE)=AR(IVE)
     & + .5*SQRT( ABS ( R2(I,IVE)*R2(IP,IVE)-RS(I,IVE)**2 )  )
30    CONTINUE
C ----------------------------------------------------------------------
      DO 40 IVE=1,LVE
40    BFO(IVE)=EXP(-AR(IVE))
C ----------------------------------------------------------------------
      IF (MEAS) THEN
      SS   = SSUM ( LVE , AR , 1 )
      ARE  = ARE + SS
C
      SS   = SSUM ( 6*LVE , RS , 1 )
      SCA  = SCA + SS
C
      SS   = SSUM ( 6*LVE , R2 , 1 )
      SEC  = SEC + SS
C
      ENDIF
C ----------------------------------------------------------------------
      DO 50 IHI=1,NHI
C ----------------------------------------------------------------------
      DO 55 I=1,6
      DO 55 IVE=1,LVE
      R2(I,IVE)=0.
      RS(I,IVE)=0.
55    CONTINUE
C ----------------------------------------------------------------------
      DO 60 ID=1,LD
      IPO=ICO-3
      DO 70 IVE=1,LVE
      IPO=IPO+3
70    PT(ID,IVE)=PO(ID,IPO)+EPSH-EPS*RANF()
C ----------------------------------------------------------------------
      DO 80 I=1,6
      IP=MOD(I,6)+1
      DO 80 IVE=1,LVE
      R2(I,IVE)=R2(I,IVE) + (PNE(I ,ID,IVE)-PT(ID,IVE))**2
      RS(I,IVE)=RS(I,IVE) + (PNE(I ,ID,IVE)-PT(ID,IVE)) *
     &                      (PNE(IP,ID,IVE)-PT(ID,IVE))
80    CONTINUE
60    CONTINUE
C ----------------------------------------------------------------------
      DO 85 IVE=1,LVE
85    AR(IVE)=0.
C ----------------------------------------------------------------------
      DO 90 I=1,6
      IP=MOD(I,6)+1
      DO 90 IVE=1,LVE
      AR(IVE)=AR(IVE)
     & + .5*SQRT( ABS ( R2(I,IVE)*R2(IP,IVE)-RS(I,IVE)**2 )  )
90    CONTINUE
C ----------------------------------------------------------------------
      DO 100 IVE=1,LVE
100   BFN(IVE)=EXP(-AR(IVE))
C ----------------------------------------------------------------------
      DO 110 IVE=1,LVE
      ACCEPT(IVE)=BFO(IVE)*RANF()-BFN(IVE)
110   BFO(IVE)=CVMGM(BFN(IVE),BFO(IVE),ACCEPT(IVE))
      DO 120 ID=1,LD
      IPO=ICO-3
      DO 120 IVE=1,LVE
      IPO=IPO+3
120   PO(ID,IPO)=CVMGM(PT(ID,IVE),PO(ID,IPO),ACCEPT(IVE))
C ----------------------------------------------------------------------
      IFA = ILSUM ( LVE , ACCEPT , 1 )
      RATE= RATE + FLOAT(IFA)
50    CONTINUE
C ----------------------------------------------------------------------
10    CONTINUE
C ----------------------------------------------------------------------
      IF (MEAS) THEN
      DO 45 ID=1,LD
      SS   = SSUM ( LA ,PO(ID,1),LD )
      RMO(ID)=SS
      SS   = SNRM2( LA ,PO(ID,1),LD )
45    RQMO(ID)=SS**2
      DO 47 ID=1,LD-1
      DO 47 KD=ID+1,LD
47    AIN(ID,KD)=SDOT(LA,PO(ID,1),LD,PO(KD,1),LD)
      ENDIF
      RATE = RATE /(LA*NHI)
      IF (MEAS) THEN
      ARE  = ARE  / 3.
      SCA  = SCA  /(LA*6.)
      SEC  = SEC  /(LA*6.)
      DO 140 ID=1,LD
      RMO(ID)=RMO(ID)/LA
      RQMO(ID)=RQMO(ID)/LA
      RQMO(ID)=RQMO(ID)-RMO(ID)**2
      DO 130 IA=1,LA
130   POM(ID,IA)=-PO(ID,IA)
      RMIN(ID)=PO(ID,ISMIN(LA,PO(ID,1),LD))
140   RMAX(ID)=PO(ID,ISMIN(LA,POM(ID,1),LD))
      DO 150 ID=1,LD-1
      DO 150 KD=ID+1,LD
150   AIN(ID,KD)=AIN(ID,KD)/LA-RMO(ID)*RMO(KD)
      ABOX=1.
      DO 160 ID=1,LD
160   ABOX=ABOX*(RMAX(ID)-RMIN(ID))
      ENDIF
      RETURN
      END
      SUBROUTINE MEASU
C ----------------------------------------------------------------------
      PARAMETER ( NP = 3 )
      PARAMETER ( NH = 2 )
      PARAMETER ( LD = 12 )
      PARAMETER ( LP = 3*NP )
      PARAMETER ( LH = 3*NH+2 )
      PARAMETER ( LA = LP*LH )
      PARAMETER ( LVE = LH*NP )
      PARAMETER ( NHI = 2 )
      PARAMETER ( NBOX = 100 )
      PARAMETER ( I7 = 4+2*LD+LD*LD+7+NBOX )
      COMMON/ALL/PO(LD,-LH+1:LA+LH),EPS,EPSH,IBAV,BMAX
      COMMON/META/RMIN(LD),RMAX(LD),RATE,ARE,SCA
     &           ,SEC,RMO(LD),RQMO(LD),AIN(LD,LD),ABOX
     &           ,BOX(NBOX),R4,R6,R8,CORP,CORH,CORD
C ----------------------------------------------------------------------
      DIMENSION DIS(6,LD,LVE),R2(6,LVE),RS(6,LVE),PNE(6,LD,LVE)
     1         ,AR(6,LVE),BFO(LVE),BFN(LVE),PT(LD,LVE),ACCEPT(LVE)
     2         ,POM(LD,LA)
      DIMENSION REL(LD,LA),R4MO(LA),R6MO(LA),R8MO(LA)
     1         ,AWAY(LA),IAWAY(LA)
      DIMENSION DOUBLE ( LD,2*LA )
C ----------------------------------------------------------------------
      ARE  = 0.
      SEC = 0.
      SCA  = 0.
      DO 3 ID=1,LD
      RMO(ID)=0.
      RQMO(ID)=0.
      DO 3 KD=1,LD
      AIN(ID,KD)=0.
3     CONTINUE
C ----------------------------------------------------------------------
      ICO=1
      CALL SCOPY ( LD*LH , PO ( 1,LA-LH+1 ) , 1 , PO ( 1,-LH+1 ) , 1 )
      CALL SCOPY ( LD*LH , PO ( 1,1       ) , 1 , PO ( 1, LA+1 ) , 1 )
      DO 5 I=1,6
      DO 5 IVE=1,LVE
      R2(I,IVE)=0.
      RS(I,IVE)=0.
5     CONTINUE
C ----------------------------------------------------------------------
      DO 20 ID=1,LD
C ----------------------------------------------------------------------
      IPO=ICO-3
      DO 21 IVE=1,LVE
      IPO=IPO+3
      IPD=IPO+1
      IPG=IPO-1
      IPUD=IPO+LH
      IPUG=IPUD-1
      IPDG=IPO-LH
      IPDD=IPDG+1
      PNE(1,ID,IVE)=PO(ID,IPD)
      PNE(2,ID,IVE)=PO(ID,IPUD)
      PNE(3,ID,IVE)=PO(ID,IPUG)
      PNE(4,ID,IVE)=PO(ID,IPG)
      PNE(5,ID,IVE)=PO(ID,IPDG)
      PNE(6,ID,IVE)=PO(ID,IPDD)
21    CONTINUE
C ----------------------------------------------------------------------
      DO 22 I=1,6
      IPO=ICO-3
      DO 22 IVE=1,LVE
      IPO=IPO+3
22    DIS(I,ID,IVE)=PNE(I,ID,IVE)-PO(ID,IPO)
C ----------------------------------------------------------------------
      DO 20 I=1,6
      IP=MOD(I,6)+1
      DO 20 IVE=1,LVE
      R2(I,IVE)=R2(I,IVE) + DIS(I,ID,IVE)**2
20    RS(I,IVE)=RS(I,IVE) + DIS(I,ID,IVE) * DIS(IP,ID,IVE)
C ----------------------------------------------------------------------
      DO 30 I=1,6
      IP=MOD(I,6)+1
      DO 30 IVE=1,LVE
      AR(I,IVE)=
     &   .5*SQRT( ABS ( R2(I,IVE)*R2(IP,IVE)-RS(I,IVE)**2 )  )
30    CONTINUE
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
C
      SS   = SSUM ( 6*LVE , AR , 1 )
      ARE  = ARE + SS
C
      SS   = SSUM ( 6*LVE , RS , 1 )
      SCA  = SCA + SS
C
      SS   = SSUM ( 6*LVE , R2 , 1 )
      SEC  = SEC + SS
C
C ----------------------------------------------------------------------
C ----------------------------------------------------------------------
10    CONTINUE
C ----------------------------------------------------------------------
      DO 45 ID=1,LD
      SS   = SSUM ( LA ,PO(ID,1),LD )
      RMO(ID)=SS
      SS   = SNRM2( LA ,PO(ID,1),LD )
45    RQMO(ID)=SS**2
      DO 47 ID=1,LD-1
      DO 47 KD=ID+1,LD
47    AIN(ID,KD)=SDOT(LA,PO(ID,1),LD,PO(KD,1),LD)
      SCA  = SCA  /(LA*2.)
      SEC  = SEC  /(LA*2.)
      DO 140 ID=1,LD
      RMO(ID)=RMO(ID)/LA
      RQMO(ID)=RQMO(ID)/LA
      RQMO(ID)=RQMO(ID)-RMO(ID)**2
      DO 130 IA=1,LA
130   POM(ID,IA)=-PO(ID,IA)
      RMIN(ID)=PO(ID,ISMIN(LA,PO(ID,1),LD))
140   RMAX(ID)=PO(ID,ISMIN(LA,POM(ID,1),LD))
      DO 150 ID=1,LD-1
      DO 150 KD=ID+1,LD
150   AIN(ID,KD)=AIN(ID,KD)/LA-RMO(ID)*RMO(KD)
      ABOX=1.
      DO 160 ID=1,LD
160   ABOX=ABOX*(RMAX(ID)-RMIN(ID))
      DO 170 ID=1,LD
      DO 170 ILA=1,LA
170   REL(ID,ILA)=PO(ID,ILA)-RMO(ID)
      DO 175 ILA=1,LA
      R4MO(ILA)=0.
      R6MO(ILA)=0.
175   R8MO(ILA)=0.
      DO 180 ID=1,LD
      DO 180 ILA=1,LA
      R4MO(ILA)=R4MO(ILA)+REL(ID,ILA)**4
      R6MO(ILA)=R6MO(ILA)+REL(ID,ILA)**6
180   R8MO(ILA)=R8MO(ILA)+REL(ID,ILA)**8
      R4 = SSUM ( LA , R4MO , 1 ) / (LA*LD)
      R6 = SSUM ( LA , R6MO , 1 ) / (LA*LD)
      R8 = SSUM ( LA , R8MO , 1 ) / (LA*LD)
      DO 190 ISCA=1,NBOX
190   BOX(ISCA)=0.
      DO 195 ILA=1,LA
195   AWAY(ILA)=0.
      DO 200  ID=1,LD
      DO 200 ILA=1,LA
200   AWAY(ILA)=AWAY(ILA)+REL(ID,ILA)**2
      DO 210 ILA=1,LA
      IAWAY(ILA)=1+INT ( SQRT(AWAY(ILA)) / BMAX * REAL(NBOX-1) )
210   IAWAY(ILA)=MIN0(NBOX,IAWAY(ILA))
      DO 220 ILA=1,LA
220   BOX(IAWAY(ILA))=BOX(IAWAY(ILA))+1.
C
      CALL SCOPY ( LD*LA , PO(1,1) , 1 , DOUBLE     , 1 )
      CALL SCOPY ( LD*LA , PO(1,1) , 1 , DOUBLE(1,LA+1) , 1 )
      CORP = SDOT ( LD*LA , DOUBLE , 1 , DOUBLE (1,1+(LH*LP)/2) , 1)
      CORH = SDOT ( LD*LA , DOUBLE , 1 , DOUBLE (1,1+LH/2) , 1)
      CORD = SDOT ( LD*LA , DOUBLE , 1 , DOUBLE (1,1+(LH*LP)/2+LH/2), 1)
      CORD = CORD / LA
      CORH = CORH / LA
      CORP = CORP / LA
      DO 310 ID=1,LD
      CORP =  CORP - RQMO (ID) - RMO (ID)**2
      CORD =  CORD - RQMO (ID) - RMO (ID)**2
310   CORH =  CORH - RQMO (ID) - RMO (ID)**2
      RETURN
      END

