#include "strings.h"

/* Where to break the line in the output file */
#define NBREAK 8

extern FILE *out;

read_aves(mes_done)
int *mes_done;
{
    char filename[100];
    FILE *in;

    if(lambdaE == 0.0)
	sprintf(filename, "N%d/avesA%4.3f_%d", nnode, lambdaA, dim);
    else
	sprintf(filename, "N%d/avesE%4.3f_%d", nnode, lambdaE, dim);

    printf("Reading aves from %s\n", filename);
    if((in = fopen(filename, "r")) == (FILE *)NULL){
        printf("Cannot open aves %s\n", filename);
	exit(0);
    } else {
#ifdef CUBIX
	fmulti(in);
#endif
	fread(mes_done, sizeof(int), 1, in); 
	fread(tot_ave, sizeof(double), NOBS+2, in); 
	fread(tot_ave2, sizeof(double), NOBS+2, in); 
	fclose(in);
    }
    printf("Sweeps so far %d\n", *mes_done);
    fflush(stdout);
}


write_aves(mes_done)
int *mes_done;
{
	char filename[100];
	FILE *waves;

	if(lambdaE == 0.0)
	    sprintf(filename, "N%d/avesA%4.3f_%d", nnode, lambdaA, dim);
	else
	    sprintf(filename, "N%d/avesE%4.3f_%d", nnode, lambdaE, dim);

#ifdef DEBUG
	printf("Writing aves to %s\n", filename);
#endif DEBUG
	if((waves = fopen(filename, "w")) == NULL){
	    perror(filename);
	    return;
	} 
#ifdef CUBIX
	fsingl(waves);
#endif CUBIX
	fwrite(mes_done, sizeof(int), 1, waves); 
	fflush(waves);
#ifdef CUBIX
	fmulti(waves);
#endif CUBIX
	fwrite(tot_ave, sizeof(double), NOBS+2, waves); 
	fflush(waves);
	fwrite(tot_ave2, sizeof(double), NOBS+2, waves); 
	fflush(waves);
	fclose(waves);
}


outfile()
{
	char filename[100];

	if(out != NULL)
		fclose(out);

	if(lambdaE == 0.0)
		sprintf(filename, "N%d/A%4.3f_%d", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/E%4.3f_%d", nnode, lambdaE, dim);

	/*
	printf("Sending data to %s\n", filename);
	*/

	if((out = fopen(filename, "w")) == NULL){
		perror(filename);
	}
#ifdef CUBIX
	fmulti(out);
#endif
}


print_data(data)
double data[NOBS+2];
{
   float temp[NOBS+2];
   int i;

   for(i=0; i<NOBS+2; i++) {
      temp[i] = data[i];
   }
   if (binary) {
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
      _ex_swaw(temp,temp,data_bytes);
#endif
#endif CUBIX
      fwrite(data, sizeof(float), NOBS+2, fdata); 
      fflush(fdata);
   }
   else {
      for(i=0; i<NBREAK; i++) {
         fprintf(fdata, "%f ", temp[i]);
      }
      fprintf(fdata, "\n");
      for(i=NBREAK; i<NOBS+2; i++) {
         fprintf(fdata, "%f ", temp[i]);
      }
      fprintf(fdata, "\n");
      fflush(fdata);
   }
}


ascii_print_action()
{
	int i;
	if (nnn == 1) avg_measure(act, act2);
#ifdef CUBIX
	fmulti(stdout);
#endif CUBIX
	printf("Proc %d (%d):\n",procnum,nnn);

#ifdef OLD
	metro_success = tot_ave[NOBS]/nnn;
	flip_success = tot_ave[NOBS+1]/nnn;
	printf("%10.5f %10.5f %10.5f\n\n", 
	       metro_success, flip_success, AVENNEIGH/nnn);

       	printf("bin averages: \n");
	printf("%10.5f %10.5f ",  BINGAUSS, BINLN_W);
	printf("%10.5f %10.5f\n", BINAREA_EX, BINEDGE_CURVE);
	printf("%10.5f %10.5f ",  BINX2,BINGAUSS_CURVE);
	printf("%10.5f %10.5f\n", BININTR_CURVE, BINDIFF_CURVE);
        printf("%10.5f %10.5f ",  BINGAUSS_2CURVE, BININTR_2CURVE);
    	printf("%10.5f %10.5f\n", BINPROD_CURVE, BINCORR_CURVE );
    	printf("\n");
	printf("%10.5f %10.5f ",  BINGAUSS2, BINLN_W2);
	printf("%10.5f %10.5f\n", BINAREA_EX2, BINEDGE_CURVE2);
        printf("%10.5f %10.5f ",  BINX22, BINGAUSS_CURVE2);
	printf("%10.5f %10.5f\n", BININTR_CURVE2, BINDIFF_CURVE2);
        printf("%10.5f %10.5f ",  BINGAUSS_2CURVE2, BININTR_2CURVE2);
    	printf("%10.5f %10.5f\n", BINPROD_CURVE2, BINCORR_CURVE2);
    	printf("\n");

        printf("total averages: \n");
	printf("%10.5f %10.5f ",  AVEGAUSS/nnn, AVELN_W/nnn);
	printf("%10.5f %10.5f\n", AVEAREA_EX/nnn, AVEEDGE_CURVE/nnn);
	printf("%10.5f %10.5f ",  AVEX2/nnn,AVEGAUSS_CURVE/nnn);
	printf("%10.5f %10.5f\n", AVEINTR_CURVE/nnn, AVEDIFF_CURVE/nnn);
        printf("%10.5f %10.5f ",  AVEGAUSS_2CURVE/nnn, AVEINTR_2CURVE/nnn); 
        printf("%10.5f %10.5f\n", AVEPROD_CURVE/nnn, AVECORR_CURVE/nnn);
    	printf("\n");
	printf("%10.5f %10.5f ",  AVEGAUSS2/nnn, AVELN_W2/nnn);
	printf("%10.5f %10.5f\n", AVEAREA_EX2/nnn, AVEEDGE_CURVE2/nnn);
	printf("%10.5f %10.5f ",  AVEX22/nnn,AVEGAUSS_CURVE2/nnn);
	printf("%10.5f %10.5f\n", AVEINTR_CURVE2/nnn, AVEDIFF_CURVE2/nnn);
        printf("%10.5f %10.5f ",  AVEGAUSS_2CURVE2/nnn, AVEINTR_2CURVE2/nnn);
    	printf("%10.5f %10.5f\n", AVEPROD_CURVE2/nnn, AVECORR_CURVE2/nnn);
    	printf("\n");
#endif OLD

      for(i=0; i<NOBS+2; i++) {
         printf("%10.5f %10.5f %10.5f %10.5f\n", 
		tot_ave[i]/nnn,tot_ave2[i]/nnn,bin_ave[i],bin_ave2[i]);
      }
      printf("\n");

	fflush(stdout);
#ifdef CUBIX
	fsingl(stdout);
#endif
}


binary_print_action()
{
/*
file out contains records with fields: TOT AVE
	0. Gaussian action
	1. Log W
	2. Area curvature
	3. Edge Curvature
	4. x2
	5. Maximum # neighbors
	6. metropolis success rate
	7. flip success rate
	+ squares of all these
*/
	float temp[NOBS+2];
	char *ptr;
	int i;
	long itemp;
	if(out == NULL)
		return;

	/* close and open file - i.e. rewind */
	outfile();

	/* write number of processors i.e. bins */
	if(procnum == 0) {
		itemp = nproc;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(&itemp,&itemp,4);
#endif
#endif
		fwrite(&itemp, sizeof(long), 1, out); 
	}

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave2[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 
	fflush(out);
}


void _ex_swaw(from, to, N)
    char *from, *to;
    int N;
{
    char q[4];
    int i;
	
    for(i=0 ; i<N/4 ; i++) {
	q[0] = *(from+3); q[1] = *(from+2);  q[2] = *(from+1); q[3] = *from;
	memcpy(to, q, 4);
	from += 4;
	to += 4;
    }
}

