#include "strings.h"


NODEPTR metro_victim;

NODEPTR A, B, C, D;
ELMTPTR ABC, ACD;

struct user_node oldnode;
struct user_elmt oldelmtbuf[MAXNEIGH];
struct user_node oldnodebuf[MAXNEIGH];

extern float pranf();
#define RAN  pranf()


double metro_move()
{
	NODEPTR node;
	double newr[MAXDIM];
	double metro_delta();
	double dact;
	int idim, try=0, succeed=0;

	FORALLNODES(node)
		for(idim=0; idim<dim; idim++)
			newr[idim] = node->user->r[idim] + hit_size*(RAN-0.5);

		dact = metro_delta(node, newr);
		try++;
		if(dact < 0.0 || exp(-dact) > RAN){
			tot_action += dact;
			metro_accept();
			succeed++;
		} else
			metro_reject();
	NEXTNODE(node)
	return((double)succeed/try);
}


double flip_move()
{
	ELMTPTR elmt;
	int i, try=0, succeed=0;
	double flip_delta();
	double dact;

	FORALLELMTS(elmt)
		i = 3*RAN;
		dact = flip_delta(elmt, i);
		try++;
/*
printf("||| %f  :   ",dact);
*/
		if(dact > 1.e20)
			continue;
		if(dact < 0.0 || exp(-dact) > RAN){
			tot_action += dact; 
			flip_accept();
			succeed++;
		} else 
			flip_reject();
	NEXTELMT(elmt)
	return((double)succeed/try);
}


double metro_delta(node, newr)
NODEPTR node;
double newr[MAXDIM];
{
   ELMTPTR elmt;
   NODEPTR noden;
   int i, idim, ineigh;
   double gaussdiff, areadiff, edgediff;
/*
   	Copy existing node, neignbor elmts and neighbor nodes
   	into temporary storage.
*/
   metro_victim = node;
   oldnode = *(node->user);
   ineigh = 0;
   FORALLNEIGH(node, elmt)
   	oldelmtbuf[ineigh] = *(elmt->user);
   	i = (indexc(elmt, node) + 1)%3;
   	oldnodebuf[ineigh] = *(elmt->neigh[i]->user);
   	ineigh++;
   NEXTNEIGH(node, elmt)
/*
   	Copy proposed coordinates of victim node into
   	existing structure.
*/
   for(idim=0; idim<dim; idim++){
   	node->user->r[idim] = newr[idim];
   }
/*
   	Get new data for neighboring elmts and nodes
*/
   FORALLNEIGH(node, elmt)
   	get_elmt_data(elmt);

   NEXTNEIGH(node, elmt)
   get_node_data(node);
   FORALLNEIGH(node, elmt)
   	i = (indexc(elmt, node) + 1)%3;
   	noden = elmt->neigh[i];
   	get_node_data(noden);
   NEXTNEIGH(node, elmt)
/*
     	Calculate differences from current (proposed) configuration
   	from stored (old) configuration;
*/
   ineigh = 0;
   gaussdiff = node->user->gauss_action - oldnode.gauss_action;
   areadiff = node->user->area_action - oldnode.area_action;
   edgediff = node->user->edge_action - oldnode.edge_action;
   FORALLNEIGH(node, elmt)
      i = (indexc(elmt, node) + 1)%3;
      noden = elmt->neigh[i];
      gaussdiff += noden->user->gauss_action - oldnodebuf[ineigh].gauss_action;
      areadiff += noden->user->area_action - oldnodebuf[ineigh].area_action;
      edgediff += noden->user->edge_action - oldnodebuf[ineigh].edge_action;
      ineigh++;
   NEXTNEIGH(node, elmt)

   return( gaussdiff + lambdaA*areadiff + lambdaE*edgediff);
}


metro_accept()
{
}


metro_reject()
{
	NODEPTR node;
	ELMTPTR elmt;
	int ineigh, i;

	node = metro_victim;
	*(node->user) = oldnode;
	ineigh = 0;
	FORALLNEIGH(node, elmt)
		*(elmt->user) = oldelmtbuf[ineigh];
		i = (indexc(elmt, node) + 1)%3;
		*(elmt->neigh[i]->user) = oldnodebuf[ineigh];
		ineigh++;
	NEXTNEIGH(node, elmt)
}


double flip_delta(elmt, i)
ELMTPTR elmt;
int i;
{
	NODENEIGHPTR indexnn(), remove();
	double gaussdiff, areadiff, edgediff, lnwdiff;

	ABC = elmt;
	B = ABC->neigh[i];
	C = ABC->neigh[(i+1)%3];
	A = ABC->neigh[(i+2)%3];

	ACD = indexnn(A, ABC)->next->elmt;
	D = ACD->neigh[(indexc(ACD, A) + 2)%3];

	if(A->user->nneigh <= 3 || C->user->nneigh <= 3
		|| B->user->nneigh >= MAXNEIGH || D->user->nneigh >= MAXNEIGH
		|| connected(B, D))
			return(LARGE);

	oldelmtbuf[0] = *(ABC->user);
	oldelmtbuf[1] = *(ACD->user);
	oldnodebuf[0] = *(A->user);
	oldnodebuf[1] = *(B->user);
	oldnodebuf[2] = *(C->user);
	oldnodebuf[3] = *(D->user);

	ABC->neigh[indexc(ABC, A)] = D;
	ACD->neigh[indexc(ACD, C)] = B;	
	insert(B, ABC, remove(C, ACD), ACD);
	insert(D, ACD, remove(A, ABC), ABC);

	get_elmt_data(ABC);
	get_elmt_data(ACD);
	get_node_data(A);
	get_node_data(B);
	get_node_data(C);
	get_node_data(D);

	gaussdiff = A->user->gauss_action - oldnodebuf[0].gauss_action;
	areadiff = A->user->area_action - oldnodebuf[0].area_action;
	edgediff = A->user->edge_action - oldnodebuf[0].edge_action;
	lnwdiff = log((double)A->user->nneigh/oldnodebuf[0].nneigh);

	gaussdiff += B->user->gauss_action - oldnodebuf[1].gauss_action;
	areadiff += B->user->area_action - oldnodebuf[1].area_action;
	edgediff += B->user->edge_action - oldnodebuf[1].edge_action;
	lnwdiff += log((double)B->user->nneigh/oldnodebuf[1].nneigh);

	gaussdiff += C->user->gauss_action - oldnodebuf[2].gauss_action;
	areadiff += C->user->area_action - oldnodebuf[2].area_action;
	edgediff += C->user->edge_action - oldnodebuf[2].edge_action;
	lnwdiff += log((double)C->user->nneigh/oldnodebuf[2].nneigh);

	gaussdiff += D->user->gauss_action - oldnodebuf[3].gauss_action;
	areadiff += D->user->area_action - oldnodebuf[3].area_action;
	edgediff += D->user->edge_action - oldnodebuf[3].edge_action;
	lnwdiff += log((double)D->user->nneigh/oldnodebuf[3].nneigh);

/*
printf(">>> %f %f %f %f  :   ",
       gaussdiff, 0.5*dim*lnwdiff, lambdaA*areadiff, lambdaE*edgediff);
*/
#ifdef ALPHA
   return(gaussdiff - alpha*lnwdiff + lambdaA*areadiff + lambdaE*edgediff);
#endif ALPHA
#ifdef SIGNBUG
   return(gaussdiff + 0.5*dim*lnwdiff + lambdaA*areadiff + lambdaE*edgediff);
#else
   return(gaussdiff - 0.5*dim*lnwdiff + lambdaA*areadiff + lambdaE*edgediff);
#endif SIGNBUG

}


flip_accept()
{
}


flip_reject()
{
	NODENEIGHPTR indexnn(), remove();
	int i;

	ABC->neigh[indexc(ABC, D)] = A;
	ACD->neigh[indexc(ACD, B)] = C;	
	insert_before(C, ABC, remove(B, ACD), ACD);
	insert_before(A, ACD, remove(D, ABC), ABC);

	*(ABC->user) = oldelmtbuf[0];
	*(ACD->user) = oldelmtbuf[1];
	*(A->user) = oldnodebuf[0];
	*(B->user) = oldnodebuf[1];
	*(C->user) = oldnodebuf[2];
	*(D->user) = oldnodebuf[3];
}

