#include "strings.h"
#include <stdio.h>

extern FILE *out;

read_aves(mes_done)
int *mes_done;
{
    char filename[100];
    FILE *in;

    if(lambdaE == 0.0)
	sprintf(filename, "N%d/avesA%4.3f_%d", nnode, lambdaA, dim);
    else
	sprintf(filename, "N%d/avesE%4.3f_%d", nnode, lambdaE, dim);

    printf("Reading aves from %s\n", filename);
    if((in = fopen(filename, "r")) == (FILE *)NULL){
        printf("Cannot open aves %s\n", filename);
	exit(0);
    } else {
#ifdef CUBIX
	fmulti(in);
#endif
	fread(mes_done, sizeof(int), 1, in); 
	fread(tot_ave, sizeof(double), NOBS+2, in); 
	fread(tot_ave2, sizeof(double), NOBS+2, in); 
	fclose(in);
    }
    printf("Sweeps so far %d\n", *mes_done);
    fflush(stdout);
}


write_aves(mes_done)
int *mes_done;
{
	char filename[100];
	FILE *write;

	if(lambdaE == 0.0)
	    sprintf(filename, "N%d/avesA%4.3f_%d", nnode, lambdaA, dim);
	else
	    sprintf(filename, "N%d/avesE%4.3f_%d", nnode, lambdaE, dim);

#ifdef DEBUG
	printf("Writing aves to %s\n", filename);
#endif DEBUG
	if((write = fopen(filename, "w")) == NULL){
	    perror(filename);
	    return;
	} else {
#ifdef CUBIX
	    fmulti(write);
#endif
	    fwrite(mes_done, sizeof(int), 1, write); 
	    fflush(write);
	    fwrite(tot_ave, sizeof(double), NOBS+2, write); 
	    fflush(write);
	    fwrite(tot_ave2, sizeof(double), NOBS+2, write); 
	    fclose(write);
	}
}


outfile()
{
	char filename[100];

	if(out != NULL)
		fclose(out);

	if(lambdaE == 0.0)
		sprintf(filename, "N%d/A%4.3f_%d", nnode, lambdaA, dim);
	else
		sprintf(filename, "N%d/E%4.3f_%d", nnode, lambdaE, dim);

	/*
	printf("Sending data to %s\n", filename);
	*/

	if((out = fopen(filename, "w")) == NULL){
		perror(filename);
	}
#ifdef CUBIX
	fmulti(out);
#endif
}


print_data(data)
double data[NOBS+2];
{
   float temp[NOBS+2];
   int i;

   for(i=0; i<NOBS+2; i++) {
      temp[i] = data[i];
   }
   if (binary) {
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
      _ex_swaw(temp,temp,data_bytes);
#endif
#endif CUBIX
      fwrite(data, sizeof(float), NOBS+2, fdata); 
      fflush(fdata);
   }
   else {
      for(i=0; i<NOBS+2; i++) {
         fprintf(fdata, "%f ", temp[i]);
      }
      fprintf(fdata, "\n");
      fflush(fdata);
   }
}


ascii_print_action()
{
	int i;
	if (nnn == 1) avg_measure(act, act2);
#ifdef CUBIX
	fmulti(stdout);
#endif
	printf("Proc %d (%d):\n",procnum,nnn);
	/*
	printf("%10.5f %10.5f\n", GAUSS, LN_W);
	printf("%10.5f %10.5f\n", AREA_CURVE, EDGE_CURVE);
	printf("%10.5f\n", X2);
	printf("%10.5f %10.5f\n", metro_success, flip_success);
	printf("%10.5f\n", NNEIGH);
	printf("%10.5f\n", 
#ifdef ALPHA
		GAUSS - alpha*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
#endif ALPHA
#ifdef SIGNBUG
		GAUSS + 0.5*dim*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
#else
		GAUSS - 0.5*dim*LN_W + lambdaA*AREA_CURVE + lambdaE*EDGE_CURVE);
#endif SIGNBUG
	printf("%10.5f %10.5f\n", GAUSS2, LN_W2);
	printf("%10.5f %10.5f\n", AREA_CURVE2, EDGE_CURVE2);
	printf("%10.5f\n", X22);
	*/

	printf("%10.3f %10.3f\n", BINGAUSS, BINLN_W);
	printf("%10.3f %10.3f\n", BINAREA_CURVE, BINEDGE_CURVE);
	printf("%10.3f\n", BINX2);
	printf("%10.3f %10.3f\n", BINGAUSS2, BINLN_W2);
	printf("%10.3f %10.3f\n", BINAREA_CURVE2, BINEDGE_CURVE2);
	printf("%10.3f\n", BINX22);

	printf("%10.3f %10.3f\n", AVEGAUSS/nnn, AVELN_W/nnn);
	printf("%10.3f %10.3f\n", AVEAREA_CURVE/nnn, AVEEDGE_CURVE/nnn);
	printf("%10.3f\n", AVEX2/nnn);
	printf("%10.3f %10.3f\n", AVEGAUSS2/nnn, AVELN_W2/nnn);
	printf("%10.3f %10.3f\n", AVEAREA_CURVE2/nnn, AVEEDGE_CURVE2/nnn);
	printf("%10.3f\n\n", AVEX22/nnn);
	fflush(stdout);
#ifdef CUBIX
	fsingl(stdout);
#endif
}


binary_print_action()
{
/*
file out contains records with fields: TOT AVE
	0. Gaussian action
	1. Log W
	2. Area curvature
	3. Edge Curvature
	4. x2
	5. Maximum # neighbors
	6. metropolis success rate
	7. flip success rate
	+ squares of all these
*/
	float temp[NOBS+2];
	char *ptr;
	int i;
	long itemp;
	if(out == NULL)
		return;

	/* close and open file - i.e. rewind */
	outfile();

	/* write number of processors i.e. bins */
	if(procnum == 0) {
		itemp = nproc;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(&itemp,&itemp,4);
#endif
#endif
		fwrite(&itemp, sizeof(long), 1, out); 
	}

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 

	for(i=0; i<NOBS+2; i++)
		temp[i] = tot_ave2[i]/nnn;
#ifdef CUBIX /* swap the f**king bytes */
#ifndef A2010 /* not on Ametek */
	_ex_swaw(temp,temp,(NOBS+2)*4);
#endif
#endif
	fwrite(temp, sizeof(float), NOBS+2, out); 
	fflush(out);
}


void _ex_swaw(from, to, N)
    char *from, *to;
    int N;
{
    char q[4];
    int i;
	
    for(i=0 ; i<N/4 ; i++) {
	q[0] = *(from+3); q[1] = *(from+2);  q[2] = *(from+1); q[3] = *from;
	memcpy(to, q, 4);
	from += 4;
	to += 4;
    }
}

